;; NOTES: 
;; dt = 1
;; latest update: February 16, 2007

globals
[
  ;;;NetLogo parameters
  adjusted-observed-river-flow-year-set 
  cattle-parameters-data-set
  cattle-parameters-input-file-name
  daily-rain-data-set
  daily-rain-input-file-name-set
  daily-rain-year-set
  day
  dynamic-subcathment-properties-data-set
  dynamic-subcathment-properties-input-file-name-set
  dynamic-subcathment-properties-year-set
  generated-dynamic-subcathment-properties-data-set-for-simulation
  generated-dynamic-subcathment-properties-data-set-for-warm-up
  input-file-name-data
  lake-parameters-data-set
  lake-parameters-input-file-name
  luc-fraction-data-set
  luc-fraction-input-file-name-set
  luc-fraction-year-set
  luc-number
  max-daily-rain-data-set
  mean-monthly-rain-data-set
  min-daily-rain-data-set
  monthly-evapotranspiration-data-set
  monthly-evapotranspiration-input-file-name
  monthly-relative-evapotranspiration-data-set  
  monthly-relative-evapotranspiration-input-file-name
  observation-point-number
  observed-river-flow-data-set
  observed-river-flow-input-file-name
  observed-river-flow-year-set
  output-file-name
  p-monthly-wet-days-data-set
  rain-parameters-data-set
  rain-parameters-input-file-name
  repeating-header
  reservoir-use-fraction-data-set
  reservoir-use-fraction-input-file-name-set
  reservoir-use-fraction-year-set
  river-parameters-data-set
  river-parameters-input-file-name
  routing-distance-input-file-name
  scenario-file-name
  sd-monthly-rain-data-set
  setup-done-code
  sim-day
  sim-year
  soil-parameters-data-set
  soil-parameters-input-file-name
  static-luc-properties-data-set
  static-luc-properties-input-file-name
  static-subcathment-properties-data-set
  static-subcathment-properties-input-file-name
  subcatchment-number
  under-development
  year
  
  ;;;STELLA parameters  
  C_CattleSale ;;non-arrays
  C_DailyIntake ;;non-arrays
  C_DailyTramplingFrac ;;non-arrays 
  C_DeathRate ;;non-arrays
  C_Destocking ;;non-arrays
  C_NutritionMortalityThreshold ;;non-arrays
  C_RelNutrition ;;non-arrays
  C_Stocking ;;non-arrays
  C_StockingRate ;;non-arrays
  C_TramplingCompactionPatch ;;2-D; subcatchment, luc-type  
  D_ActETPatch ;;2-D: subcatchment, luc-type
  D_AtmWaterPatch ;; 2D: subcatchment,luc type
  D_CumRiverFlowObs ;; 2D: subcatchment, observation point
  D_DeepInfiltrationSub ;;1-D: subcatchment  
  D_DelayRiverFlowObs ;;2-D: subcatchment, observation point
  D_DelaySurfaceFlowObs ;;2-D: subcatchment, observation point
  D_DelaySurfaceFlowToRiverObs ;;2-D: subcatchment, observation point
  D_DelaySurfaceFlowToRiverObs_DailySet ;;3-D: subcatchment, observation point, day
  D_DirectRiverFlowObs ;;2-D: subcatchment, observation point
  D_DirectSurfaceFlowObs ;;2-D: subcatchment, observation point
  D_FeedingIntoLakeSub? ;;1-D: subcatchment
  D_GWDischargeSub ;;1-D: subcatchment
  D_GWFracToLakeSub ;;1-D: subcatchment
  D_GWLakeObs ;;2-D: subcatchment, observation point
  D_GWSub ;; 1D: subcatchment  
  D_GWToLakeObs ;;1-D: observation point  
  ;;Modified
  ;;xxx
  D_GWUtilizationFractionPatch ;;1-D: subcatchment
  D_GWUtilizedPatch? ;;2-D: subcatchment, luc-type
  D_InfiltrationPatch ;;2-D: subcatchment, luc-type
  D_InterceptDripRate ;;non-arrays
  D_InterceptDurationSub ;;1-D: subcatchment
  D_InterceptPatch ;;2-D: subcatchment, luc-type
  D_MaxInterceptDripDuration;;non-arrays
  D_MaxReservoirVolSub ;;1-D: subcatchment
  D_PercolationPatch ;;2-D: subcatchment, luc-type
  D_RelAvailWaterPatch ;;2-D: subcatchment, luc-type
  D_ReservoirEvapSub ;;1-D: subcatchment
  D_ReservoirInflowSub ;;1-D: subcatchment
  D_ReservoirOutflowSub ;;1-D: subcatchment
  D_ReservoirUseFracSub ;;1-D: subcatchment
  D_ReservoirUseFracSub_Simulation ;;3-D: subcatchment, year, day
  D_ReservoirUseFracSub_WarmUp ;;3-D: subcatchment, year, day
  D_ReservoirVolSub ;; 1D: subcatchment 
  D_RiverFlowToLakeObs ;;1-D: observation point
  D_RiverInflowToLakeObs ;;2-D: subcatchment, observation point
  D_RiverToLakeSameDayObs ;;2-D: subcatchment, observation point
  D_RoutingTimeObs ;;2-D: subcatchment, observation point
  D_SoilDischargePatch ;;2-D: subcatchment, luc-type
  D_SoilWaterPatch ;; 2D: subcatchment,luc type      
  D_SurfaceFlowSub ;;1-D: subcatchment
  D_TotalDelayRiverFlowObs ;; 2D: subcatchment, observation point
  D_TotalStreamInflowSub ;;1-D: subcatchment
  G_DecayManureIncorportionPatch ;;2-D; subcatchment, luc-type
  G_DecaySurfaceLitterIncorporationPatch ;;2-D; subcatchment, luc-type
  G_FaecesProductionPatch ;;2-D; subcatchment, luc-type
  G_GrassBiomassPatch ;;2-D: subcatchment, luc type
  G_GrassCatch ;;non-arrays  
  G_GrassLitterConverter ;;non-arrays
  G_GrassMortalityFrac ;;non-arrays
  G_GrazingManureConverter ;;non-arrays  
  G_GrazingPatch ;;2-D; subcatchment, luc-type
  G_GrowthRatePatch ;;2-D; subcatchment, luc-type
  G_LeafMortalityPatch ;;2-D; subcatchment, luc-type
  G_LitterDepositionPatch ;;2-D; subcatchment, luc-type
  G_SurfaceCoverPatch ;;2-D; subcatchment, luc-type
  G_SurfaceLitterDecayFrac ;;non-arrays
  G_SurfaceLitterPatch ;;2-D: subcatchment, luc type
  G_SurfaceManurePatch ;;2-D: subcatchment, luc type
  G_SurfaceManurePatchDecayFrac ;;non-arrays
  G_TramplingMultiplier ;;non-arrays
  G_WUE ;;non-arrays
  I_AreaSub ;;1-D: subcatchment
  I_AvailWaterPatch ;;2-D: subcatchment, luc-type
  I_AvailWaterSub ;;1-D: subcatchment
  I_AvailWaterSub_Simulation ;;2-D: subcatchment, year
  I_AvailWaterSub_WarmUp ;;2-D: subcatchment, year
  I_BD_BDRefSub ;;1-D: subcatchment
  I_BD_BDRefSub_Simulation ;;2-D: subcatchment, year
  I_BD_BDRefSub_WarmUp ;;2-D: subcatchment, year
  I_ContributoryArea ;;1-D: observation point  
  I_DailyRainPatch ;;2-D: subcatchment, luc type
  I_DailyRainSub ;;1-D: subcatchment
  I_DailyRainSub_Simulation ;;3-D: subcatchment, year, day
  I_DailyRainSub_WarmUp ;;3-D: subcatchment, year, day
  I_DamHereSub? ;;1-D: subcatchment
  I_ET ;;non-arrays
  I_ET_DailySet ;;1-D: day
  I_GrassFracBiomassLUC ;;1-D: luc type
  I_GWRelFracSub ;;1-D: subcatchment
  I_GWRelFracSub_Simulation ;;2-D: subcatchment, year
  I_GWRelFracSub_WarmUp ;;2-D: subcatchment, year
  I_InfiltrationDurationSub ;;1-D: subcatchment
  I_InitRelGW ;;non-arrays
  I_InitRelSoil ;;non-arrays
  I_InterceptCapacityPatch ;;2-D: subcatchment, luc-type
  I_InterceptionEffectOnTranspiration ;;non-arrays
  I_InterceptLUC ;;1-D: luc type
  I_LakeTranspirationMultiplier ;;non-arrays
  I_MaxDynGWSub ;;1-D: subcatchment
  I_MaxDynGWSub_Simulation ;;2-D: subcatchment, year
  I_MaxDynGWSub_WarmUp ;;2-D: subcatchment, year
  I_MaxInfiltration ;;non-arrays
  I_MaxInfiltrationPatch ;;2-D: subcatchment, luc-type
  I_MaxInfiltrationSubSoil ;;non-arrays
  I_MaxInfiltrationSubSoilPatch ;;2-D: subcatchment, luc-type
  I_MeasuredDebit_m3_per_sec ;;1-D: subcatchment
  I_MeasuredDebit_mm_per_day ;;1-D: observation point
  I_ObserveAllSubcatchmentsObs? ;;1-D: observation point
  I_PercolationFraction ;;non-arrays
  I_PETPatch ;;2-D: subcatchment, luc-type
  I_PWPSub ;;1-D: subcatchment  
  I_PWPSub_Simulation ;;2-D: subcatchment, year
  I_PWPSub_WarmUp ;;2-D: subcatchment, year
  I_Rain_GenSeed ;;non-arrays
  I_Rain_IntensityCV ;;non-arrays
  I_Rain_IntensityMax ;;non-arrays
  I_Rain_IntensityMean  ;;non-arrays
  I_Rain_IntensityMin ;;non-arrays
  I_RainDurationSub ;;1-D: subcatchment
  I_RainIntensitySub ;;1-D: subcatchment
  I_RainMultiplier ;;non-arrays
  I_RelAreaPatch ;;2-D: subcatchment, luc type
  I_RelAreaPatch_Simulation ;;3-D: subcatchment, year, luc type
  I_RelAreaPatch_WarmUp ;;3-D: subcatchment, year, luc type
  I_RelAreaSub ;;1-D: subcatchment
  I_RelAreaSubObs ;;2-D: subcatchment, observation point
  I_RelDroughtLUC ;;1-D: luc type
  I_RelETLUC ;;1-D: luc type
  I_RelETLUC_DailySet ;;2-D: luc type, day
  I_RelFracObs ;;2-D: subcatchment, observation point
  I_ReservoirDepth ;;non-arrays
  I_RiverFlowDispersalFactor ;;non-arrays
  I_RiverFlowTimeSub ;;1-D: subcatchment
  I_RiverFlowTimeSub_Simulation ;;2-D: subcatchment, year
  I_RiverFlowTimeSub_WarmUp ;;2-D: subcatchment, year
  I_RoutingDistanceObs ;;2-D: subcatchment, observation point 
  I_RoutingVelocity_m_per_s ;;non-arrays 
  I_Simulation_Time ;;non-arrays  
  I_SoilFieldCapacitySub ;;1-D: subcatchment
  I_SoilFieldCapacitySub_Simulation ;;2-D: subcatchment, year
  I_SoilFieldCapacitySub_WarmUp ;;2-D: subcatchment, year
  I_SoilSaturationPatch ;;2-D: subcatchment, luc-type
  I_Tortuosity ;;non-arrays  
  L_CumEvapLake ;;non-arrays
  L_CumHEPPUse ;;non-arrays
  L_CumRiverOutflow ;;non-arrays
  L_EvapLake ;;non-arrays
  L_FloodingCurrent? ;;non-arrays
  L_FloodTresh ;;non-arrays  
  L_HEPP_kWh ;;non-arrays
  L_HEPP_RelOperationalTime ;;non-arrays
  L_HEPPDailyDemand ;;non-arrays    
  L_HEPPOutflow ;;non-arrays
  L_HEPPWaterUseFlow ;;non-arrays
  L_InflowToLake ;;non-arrays  
  L_LakeAreaSub ;;1-D: subcatchment
  L_LakeBottomElev ;;non-arrays
  L_LakeElevPreHEPP ;;non-arrays
  L_LakeHereSub? ;;1-D: subcatchment
  L_LakeLevel ;;non-arrays
  L_LakeLevelExcess ;;non-arrays
  L_LakeLevelFullHEPP ;;non-arrays
  L_LakeLevelHalfHEPP ;;non-arrays
  L_LakeLevelNoHEPP ;;non-arrays
  L_LakeOverFlow ;;non-arrays
  L_LakeOverFlowFrac ;;non-arrays
  L_LakeElevPostHEPP ;;non-arrays
  L_LakeTranspirationSub ;;1-D: subcatchment
  L_LakeVol ;;non-arrays
  L_m3_per_kWh ;;non-arrays
  L_OutflowTresholdVolPostHEPP ;;non-arrays
  L_OutflowTresholdVolPreHEPP ;;non-arrays
  L_QHEPP_m3_per_sec ;;non-arrays
  L_QSanitaryFlow_m3_per_sec ;;non-arrays
  L_RiverOutflow ;;non-arrays  
  L_SanitaryFlow ;;non-arrays
  O_BalanceCatch ;;non-arrays
  O_CumDebitCatch ;;non-arrays
  O_CumDeepInfiltrationCatch ;;non-arrays
  O_CumETCatch ;;non-arrays
  O_CumGWCatch ;;non-arrays
  O_CumGWDischargeCatch ;;non-arrays
  O_CumInfiltrationCatch ;;non-arrays
  O_CumInterceptCatch ;;non-arrays
  O_CumPercolationCatch ;;non-arrays
  O_CumRainCatch ;;non-arrays
  O_CumSimulatedDebit ;;1-D: observation point
  O_CumSoilDischargeCatch ;;non-arrays
  O_CumSoilWaterCatch ;;non-arrays 
  O_CumSurfaceFlowCatch ;;non-arrays
  O_CumHEPP_kWh ;;non-arrays
  O_DeltaGWCatch ;;non-arrays
  O_DeltaSoilWaterStockCatch ;;non-arrays  
  O_FracBaseFlow ;;non-arrays
  O_FracSoilQuickFlow ;;non-arrays
  O_FracSurfaceQuickFlow ;;non-arrays
  O_RelAvailWaterCatch ;;non-arrays
  O_SimulatedDebit_mm_per_day ;;1-D: observation point
  O_TotalStreamFlowCatch ;;non-arrays
  S_CompactionPatch ;;2-D; subcatchment, luc-type
  S_MaxTrampling;;non-arrays
  S_RainAtSoilSurfacePatch ;;2-D: subcatchment, luc type
  S_RelBDPatch ;;2-D: subcatchment, luc type
  S_RippingSurfacePatch ;;2-D: subcatchment, luc type
  S_SplashErosionPatch ;;2-D; subcatchment, luc-type
  S_StructureFormationPatch ;;2-D; subcatchment, luc-type  
]

to manage-input-file
  set input-file-name-data read-text-file scenario-file-name
end

to-report read-text-file[file-name]
  let data[]
  if (file-name != false)
  [
    file-open file-name
    while [ not file-at-end? ]
    [ 
      set data sentence data file-read
    ]
    file-close
  ]     
  report data
end

to-report read-col-wise-text-file[file-name]
  let data1[]
  let row 0
  if (file-name != false)
  [
    file-open file-name
    while [ not file-at-end? ]
    [ 
      set data1 sentence data1 file-read-line
      set row row + 1
    ]
    file-close
  ]      
  let data2[]
  if (file-name != false)
  [
    file-open file-name
    while [ not file-at-end? ]
    [ 
      set data2 sentence data2 file-read
    ]
    file-close
  ]     
  let col length data2 / row  
  
  let data3[]
  foreach n-values row[?]
  [
    let i ? + (? * (col - 1))
    let j i + col
    set data3 lput (sublist data2 i j) data3
  ]
  report data3
end

to-report read-row-wise-text-file[file-name]
  let data1[]
  let row 0
  if (file-name != false)
  [
    file-open file-name
    while [ not file-at-end? ]
    [ 
      set data1 sentence data1 file-read-line
      set row row + 1
    ]
    file-close
  ]      
  let data2[]
  if (file-name != false)
  [
    file-open file-name
    while [ not file-at-end? ]
    [ 
      set data2 sentence data2 file-read
    ]
    file-close
  ]     
  let col length data2 / row  
  let data3[]
  foreach n-values col[?]
  [
    let x ?
    foreach n-values row[?]
    [ 
      let y ?
      set data3 sentence data3 item (x + (y * col)) data2
    ]
  ]
  let data4[]
  foreach n-values col[?]
  [
    let i ? + (? * (row - 1))
    let j i + row
    set data4 lput (sublist data3 i j) data4
  ]
  report data4
end

to-report read-time-series-data[file-set]
  let data-set[]    
  ifelse ((length file-set) mod 2) = 0
  [
    foreach n-values length file-set[?]
    [
      if (? mod 2) = 0
      [
        set data-set sentence data-set
          (list read-row-wise-text-file item ? file-set 
          read-row-wise-text-file item (? + 1) file-set)
      ] 
    ]
  ]
  [
    foreach n-values ((length file-set) - 1)[?]
    [
      if (? mod 2) = 0
      [
        set data-set sentence data-set
          (list read-row-wise-text-file item ? file-set 
          read-row-wise-text-file item (? + 1) file-set)
      ] 
    ]
    set data-set lput read-row-wise-text-file last file-set data-set       
  ]  
  report data-set
end

to read-daily-rain
  let data-set1 read-time-series-data daily-rain-input-file-name-set
  set daily-rain-data-set[]
  set daily-rain-year-set[]
  foreach n-values length data-set1[?]
  [
    let x ?
    let data-set2[]
    let data-set3[]
    foreach n-values length (item x data-set1)[?]
    [
      let y ?
      set data-set2 lput (bf (item y (item x data-set1))) data-set2
      set data-set3 lput (item 0 (item y (item x data-set1))) data-set3
    ]
    ;;order: subcatchment, year, list of daily rain for 365 days
    set daily-rain-data-set lput data-set2 daily-rain-data-set     
    ;;order: subcatchment, list of year point
    set daily-rain-year-set lput data-set3 daily-rain-year-set
  ]
end

to read-reservoir-use-fraction
  let data-set1 read-time-series-data reservoir-use-fraction-input-file-name-set
  set reservoir-use-fraction-data-set[]
  set reservoir-use-fraction-year-set[]
  foreach n-values length data-set1[?]
  [
    let x ?
    let data-set2[]
    let data-set3[]
    foreach n-values length (item x data-set1)[?]
    [
      let y ?
      set data-set2 lput (bf (item y (item x data-set1))) data-set2
      set data-set3 lput (item 0 (item y (item x data-set1))) data-set3
    ]
    ;;order: subcatchment, year, list of reservoir use fraction for 365 days
    set reservoir-use-fraction-data-set lput data-set2 reservoir-use-fraction-data-set     
    ;;order: subcatchment, list of year point
    set reservoir-use-fraction-year-set lput data-set3 reservoir-use-fraction-year-set
  ]
end

to read-observed-river-flow
  let data-set1 read-time-series-data observed-river-flow-input-file-name
  set observed-river-flow-data-set[]
  set observed-river-flow-year-set[]
  foreach n-values length data-set1[?]
  [
    let x ?
    let data-set2[]
    let data-set3[]
    foreach n-values length (item x data-set1)[?]
    [
      let y ?
      set data-set2 lput (bf (item y (item x data-set1))) data-set2
      set data-set3 lput (item 0 (item y (item x data-set1))) data-set3
    ]
    ;;order: subcatchment, year, list of daily observed-river-flow for 365 days
    set observed-river-flow-data-set lput data-set2 observed-river-flow-data-set     
    ;;order: subcatchment, list of year point
    set observed-river-flow-year-set lput data-set3 observed-river-flow-year-set
  ]
  set observed-river-flow-data-set reduce[sentence ?1 ?2] observed-river-flow-data-set
  set observed-river-flow-year-set reduce[sentence ?1 ?2] observed-river-flow-year-set
end

to read-luc-fraction
  let data-set1 read-time-series-data luc-fraction-input-file-name-set
  set luc-fraction-data-set[]
  set luc-fraction-year-set[]
  foreach n-values length data-set1[?]
  [
    let x ?
    let data-set2[]
    let data-set3[]
    foreach n-values length (item x data-set1)[?]
    [
      let y ?
      set data-set2 lput (bf (item y (item x data-set1))) data-set2
      set data-set3 lput (item 0 (item y (item x data-set1))) data-set3
    ]
    ;;order: subcatchment, year, list of luc-type fraction for n classes
    set luc-fraction-data-set lput data-set2 luc-fraction-data-set     
    ;;order: subcatchment, list of year point
    set luc-fraction-year-set lput data-set3 luc-fraction-year-set
  ]
end

to read-dynamic-subcathment-properties
  let data-set1 read-time-series-data dynamic-subcathment-properties-input-file-name-set
  set dynamic-subcathment-properties-data-set[]
  set dynamic-subcathment-properties-year-set[]
  foreach n-values length data-set1[?]
  [
    let x ?
    let data-set2[]
    let data-set3[]
    foreach n-values length (item x data-set1)[?]
    [
      let y ?
      set data-set2 lput (bf (item y (item x data-set1))) data-set2
      set data-set3 lput (item 0 (item y (item x data-set1))) data-set3
    ]
    ;;order: subcatchment, year, list of dynamic properties: 
    ;;item 0: relative flow velocity
    ;;item 1: maximum dynamic groundwater store
    ;;item 2: groundwater release fraction
    ;;item 3: soil quickflow capacity
    ;;item 4: plant available water
    ;;item 5: inaccessible water
    ;;item 6: top soil bd/bdref
    set dynamic-subcathment-properties-data-set lput data-set2 dynamic-subcathment-properties-data-set     
    
    ;;order: subcatchment, list of year point
    set dynamic-subcathment-properties-year-set lput data-set3 dynamic-subcathment-properties-year-set 
  ]
end

;;Modified
;;xxx
to read-static-subcathment-properties
  ;;order: subcatchment, list of static properties: 
  ;;item 0: area (km2)
  ;;item 1: dam in this stream? 
  ;;item 2: feeding into lake?
  ;;item 3: groundwater fraction to lake
  ;;item 4: groundwater utilization fraction
  set static-subcathment-properties-data-set read-col-wise-text-file static-subcathment-properties-input-file-name
  ;;extract the data set
  set I_AreaSub map[item 0 ?] static-subcathment-properties-data-set
  set I_DamHereSub? map[item 1 ? = 1] static-subcathment-properties-data-set  
  set D_FeedingIntoLakeSub? map[item 2 ? = 1] static-subcathment-properties-data-set
  set D_GWFracToLakeSub map[item 3 ?] static-subcathment-properties-data-set  
  set D_GWUtilizationFractionPatch map[item 4 ?] static-subcathment-properties-data-set  
end

;;Modified
;;xxx
to read-groundwater-utilization
  let temp1[]
  foreach n-values luc-number[?]
  [
    let i ?
    set temp1 lput
      (map[item (i + 5) ?] static-subcathment-properties-data-set)
      temp1
  ]
  
  let temp2[]
  foreach n-values subcatchment-number[?]
  [
    let i ?
    set temp2 lput
      (map[item i ? = 1] temp1)
      temp2
  ]
  set D_GWUtilizedPatch? temp2
end

to read-routing-distance
  ;;order: subcatchment, measurement point 
  set I_RoutingDistanceObs read-col-wise-text-file routing-distance-input-file-name
  set observation-point-number mean map[length ?] I_RoutingDistanceObs
  ;;Modified
  ;;xxx
  let temp[]
  foreach n-values observation-point-number[?]
  [
    let i ?
    set temp lput
      map[ifelse-value (item i ? >= 0) [1] [0]] I_RoutingDistanceObs
      temp
  ]
  set I_ObserveAllSubcatchmentsObs? map[mean ? = 1] temp
end

to read-monthly-relative-evapotranspiration
  let data-set1 read-time-series-data monthly-relative-evapotranspiration-input-file-name
  set monthly-relative-evapotranspiration-data-set[]
  foreach n-values length data-set1[?]
  [
    let x ?
    let data-set2[]
    foreach n-values length (item x data-set1)[?]
    [
      let y ?
      set data-set2 lput (item y (item x data-set1)) data-set2
    ]
    set monthly-relative-evapotranspiration-data-set lput data-set2 monthly-relative-evapotranspiration-data-set     
  ]
  ;;order: month, list of relative evapotranspiration by n classes luc-type
  set monthly-relative-evapotranspiration-data-set reduce[sentence ?1 ?2] monthly-relative-evapotranspiration-data-set  
end

to read-static-luc-properties
  let data-set1 read-time-series-data static-luc-properties-input-file-name
  set static-luc-properties-data-set[]
  foreach n-values length data-set1[?]
  [
    let x ?
    let data-set2[]
    foreach n-values length (item x data-set1)[?]
    [
      let y ?
      set data-set2 lput (item y (item x data-set1)) data-set2
    ]
    ;; order: list of static landcover properties:
    ;; item 0: potential interception (mm/day) by n classes luc-type
    ;; item 1: relative drought threshold by n classes luc-type
    ;; item 2: grazable fraction of new growth by n classes luc-type
    set static-luc-properties-data-set lput data-set2 static-luc-properties-data-set     
  ]
  set static-luc-properties-data-set reduce[sentence ?1 ?2] static-luc-properties-data-set
  
  set I_InterceptLUC item 0 static-luc-properties-data-set
  set I_RelDroughtLUC item 1 static-luc-properties-data-set
  set I_GrassFracBiomassLUC item 2 static-luc-properties-data-set
end

to read-monthly-evapotranspiration
  ;;order: month, mean daily evapotranspiration (mm)
  set monthly-evapotranspiration-data-set read-row-wise-text-file monthly-evapotranspiration-input-file-name
  set monthly-evapotranspiration-data-set reduce[sentence ?1 ?2] monthly-evapotranspiration-data-set  
end

to read-lake-parameters
  set lake-parameters-data-set read-row-wise-text-file lake-parameters-input-file-name
  ;;item 0: lake m3_per_kWh
  ;;item 1: lake bottom elevation
  ;;item 2: lake elevation pre HEPP
  ;;item 3: lake elevation post HEPP
  ;;item 4: lake flood treshold
  ;;item 6: HEPP full level
  ;;item 7: HEPP half level
  ;;item 8: HEPP no level
  ;;item 9: lake overflow
  ;;item 10: lake overflow fraction
  ;;item 11: Qmecs HEPP
  ;;item 12: Qmecs for sanitation flow
  ;;item 13: lake transpiration multiplier
  set lake-parameters-data-set reduce[sentence ?1 ?2] lake-parameters-data-set
  
  ;;extract the data set
  set L_m3_per_kWh item 0 lake-parameters-data-set
  set L_LakeBottomElev item 1 lake-parameters-data-set
  set L_LakeElevPreHEPP item 2 lake-parameters-data-set
  set L_LakeElevPostHEPP item 3 lake-parameters-data-set
  set L_FloodTresh item 4 lake-parameters-data-set
  set L_LakeLevelFullHEPP item 5 lake-parameters-data-set
  set L_LakeLevelHalfHEPP item 6 lake-parameters-data-set
  set L_LakeLevelNoHEPP item 7 lake-parameters-data-set
  set L_LakeOverFlow item 8 lake-parameters-data-set
  set L_LakeOverFlowFrac item 9 lake-parameters-data-set
  set L_QHEPP_m3_per_sec item 10 lake-parameters-data-set
  set L_QSanitaryFlow_m3_per_sec item 11 lake-parameters-data-set
  set I_LakeTranspirationMultiplier item 12 lake-parameters-data-set
end

to read-rain-parameters
  set rain-parameters-data-set read-row-wise-text-file rain-parameters-input-file-name
  ;;item 0: interception drip duration
  ;;item 1: interception drip rate
  ;;item 2: rain multiplier
  ;;item 3: interception effect on transpiration
  ;;item 4: cv of rain intensity
  ;;item 5: mean of rain intensity
  ;;item 6: min rain intensity
  ;;item 7: max rain intensity
  ;;item 8: rain random seed
  set rain-parameters-data-set reduce[sentence ?1 ?2] rain-parameters-data-set
  
  ;;extract the data set
  set D_InterceptDripRate item 0 rain-parameters-data-set
  set D_MaxInterceptDripDuration item 1 rain-parameters-data-set
  set I_RainMultiplier item 2 rain-parameters-data-set
  set I_InterceptionEffectOnTranspiration item 3 rain-parameters-data-set
  set I_Rain_IntensityCV item 4 rain-parameters-data-set
  set I_Rain_IntensityMean item 5 rain-parameters-data-set
  set I_Rain_IntensityMin item 6 rain-parameters-data-set
  set I_Rain_IntensityMax item 7 rain-parameters-data-set
  set I_Rain_GenSeed item 8 rain-parameters-data-set
end

to read-river-parameters
  set river-parameters-data-set read-row-wise-text-file river-parameters-input-file-name
  ;;item 0: river flow dispersal factor
  ;;item 1: tortuosity
  ;;item 2: velocity (m/s)
  ;;item 3: reservoir depth
  set river-parameters-data-set reduce[sentence ?1 ?2] river-parameters-data-set
  
  ;;extract the data set
  set I_RiverFlowDispersalFactor item 0 river-parameters-data-set
  set I_Tortuosity item 1 river-parameters-data-set
  set I_RoutingVelocity_m_per_s item 2 river-parameters-data-set
  set I_ReservoirDepth item 3 river-parameters-data-set
end

to read-soil-parameters
  set soil-parameters-data-set read-row-wise-text-file soil-parameters-input-file-name
  ;;item 0: initial relative groundwater
  ;;item 1: initial relative soil water
  ;;item 2: maximum infiltration
  ;;item 3: maximum infiltration by sub soil
  ;;item 4: percolation fraction multiplier
  set soil-parameters-data-set reduce[sentence ?1 ?2] soil-parameters-data-set
  
  ;;extract the data set
  set I_InitRelGW item 0 soil-parameters-data-set
  set I_InitRelSoil item 1 soil-parameters-data-set
  set I_MaxInfiltration item 2 soil-parameters-data-set
  set I_MaxInfiltrationSubSoil item 3 soil-parameters-data-set
  set I_PercolationFraction item 4 soil-parameters-data-set
end

to read-cattle-parameters
  set cattle-parameters-data-set read-row-wise-text-file cattle-parameters-input-file-name
  ;;item 0: cattle daily intake
  ;;item 1: cattle daily trampling factor
  ;;item 2: cattle sale
  ;;item 3: cattle stocking rate
  ;;item 4: grass litter converter
  ;;item 5: manure converter 
  ;;item 6: grass mortality fraction
  ;;item 7: surface litter decay fraction
  ;;item 8: surface manure decay fraction
  ;;item 9: trampling multiplier
  ;;item 10: grass water use efficiency
  ;;item 11: maximum soil trampling
  ;;item 12: nutrition mortality treshold
  set cattle-parameters-data-set reduce[sentence ?1 ?2] cattle-parameters-data-set
  
  ;;extract the data set
  set C_DailyIntake item 0 cattle-parameters-data-set
  set C_DailyTramplingFrac item 1 cattle-parameters-data-set
  set C_CattleSale item 2 cattle-parameters-data-set
  set C_StockingRate item 3 cattle-parameters-data-set
  set G_GrassLitterConverter item 4 cattle-parameters-data-set
  set G_GrazingManureConverter item 5 cattle-parameters-data-set
  set G_GrassMortalityFrac item 6 cattle-parameters-data-set
  set G_SurfaceLitterDecayFrac item 7 cattle-parameters-data-set
  set G_SurfaceManurePatchDecayFrac item 8 cattle-parameters-data-set
  set G_TramplingMultiplier item 9 cattle-parameters-data-set
  set G_WUE item 10 cattle-parameters-data-set
  set S_MaxTrampling item 11 cattle-parameters-data-set
  set C_NutritionMortalityThreshold item 12 cattle-parameters-data-set
end

to define-daily-rain-input-file-name
  set daily-rain-input-file-name-set[]
  foreach n-values 100[?]
  [
    if not empty? item ? input-file-name-data
    [
      set daily-rain-input-file-name-set lput (item ? input-file-name-data) daily-rain-input-file-name-set
    ]
  ] 
end

to define-luc-fraction-input-file-name
  set luc-fraction-input-file-name-set[]
  foreach n-values 100[?]
  [
    if not empty? item (? + 100) input-file-name-data
    [
      set luc-fraction-input-file-name-set lput (item (? + 100) input-file-name-data) luc-fraction-input-file-name-set
    ]
  ]  
end

to define-dynamic-subcathment-properties-input-file-name
  set dynamic-subcathment-properties-input-file-name-set[]
  foreach n-values 100[?]
  [
    if not empty? item (? + 200) input-file-name-data
    [
      set dynamic-subcathment-properties-input-file-name-set lput (item (? + 200) input-file-name-data) dynamic-subcathment-properties-input-file-name-set
    ]
  ]    
end

to define-reservoir-use-fraction-input-file-name
  set reservoir-use-fraction-input-file-name-set[]
  foreach n-values 100[?]
  [
    if not empty? item (? + 300) input-file-name-data
    [
      set reservoir-use-fraction-input-file-name-set lput (item (? + 300) input-file-name-data) reservoir-use-fraction-input-file-name-set
    ]
  ]    
end

to define-observed-river-flow-input-file-name
  if not empty? item 400 input-file-name-data
  [
    set observed-river-flow-input-file-name lput (item 400 input-file-name-data) []
  ]
end

to define-static-subcathment-properties-input-file-name
  if not empty? item 401 input-file-name-data
  [
    set static-subcathment-properties-input-file-name item 401 input-file-name-data
  ]
end

to define-routing-distance-input-file-name
  if not empty? item 402 input-file-name-data
  [
    set routing-distance-input-file-name item 402 input-file-name-data
  ]
end

to define-monthly-evapotranspiration-input-file-name
  if not empty? item 403 input-file-name-data
  [
    set monthly-evapotranspiration-input-file-name item 403 input-file-name-data
  ]
end

to define-monthly-relative-evapotranspiration-input-file-name
  if not empty? item 404 input-file-name-data
  [
    set monthly-relative-evapotranspiration-input-file-name lput (item 404 input-file-name-data) []
  ]
end

to define-static-luc-properties-input-file-name
  if not empty? item 405 input-file-name-data
  [
    set static-luc-properties-input-file-name lput (item 405 input-file-name-data) []
  ]
end

to define-lake-parameters-input-file-name
  if not empty? item 406 input-file-name-data
  [
    set lake-parameters-input-file-name item 406 input-file-name-data
  ]
end

to define-rain-parameters-input-file-name
  if not empty? item 407 input-file-name-data
  [
    set rain-parameters-input-file-name item 407 input-file-name-data
  ]
end

to define-river-parameters-input-file-name
  if not empty? item 408 input-file-name-data
  [
    set river-parameters-input-file-name item 408 input-file-name-data
  ]
end

to define-soil-parameters-input-file-name
  if not empty? item 409 input-file-name-data
  [
    set soil-parameters-input-file-name item 409 input-file-name-data
  ]
end

to define-cattle-parameters-input-file-name
  if not empty? item 410 input-file-name-data
  [
    set cattle-parameters-input-file-name item 410 input-file-name-data
  ]
end

to check-subcatchment-number
  ifelse length (daily-rain-input-file-name-set) != length (luc-fraction-input-file-name-set)
  or length (daily-rain-input-file-name-set) != length (reservoir-use-fraction-input-file-name-set)
  or length (daily-rain-input-file-name-set) != length (dynamic-subcathment-properties-input-file-name-set)
  or length (daily-rain-input-file-name-set) != length (static-subcathment-properties-data-set)
  or length (daily-rain-input-file-name-set) != length (I_RoutingDistanceObs) 
  [
    user-message 
      "[GenRiver - Error Message] Number of subcathments in your data are different."
      + " You have " + length (daily-rain-input-file-name-set) 
      + " subcatchments in the rain time-series, " + length (luc-fraction-input-file-name-set) 
      + " subcatchments in reservoir use fraction time-series, " + length (reservoir-use-fraction-input-file-name-set)
      + " subcatchments in the land-cover fraction time-series, " + length (dynamic-subcathment-properties-input-file-name-set)
      + " subcatchments in the dynamic properties data set, " + length (static-subcathment-properties-data-set)
      + " subcatchments in the static properties data set, " + length (I_RoutingDistanceObs)
      + " subcatchments in the routing distance data set."
      + "Please, check again!"
    stop
  ]
  [
    set subcatchment-number length (daily-rain-input-file-name-set)
  ]
end

to check-days-number
  if mean map [length ?] reduce[sentence ?1 ?2] daily-rain-data-set != 365
  [
    user-message 
      "[GenRiver - Error Message] Some of your daily rain time series have wrong format. "
      + "The right format is: "
      + "[1] the first row represents year, "
      + "[2] the next 365 rows represents daily rain data for 365 days for each year. "
      + "Please, check again!"
    stop
  ]
  
  if mean map [length ?] reduce[sentence ?1 ?2] reservoir-use-fraction-data-set != 365
  [
    user-message 
      "[GenRiver - Error Message] Some of your reservoir use fraction time series have wrong format. "
      + "The right format is: "
      + "[1] the first row represents year, "
      + "[2] the next 365 rows represents reservoir use fraction data for 365 days for each year. "
      + "Please, check again!"
    stop
  ]
end

;;Modified
;;xxx
to check-luc-number
  ifelse mean map [length ?] reduce[sentence ?1 ?2] luc-fraction-data-set != 
  mean map [length ?] monthly-relative-evapotranspiration-data-set
  or
  mean map [length ?] reduce[sentence ?1 ?2] luc-fraction-data-set != 
  mean map [length ? - 5] static-subcathment-properties-data-set
  [
    user-message 
      "[GenRiver - Error Message] You have different number of land use/cover classes in your related files. "
      + "Please, check again!"
    stop
  ]
  [
    set luc-number mean map [length ?] reduce[sentence ?1 ?2] luc-fraction-data-set
  ]
end

to check-dynamic-subcathment-properties
  if mean map[length ?] reduce[sentence ?1 ?2] dynamic-subcathment-properties-data-set != 7
  [
    user-message 
      "[GenRiver - Error Message] Please check your dynamic subcatchment properties data set. "
      + "You should have 7 parameters in each subcatchment in each year of reference, covering: "
      + "[1] relative flow velocity, "
      + "[2] maximum dynamic groundwater store, "
      + "[3] groundwater release fraction, "
      + "[4] soil quickflow capacity, "
      + "[5] plant available water, "
      + "[6] inaccessible water, "
      + "[7] top soil bd/bdref."
    stop
  ]
end

;;Modified
;;xxx
to check-static-subcathment-properties
  if mean map[length ?] static-subcathment-properties-data-set != (5 + luc-number)
  [
    user-message 
      "[GenRiver - Error Message] Please check your static subcatchment properties data set. "
      + "You should have " + (5 + luc-number) + " parameters in each subcatchment, covering: "
      + "[1] area (km2), "
      + "[2] whether dam exists?, "
      + "[3] whether its flow is fed into lake?, "
      + "[4] groundwater fraction to lake, "
      + "[5] groundwater utilization fraction,"
      + "[6-" + (5 + luc-number) + "] groundwater use in " + luc-number +" land use/cover types?"
    stop
  ]
end

to check-static-luc-properties
  if length static-luc-properties-data-set != 3
  [
    user-message 
      "[GenRiver - Error Message] Please check your static land use/cover properties data set. "
      + "You should have 3 parameters in each luc class, covering: "
      + "[1] potential interception (mm/day), "
      + "[2] relative drought threshold, "
      + "[3] grazable fraction of new growth."
    stop
  ]
end

to check-lake-parameters
  if length lake-parameters-data-set != 13
  [
    user-message 
      "[GenRiver - Error Message] Please check your lake parameters data set. "
      + "You should have 14 parameters, covering: "
      + "[1] lake m3_per_kWh, "
      + "[2] lake bottom elevation, "
      + "[3] lake elevation pre HEPP, "
      + "[4] lake elevation post HEPP, "
      + "[5] lake flood treshold, "
      + "[6] HEPP full level, "
      + "[7] HEPP half level, "
      + "[8] HEPP no level, "
      + "[9] lake overflow, "
      + "[10] lake overflow fraction, "
      + "[11] Qmecs HEPP, "
      + "[12] Qmecs for sanitation flow, "
      + "[13] lake transpiration multiplier."
    stop
  ]
end

to check-rain-parameters
  if length rain-parameters-data-set != 9
  [
    user-message 
      "[GenRiver - Error Message] Please check your rain parameters data set. "
      + "You should have 9 parameters, covering: "
      + "[1] interception drip duration, "
      + "[2] interception drip rate, "
      + "[3] rain multiplier, "
      + "[4] interception effect on transpiration, "
      + "[5] cv of rain intensity, "
      + "[6] mean of rain intensity, "
      + "[7] min rain intensity, "
      + "[8] max rain intensity, "
      + "[9] rain random seed generator."
    stop
  ]
end

to check-river-parameters
  if length river-parameters-data-set != 4
  [
    user-message 
      "[GenRiver - Error Message] Please check your river parameters data set. "
      + "You should have 4 parameters, covering: "
      + "[1] river flow dispersal factor, "
      + "[2] tortuosity, "
      + "[3] velocity (m/s), "
      + "[4] reservoir depth."
    stop
  ]
end

to check-soil-parameters
  if length soil-parameters-data-set != 5
  [
    user-message 
      "[GenRiver - Error Message] Please check your soil parameters data set. "
      + "You should have 5 parameters, covering: "
      + "[1] initial relative groundwater, "
      + "[2] initial relative soil water, "
      + "[3] maximum infiltration, "
      + "[4] maximum infiltration sub soil, "
      + "[5] percolation fraction multiplier."
    stop
  ]
end

to check-cattle-parameters
  if length cattle-parameters-data-set != 13
  [
    user-message 
      "[GenRiver - Error Message] Please check your cattle parameters data set. "
      + "You should have 13 parameters, covering: "
      + "[1] cattle daily intake, "
      + "[2] cattle daily trampling factor, "
      + "[3] cattle sale, "
      + "[4] cattle stocking rate, "
      + "[5] grass litter converter, "
      + "[6] manure converter, "
      + "[7] grass mortality fraction, "
      + "[8] surface litter decay fraction, "
      + "[9] surface manure decay fraction, "
      + "[10] trampling multiplier, "
      + "[11] grass water use efficiency, "
      + "[12] maximum trampling, "
      + "[13] nutrition mortality treshold."
    stop
  ]
end

to check-input-data-error
  check-subcatchment-number
  check-days-number
  check-luc-number
  check-dynamic-subcathment-properties
  check-static-subcathment-properties
  check-static-luc-properties
  check-lake-parameters
  check-rain-parameters
  check-river-parameters
  check-soil-parameters
  check-cattle-parameters
end

to summarise-rain-data
  set mean-monthly-rain-data-set[]
  set sd-monthly-rain-data-set[]
  set p-monthly-wet-days-data-set[]
  set min-daily-rain-data-set[]
  set max-daily-rain-data-set[]
  foreach n-values subcatchment-number[?]
  [    
    let x ?
    let subcatchment-monthly-data-set[[] [] [] [] [] [] [] [] [] [] [] []]
    foreach n-values (length item x daily-rain-data-set)[?]
    [
      let y ?
      let data-set (item y item x daily-rain-data-set)
      let current-monthly-data-set[]
      set current-monthly-data-set
        fput sublist data-set 0 30
        fput sublist data-set 31 58 
        fput sublist data-set 59 89 
        fput sublist data-set 90 119 
        fput sublist data-set 120 150 
        fput sublist data-set 151 180 
        fput sublist data-set 181 211 
        fput sublist data-set 212 242 
        fput sublist data-set 243 272 
        fput sublist data-set 273 303 
        fput sublist data-set 304 333 
        fput sublist data-set 334 364 
        current-monthly-data-set
       set subcatchment-monthly-data-set (map[sentence ?1 ?2] subcatchment-monthly-data-set current-monthly-data-set)
    ]    
    set mean-monthly-rain-data-set lput (map[mean ?] subcatchment-monthly-data-set) mean-monthly-rain-data-set
    set sd-monthly-rain-data-set lput (map[standard-deviation ?] subcatchment-monthly-data-set) sd-monthly-rain-data-set
    set p-monthly-wet-days-data-set lput (map[length remove 0 ? / length ?] subcatchment-monthly-data-set) p-monthly-wet-days-data-set
    ;;Modified
    ;;xxx
    set min-daily-rain-data-set lput (map[ifelse-value (length remove 0 ? > 0) [min remove 0 ?] [0]] subcatchment-monthly-data-set) min-daily-rain-data-set
    set max-daily-rain-data-set lput (map[ifelse-value (length remove 0 ? > 0) [max remove 0 ?] [0]] subcatchment-monthly-data-set) max-daily-rain-data-set
  ]
end

to-report inter-or-extrapolate-time-series-data[percent? time-series time-set start-year end-year] 
  let reference-pos-set[]
  foreach n-values subcatchment-number[?]
  [
    let x ?
    let lo-reference-pos 0
    let up-reference-pos 0
    let reference-pos[]
    foreach n-values (end-year - start-year + 1) [? + start-year]
    [
      let y ?
      set lo-reference-pos position (min (map[abs (? - y)] item x time-set)) (map[abs (? - y)] item x time-set)
      set up-reference-pos position (min(remove-item lo-reference-pos (map[abs (? - y)] item x time-set))) (map[abs (? - y)] item x time-set)
      set reference-pos lput (list lo-reference-pos up-reference-pos) reference-pos
    ]
    set reference-pos-set lput reference-pos reference-pos-set
  ]  
  let data-set4[]
  foreach n-values subcatchment-number[?]
  [
    let x ?
    let data-set1[]
    let data-set2[]
    let data-set3[]
    foreach n-values length (item x reference-pos-set)[?]
    [
      let y ?
      let lo-reference-set item (item 0 item y (item x reference-pos-set)) (item x time-series)
      let up-reference-set item (item 1 item y (item x reference-pos-set)) (item x time-series)
      let lo-time item (item 0 item y (item x reference-pos-set)) (item x time-set)
      let up-time item (item 1 item y (item x reference-pos-set)) (item x time-set)
      let current-time item y (n-values (end-year - start-year + 1) [? + start-year])
      if (up-time - lo-time != 0)
      ;ifelse (up-time - lo-time != 0)
      [
        set data-set1 
          ((map[max list 0 (?1 + ((?2 - ?1) * (current-time - lo-time) / (up-time - lo-time)))] 
          lo-reference-set up-reference-set)) 
    
        set data-set2 ifelse-value (percent?)
        [
          map[precision (ifelse-value (sum data-set1 > 0) [? / sum data-set1] [0]) 2] data-set1
        ]
        [
          data-set1
        ]
        set data-set3 lput data-set2 data-set3
      ]
      ;[
      ;  user-message "[GenRiver - Error Message] You only have one year of time reference in your time-series data." 
      ;  + " At least two points of time reference are needed. Please, check again."
      ;  stop
      ;]
    ]
    set data-set4 lput data-set3 data-set4
  ]
  report data-set4
end

to-report randomize-time-series-data[time-series time-set mean-set sd-set p-set min-set max-set start-year end-year]
  let data-set3[]
  foreach n-values subcatchment-number[?]
  [
    let x ?
    let data-set2[]
    foreach n-values (end-year - start-year + 1) [? + start-year]
    [
      let y ?
      let data-set1[]
      foreach item x time-set
      [
        let z ?
        
        if y = z
        [
          set data-set1 item (position z item x time-set) (item x time-series)
        ]  
      ]
      if data-set1 = [] 
      [ 
        foreach n-values 31[?]
        [
          let jan-rain ifelse-value(random-float 1 < (item 0 item x p-set))
          [
            precision min list (item 0 item x max-set) max list (item 0 item x min-set) random-normal (item 0 item x mean-set) (item 0 item x sd-set) 0            
          ]
          [
            0
          ]
          set data-set1 sentence jan-rain data-set1
        ]                
        foreach n-values 28[?]
        [
          let feb-rain ifelse-value (random-float 1 < (item 1 item x p-set))
          [
            precision min list (item 1 item x max-set) max list (item 1 item x min-set) random-normal (item 1 item x mean-set) (item 1 item x sd-set) 0
          ]
          [
            0
          ]
          set data-set1 sentence feb-rain data-set1
        ]
        foreach n-values 31[?]
        [
          let mar-rain ifelse-value(random-float 1 < (item 2 item x p-set))
          [
            precision min list (item 2 item x max-set)max list (item 2 item x min-set) random-normal (item 2 item x mean-set) (item 2 item x sd-set) 0
          ]
          [
            0
          ]                        
          set data-set1 sentence mar-rain data-set1
        ]
        foreach n-values 30[?]
        [
          let apr-rain ifelse-value(random-float 1 < (item 3 item x p-set))
          [
            precision min list (item 3 item x max-set) max list (item 3 item x min-set) random-normal (item 3 item x mean-set) (item 3 item x sd-set) 0
          ]
          [
            0
          ]
          set data-set1 sentence apr-rain data-set1
        ]
        foreach n-values 31[?]
        [
          let may-rain ifelse-value(random-float 1 < (item 4 item x p-set))
          [
            precision min list (item 4 item x max-set) max list (item 4 item x min-set) random-normal (item 4 item x mean-set) (item 4 item x sd-set) 0
          ]
          [
            0
          ]
          set data-set1 sentence may-rain data-set1
        ]
        foreach n-values 30[?]
        [
          let jun-rain ifelse-value(random-float 1 < (item 5 item x p-set))
          [
            precision min list (item 5 item x max-set) max list (item 5 item x min-set) random-normal (item 5 item x mean-set) (item 5 item x sd-set) 0
          ]
          [
            0
          ]
          set data-set1 sentence jun-rain data-set1
        ]
        foreach n-values 31[?]
        [
          let jul-rain ifelse-value(random-float 1 < (item 6 item x p-set))
          [
            precision min list (item 6 item x max-set) max list (item 6 item x min-set) random-normal (item 6 item x mean-set) (item 6 item x sd-set) 0
          ]
          [
            0
          ]
          set data-set1 sentence jul-rain data-set1
        ]
        foreach n-values 31[?]
        [
          let aug-rain ifelse-value(random-float 1 < (item 7 item x p-set))
          [
            precision min list (item 7 item x max-set) max list (item 7 item x min-set) random-normal (item 7 item x mean-set) (item 7 item x sd-set) 0
          ]
          [
            0
          ]
          set data-set1 sentence aug-rain data-set1
        ]
        foreach n-values 30[?]
        [
          let sep-rain ifelse-value(random-float 1 < (item 8 item x p-set))
          [
            precision min list (item 8 item x max-set) max list (item 8 item x min-set) random-normal (item 8 item x mean-set) (item 8 item x sd-set) 0
          ]
          [
            0
          ]
          set data-set1 sentence sep-rain data-set1
        ]
        foreach n-values 31[?]
        [
          let oct-rain ifelse-value(random-float 1 < (item 9 item x p-set))
          [
            precision min list (item 9 item x max-set) max list (item 9 item x min-set) random-normal (item 9 item x mean-set) (item 9 item x sd-set) 0
          ]
          [
            0
          ]
          set data-set1 sentence oct-rain data-set1
        ]
        foreach n-values 30[?]
        [
          let nov-rain ifelse-value(random-float 1 < (item 10 item x p-set))
          [
            precision min list (item 10 item x max-set) max list (item 10 item x min-set) random-normal (item 10 item x mean-set) (item 10 item x sd-set) 0
          ]
          [
            0
          ]
          set data-set1 sentence nov-rain data-set1
        ]
        foreach n-values 31[?]
        [
          let dec-rain ifelse-value(random-float 1 < (item 11 item x p-set))
          [
            precision min list (item 11 item x max-set) max list (item 11 item x min-set) random-normal (item 11 item x mean-set) (item 11 item x sd-set) 0
          ]
          [
            0
          ]
          set data-set1 sentence dec-rain data-set1
        ]
      ]
      set data-set2 lput data-set1 data-set2
    ]
    set data-set3 lput data-set2 data-set3
  ]
  report data-set3
end

to generate-daily-rain
  ;;order: subcatchment, year, list of daily rain for 365 days
  set I_DailyRainSub_Simulation 
    randomize-time-series-data
    daily-rain-data-set
    daily-rain-year-set
    mean-monthly-rain-data-set
    sd-monthly-rain-data-set
    p-monthly-wet-days-data-set
    min-daily-rain-data-set
    max-daily-rain-data-set
    simulation-start-year (simulation-start-year + simulation-duration - 1)
  
  ;;order: subcatchment, year, list of daily rain for 365 days 
  if (use-warm-up?)
  [
    set I_DailyRainSub_WarmUp
      randomize-time-series-data
      daily-rain-data-set
      daily-rain-year-set
      mean-monthly-rain-data-set
      sd-monthly-rain-data-set
      p-monthly-wet-days-data-set
      min-daily-rain-data-set
      max-daily-rain-data-set
      simulation-start-year (simulation-start-year + warm-up-duration - 1)
   ]
end

to generate-luc-fraction
  ;;order: subcatchment, year, list of luc-type fraction for n classes
  set I_RelAreaPatch_Simulation
    inter-or-extrapolate-time-series-data 
    true luc-fraction-data-set luc-fraction-year-set 
    simulation-start-year (simulation-start-year + simulation-duration - 1)   
  
  ;;order: subcatchment, year, list of luc-type fraction for n classes  
  if (use-warm-up?)
  [
    set I_RelAreaPatch_WarmUp
      inter-or-extrapolate-time-series-data 
      true luc-fraction-data-set luc-fraction-year-set 
      simulation-start-year (simulation-start-year + warm-up-duration - 1)
  ]
end

to generate-reservoir-use-fraction
  ;;order: subcatchment, year, list of daily reservoir-use-fraction
  set D_ReservoirUseFracSub_Simulation
    inter-or-extrapolate-time-series-data 
    false reservoir-use-fraction-data-set reservoir-use-fraction-year-set 
    simulation-start-year (simulation-start-year + simulation-duration)   

  ;;order: subcatchment, year, list of daily reservoir-use-fraction
  if (use-warm-up?)
  [
    set D_ReservoirUseFracSub_WarmUp
      inter-or-extrapolate-time-series-data 
      false reservoir-use-fraction-data-set reservoir-use-fraction-year-set 
      simulation-start-year (simulation-start-year + warm-up-duration - 1)     
  ]
end

to-report extract-2d-data-set[i data-set]
  let x length data-set
  let y mean map[length ?] data-set
  let f-data-set1 map[item i ?] reduce [sentence ?1 ?2] data-set
  let f-data-set2[]
  let i1 0
  foreach n-values x [?]
  [
    let i2 i1 + y  
    set f-data-set2 lput (sublist f-data-set1 i1 i2) f-data-set2
    set i1 i1 + y
  ]  
  report f-data-set2
end

to generate-dynamic-subcathment-properties
  ;;order: subcatchment, year, list of dynamic properties: 
  ;;item 0: relative flow velocity
  ;;item 1: maximum dynamic groundwater store
  ;;item 2: groundwater release fraction
  ;;item 3: soil quickflow capacity
  ;;item 4: plant available water
  ;;item 5: inaccessible water
  ;;item 6: top soil bd/bdref
  set generated-dynamic-subcathment-properties-data-set-for-simulation
    inter-or-extrapolate-time-series-data 
    false dynamic-subcathment-properties-data-set dynamic-subcathment-properties-year-set 
    simulation-start-year (simulation-start-year + simulation-duration - 1)   
    
  ;;order: subcatchment, year, list of dynamic properties: 
  ;;item 0: relative flow velocity
  ;;item 1: maximum dynamic groundwater store
  ;;item 2: groundwater release fraction
  ;;item 3: soil quickflow capacity
  ;;item 4: plant available water
  ;;item 5: inaccessible water
  ;;item 6: top soil bd/bdref
  set generated-dynamic-subcathment-properties-data-set-for-warm-up
    inter-or-extrapolate-time-series-data 
    false dynamic-subcathment-properties-data-set dynamic-subcathment-properties-year-set 
    simulation-start-year (simulation-start-year + warm-up-duration - 1)  
  
  ;;extract the data set
  set I_RiverFlowTimeSub_Simulation extract-2d-data-set 0 generated-dynamic-subcathment-properties-data-set-for-simulation
  set I_MaxDynGWSub_Simulation extract-2d-data-set 1 generated-dynamic-subcathment-properties-data-set-for-simulation
  set I_GWRelFracSub_Simulation extract-2d-data-set 2 generated-dynamic-subcathment-properties-data-set-for-simulation
  set I_SoilFieldCapacitySub_Simulation extract-2d-data-set 3 generated-dynamic-subcathment-properties-data-set-for-simulation
  set I_AvailWaterSub_Simulation extract-2d-data-set 4 generated-dynamic-subcathment-properties-data-set-for-simulation
  set I_PWPSub_Simulation extract-2d-data-set 5 generated-dynamic-subcathment-properties-data-set-for-simulation
  set I_BD_BDRefSub_Simulation extract-2d-data-set 6 generated-dynamic-subcathment-properties-data-set-for-simulation
  
  if (use-warm-up?)
  [
    set I_RiverFlowTimeSub_WarmUp extract-2d-data-set 0 generated-dynamic-subcathment-properties-data-set-for-warm-up
    set I_MaxDynGWSub_WarmUp extract-2d-data-set 1 generated-dynamic-subcathment-properties-data-set-for-warm-up
    set I_GWRelFracSub_WarmUp extract-2d-data-set 2 generated-dynamic-subcathment-properties-data-set-for-warm-up
    set I_SoilFieldCapacitySub_WarmUp extract-2d-data-set 3 generated-dynamic-subcathment-properties-data-set-for-warm-up
    set I_AvailWaterSub_WarmUp extract-2d-data-set 4 generated-dynamic-subcathment-properties-data-set-for-warm-up
    set I_PWPSub_WarmUp extract-2d-data-set 5 generated-dynamic-subcathment-properties-data-set-for-warm-up
    set I_BD_BDRefSub_WarmUp extract-2d-data-set 6 generated-dynamic-subcathment-properties-data-set-for-warm-up
  ]
end

to generate-daily-evapotranspiration
  ;;order: daily evapotranspiration (mm)
  set I_ET_DailySet
    sentence n-values 31 [item 0 monthly-evapotranspiration-data-set]
    sentence n-values 28 [item 1 monthly-evapotranspiration-data-set]
    sentence n-values 31 [item 2 monthly-evapotranspiration-data-set]
    sentence n-values 30 [item 3 monthly-evapotranspiration-data-set]
    sentence n-values 31 [item 4 monthly-evapotranspiration-data-set]
    sentence n-values 30 [item 5 monthly-evapotranspiration-data-set]
    sentence n-values 31 [item 6 monthly-evapotranspiration-data-set]
    sentence n-values 31 [item 7 monthly-evapotranspiration-data-set]
    sentence n-values 30 [item 8 monthly-evapotranspiration-data-set]
    sentence n-values 31 [item 9 monthly-evapotranspiration-data-set]
    sentence n-values 30 [item 10 monthly-evapotranspiration-data-set]
    n-values 31 [item 11 monthly-evapotranspiration-data-set]
    
  ;;order: day, list of daily relative evapotranspiration of n classes luc-type
  set I_RelETLUC_DailySet
    sentence n-values 31 [item 0 monthly-relative-evapotranspiration-data-set]
    sentence n-values 28 [item 1 monthly-relative-evapotranspiration-data-set]
    sentence n-values 31 [item 2 monthly-relative-evapotranspiration-data-set]
    sentence n-values 30 [item 3 monthly-relative-evapotranspiration-data-set]
    sentence n-values 31 [item 4 monthly-relative-evapotranspiration-data-set]
    sentence n-values 30 [item 5 monthly-relative-evapotranspiration-data-set]
    sentence n-values 31 [item 6 monthly-relative-evapotranspiration-data-set]
    sentence n-values 31 [item 7 monthly-relative-evapotranspiration-data-set]
    sentence n-values 30 [item 8 monthly-relative-evapotranspiration-data-set]
    sentence n-values 31 [item 9 monthly-relative-evapotranspiration-data-set]
    sentence n-values 30 [item 10 monthly-relative-evapotranspiration-data-set]
    n-values 31 [item 11 monthly-relative-evapotranspiration-data-set]
end

to read-input-parameters
  manage-input-file
  define-daily-rain-input-file-name
  define-observed-river-flow-input-file-name
  define-luc-fraction-input-file-name
  define-dynamic-subcathment-properties-input-file-name
  define-reservoir-use-fraction-input-file-name
  define-static-subcathment-properties-input-file-name
  define-routing-distance-input-file-name
  define-static-luc-properties-input-file-name
  define-monthly-evapotranspiration-input-file-name
  define-monthly-relative-evapotranspiration-input-file-name
  define-lake-parameters-input-file-name
  define-rain-parameters-input-file-name
  define-river-parameters-input-file-name
  define-soil-parameters-input-file-name
  define-cattle-parameters-input-file-name
  ;;;  
  read-daily-rain
  read-reservoir-use-fraction
  read-observed-river-flow
  read-luc-fraction  
  read-dynamic-subcathment-properties
  read-static-subcathment-properties
  read-routing-distance
  read-static-luc-properties
  read-monthly-evapotranspiration
  read-monthly-relative-evapotranspiration
  read-lake-parameters
  read-rain-parameters
  read-river-parameters
  read-soil-parameters
  read-cattle-parameters
  ;;;
  check-input-data-error
  ;;;
  read-groundwater-utilization
  summarise-rain-data
  generate-daily-rain
  generate-reservoir-use-fraction
  generate-luc-fraction
  generate-dynamic-subcathment-properties    
  generate-daily-evapotranspiration
end

to-report initialize-1D-parameters[x val]
  let data-set n-values x[val]
  report data-set
end

to-report initialize-2D-parameters[x y val]
  let data-set n-values x [n-values y[val]]
  report data-set
end

to-report initialize-3D-parameters[x y z val]
  let data-set n-values x [n-values y[n-values z[val]]]
  report data-set
end

to initialize-patch-water-balance
  set D_AtmWaterPatch initialize-2D-parameters subcatchment-number luc-number 0
  set D_SoilWaterPatch[]
  foreach n-values subcatchment-number[?]
  [
    let i ?
    set D_SoilWaterPatch lput (map[(item i ((map[item 0 ? * I_InitRelSoil] I_AvailWaterSub_Simulation))) * ?] (item i (map[item 0 ?] I_RelAreaPatch_Simulation))) D_SoilWaterPatch
  ]
  set D_GWSub map[? * I_InitRelGW] (map[item 0 ?] I_MaxDynGWSub_Simulation)
end

to initialize-stream-network
  ;;Modified
  ;;xxx
  set O_CumDebitCatch 0
  set adjusted-observed-river-flow-year-set map[? - simulation-start-year] observed-river-flow-year-set
  set D_CumRiverFlowObs initialize-2D-parameters subcatchment-number observation-point-number 0  
  set D_DelaySurfaceFlowToRiverObs_DailySet initialize-3D-parameters subcatchment-number observation-point-number (365 * (simulation-duration + warm-up-duration)) 0
  set D_TotalDelayRiverFlowObs initialize-2D-parameters subcatchment-number observation-point-number 0    
  set I_ContributoryArea[] 
  foreach n-values observation-point-number[?]
  [
    let i ?
    set I_ContributoryArea lput
      sum(map[ifelse-value(?1) [?2] [0]]
      (map[item i ? >= 0] I_RoutingDistanceObs)
      I_AreaSub)
      I_ContributoryArea
  ]
  
  let mult[]
    foreach n-values subcatchment-number[?]
    [
      let i ?
      set mult lput 
        (map[ifelse-value(? >= 0) [1] [0]] (item i I_RoutingDistanceObs))
        mult
    ]
    set I_RelAreaSubObs[]
    foreach n-values subcatchment-number[?]
    [
      let i ?
      set I_RelAreaSubObs lput
      (map[ifelse-value(?1 > 0) [?2 / ?1] [0]] I_ContributoryArea (map[item i I_AreaSub * ?] item i mult))
      I_RelAreaSubObs 
    ]
end

to initialize-lake
  set L_CumEvapLake 0
  set L_CumHEPPUse 0
  set L_CumRiverOutflow 0
  set L_HEPPDailyDemand ifelse-value (sum I_AreaSub > 0) [(L_QHEPP_m3_per_sec * 3600 * 24) / (sum I_AreaSub * 10 ^ -3)] [0]
  set L_SanitaryFlow ifelse-value(sum I_AreaSub > 0) [(L_QSanitaryFlow_m3_per_sec * 3600 * 24) / (sum I_AreaSub * 10 ^ -3)] [0]
  
  ifelse (water-body-id <= (luc-number - 1))
  [
    set L_LakeHereSub? (map[? = 1] (map[item water-body-id ?] (map[item 0 ?] I_RelAreaPatch_Simulation)))
  ]
  [
    set L_LakeHereSub? initialize-1D-parameters subcatchment-number false
  ]
  
  set L_LakeAreaSub (map[ifelse-value (?1) [?2] [0]] L_LakeHereSub? I_AreaSub)
  set D_MaxReservoirVolSub (map[ifelse-value (?1) [?2 * I_ReservoirDepth] [0]] L_LakeHereSub? I_AreaSub)
  set D_ReservoirVolSub (map[ifelse-value (?1) [?2] [0]] I_DamHereSub? D_MaxReservoirVolSub) 
  set L_OutflowTresholdVolPreHEPP 1000 * (L_LakeElevPreHEPP - L_LakeBottomElev) * sum L_LakeAreaSub
  set L_OutflowTresholdVolPostHEPP 1000 * (L_LakeElevPostHEPP - L_LakeBottomElev) * sum L_LakeAreaSub
  set L_LakeVol ifelse-value (activate-HEPP?) [L_OutflowTresholdVolPostHEPP] [L_OutflowTresholdVolPreHEPP]
  set O_CumHEPP_kWh 0
end

to initialize-output
  set O_CumDeepInfiltrationCatch 0
  set O_CumETCatch 0
  set O_CumGWCatch sum (map[?1 * ?2] (map[item 0 ?] I_MaxDynGWSub_Simulation) I_RelAreaSub) * I_InitRelGW
  set O_CumGWDischargeCatch 0
  set O_CumInfiltrationCatch 0
  set O_CumInterceptCatch 0
  set O_CumPercolationCatch 0
  set O_CumRainCatch 0
  set O_CumSimulatedDebit initialize-1D-parameters observation-point-number 0
  set O_CumSoilDischargeCatch 0
  set O_CumSoilWaterCatch sum (map[?1 * ?2] (map[item 0 ?] I_AvailWaterSub_Simulation) I_RelAreaSub) * I_InitRelSoil
  set O_CumSurfaceFlowCatch 0
end

to initialize-grass
  set G_GrassBiomassPatch initialize-2D-parameters subcatchment-number luc-number 1
  set G_SurfaceLitterPatch initialize-2D-parameters subcatchment-number luc-number 0
  set G_SurfaceManurePatch initialize-2D-parameters subcatchment-number luc-number 0
end

to initialize-cattle
  set C_Stocking 1
end

to initialize-soil-structure-dynamics
  set S_RelBDPatch[]
  foreach map[item 0 ?] I_BD_BDRefSub_Simulation
  [
    let val ?
    set S_RelBDPatch lput n-values luc-number [val] S_RelBDPatch
  ]
end

to initialize-subcathment  
  set I_RelAreaSub map[? / (sum I_AreaSub)] I_AreaSub
end

to initialize-before-warming-up
  set under-development 0
  read-input-parameters
  initialize-subcathment
  initialize-grass
  initialize-cattle
  initialize-soil-structure-dynamics
  initialize-patch-water-balance
  initialize-stream-network
  initialize-lake
  initialize-output
end

to initialize-before-simulation[warm-up?]
  set I_Simulation_Time 0
  
  if (not warm-up?)
  [
    let list3[]
    foreach n-values subcatchment-number[?]
    [
      let x ?
      let list2[]
      foreach n-values observation-point-number[?]
      [
        let y ?
        let list1 sublist (item y item x D_DelaySurfaceFlowToRiverObs_DailySet) (365 * warm-up-duration) (365 * (warm-up-duration + simulation-duration))
        set list2 lput list1 list2
      ]
      set list3 lput list2 list3
    ]
    set D_DelaySurfaceFlowToRiverObs_DailySet list3
  ]
end

to parameterize-yearly-parameters
  [
    available-water-set
    bd-set
    gw-release-fraction-set
    max-gw-set
    pwp-set
    luc-fraction-set
    river-flow-time-set
    soil-field-capacity-set
  ]
  set I_AvailWaterSub map[item year ?] available-water-set
  set I_BD_BDRefSub map[item year ?] bd-set
  set I_GWRelFracSub map[item year ?] gw-release-fraction-set
  set I_MaxDynGWSub map[item year ?] max-gw-set
  set I_PWPSub map[item year ?] pwp-set
  set I_RelAreaPatch map[item year ?] luc-fraction-set
  set I_RiverFlowTimeSub map[item year ?] river-flow-time-set
  set I_SoilFieldCapacitySub map[item year ?] soil-field-capacity-set
end

to simulate-yearly-dynamics
  set I_AvailWaterPatch[]
  foreach n-values subcatchment-number[?]
  [
    let i ?
    set I_AvailWaterPatch lput (map [? * (item i I_AvailWaterSub)] (item i I_RelAreaPatch)) I_AvailWaterPatch
  ]
end

;;Modified
;;xxx
to parameterize-daily-parameters
  [
    dd
    yy
    rain-set 
    subcatchment-reservoir-use-fraction-set 
    measured-debit-year-set
    measured-debit-data-set
  ]
  
  set I_DailyRainSub map[(item dd item yy ?) * I_RainMultiplier] rain-set    
  set I_ET item dd I_ET_DailySet
  ifelse(member? yy measured-debit-year-set)
  [
    let y position yy measured-debit-year-set
    set I_MeasuredDebit_m3_per_sec item dd item y measured-debit-data-set
  ]
  [
    set I_MeasuredDebit_m3_per_sec 0
  ]
  set I_MeasuredDebit_mm_per_day 
    map[ifelse-value(? > 0) [(I_MeasuredDebit_m3_per_sec * 24 * 3.6) / ?] [0]] I_ContributoryArea
  set I_RelETLUC (item dd I_RelETLUC_DailySet)    
  set D_ReservoirUseFracSub map[item dd item yy ?] subcatchment-reservoir-use-fraction-set
end

to update-data-set
  let temp3[]
  foreach n-values subcatchment-number[?]
  [
    let x ?
    let temp2[]
    foreach n-values observation-point-number[?]
    [
      let y ?
      let z (item y item x D_RoutingTimeObs) + I_Simulation_Time
      let temp1 ifelse-value (z >= 0 and z <= length(item y item x D_DelaySurfaceFlowToRiverObs_DailySet) - 1)
      [
        replace-item z 
          (item y item x D_DelaySurfaceFlowToRiverObs_DailySet)
          (item y item x D_DelaySurfaceFlowObs)
      ]
      [
        (item y item x D_DelaySurfaceFlowToRiverObs_DailySet)
      ]  
        set temp2 lput temp1 temp2
    ]
    set temp3 lput temp2 temp3
    ]
    set D_DelaySurfaceFlowToRiverObs_DailySet temp3   
end

to update-soil-structure-stocks
  let temp[]           
  foreach n-values subcatchment-number[?]
  [
    let i ?
          
    set temp lput
      (map[max list 0 (?1 + ?2 + ?3 + ?4 - ?5)]
      (item i S_RelBDPatch)
      (item i S_StructureFormationPatch)
      (item i S_RippingSurfacePatch)
      (item i S_SplashErosionPatch)
      (item i S_CompactionPatch))
      temp 
  ]       
  set S_RelBDPatch temp
end

to update-stocks      
  update-patch-stocks
  update-subcatchment-stocks
  update-river-stocks
  update-lake-stocks    
  update-output-stocks
  update-grass-stocks
  update-cattle-stocks
  update-soil-structure-stocks
end

to update-grass-stocks
  let temp1[]
  let temp2[]
  let temp3[]              
  foreach n-values subcatchment-number[?]
  [
    let i ?
          
    set temp1 lput
      (map[max list 0 (?1 + ?2 - ?3 - ?4)]
      (item i G_GrassBiomassPatch)
      (item i G_GrowthRatePatch)
      (item i G_GrazingPatch)      
      (item i G_LeafMortalityPatch)    
      )
      temp1  
        
    set temp2 lput
      (map[max list 0 (?1 + ?2 - ?3)]
      (item i G_SurfaceLitterPatch)
      (item i G_LitterDepositionPatch)
      (item i G_DecaySurfaceLitterIncorporationPatch)
      )
      temp2
          
    set temp3 lput
      (map[max list 0 (?1 + ?2 - ?3)]
      (item i G_SurfaceManurePatch)
      (item i G_FaecesProductionPatch)
      (item i G_DecayManureIncorportionPatch)
      )
      temp3        
  ]             
  set G_GrassBiomassPatch temp1
  set G_SurfaceLitterPatch temp2
  set G_SurfaceManurePatch temp3
end

to update-cattle-stocks
  set C_Stocking max list 0 (C_Stocking + C_StockingRate - C_Destocking)
end

to update-subcatchment-stocks
  set D_GWSub
    (map[max list 0 (?1 + ?2 + ?3 - ?4)]
    D_GWSub
    (map[sum ?] D_PercolationPatch)
    D_DeepInfiltrationSub
    D_GWDischargeSub
    )
      
  set D_ReservoirVolSub
    (map[max list 0 (?1 + ?2 - ?3 - ?4)]
    D_ReservoirVolSub
    D_ReservoirInflowSub
    D_ReservoirEvapSub
    D_ReservoirOutflowSub
    )
end

to update-patch-stocks
  let temp1[]
  let temp2[]    
  foreach n-values subcatchment-number[?]
  [
    let i ?
    set temp1 lput
      (map[max list 0 (?1 + ?2 + ?3)]
      (item i D_AtmWaterPatch)
      (item i D_ActETPatch)
      (item i D_InterceptPatch)
      )
      temp1
       
    set temp2 lput
      (map[max list 0 (?1 + ?2 - ?3 - ?4 - ?5)]
      (item i D_SoilWaterPatch)
      (item i D_InfiltrationPatch)
      (item i D_ActETPatch)
      (item i D_PercolationPatch)
      (item i D_SoilDischargePatch))
      temp2
  ]       
  set D_AtmWaterPatch temp1  
  set D_SoilWaterPatch temp2
end

to update-river-stocks
  let temp1[]
  let temp2[]
              
  foreach n-values subcatchment-number[?]
  [
    let i ?

    set temp1 lput
      (map[max list 0 (?1 + ?2 + ?3)]
      (item i D_CumRiverFlowObs)
      (item i D_DelayRiverFlowObs)
      (item i D_DirectRiverFlowObs))
      temp1
       
    set temp2 lput
      (map[max list 0 (?1 + ?2 + ?3 - ?4 - ?5)] 
      (item i D_TotalDelayRiverFlowObs)
      (item i D_DelaySurfaceFlowToRiverObs)
      (item i D_DirectSurfaceFlowObs)
      (item i D_DelayRiverFlowObs)
      (item i D_RiverInflowToLakeObs)
      )
      temp2
  ]       
      
  set D_CumRiverFlowObs temp1
  set D_TotalDelayRiverFlowObs temp2
  
  ;;Modified
  ;;xxx
  set O_CumDebitCatch (item (position true I_ObserveAllSubcatchmentsObs?) O_SimulatedDebit_mm_per_day) + O_CumDebitCatch
end

to update-lake-stocks
  set L_CumEvapLake max list 0 (L_CumEvapLake + L_EvapLake)
  set L_CumHEPPUse max list 0 (L_CumHEPPUse + L_HEPPWaterUseFlow)
  set L_CumRiverOutflow max list 0 (L_CumRiverOutflow + L_RiverOutflow)
  set L_LakeVol max list 0 (L_LakeVol + L_InflowToLake - L_EvapLake - L_RiverOutflow - L_HEPPWaterUseFlow)
end

to update-output-stocks
  set O_CumGWDischargeCatch 
    max list 0 (O_CumGWDischargeCatch + sum(map[?1 * ?2] D_GWDischargeSub I_RelAreaSub))
  set O_CumDeepInfiltrationCatch max list 0 (O_CumDeepInfiltrationCatch + sum(map[?1 * ?2] D_DeepInfiltrationSub I_RelAreaSub))
  set O_CumInfiltrationCatch max list 0 (O_CumInfiltrationCatch + sum(map[?1 * ?2] (map[sum ?] D_InfiltrationPatch) I_RelAreaSub))    
  set O_CumPercolationCatch max list 0 (O_CumPercolationCatch + sum(map[?1 * ?2] (map[sum ?] D_PercolationPatch) I_RelAreaSub))
  set O_CumRainCatch max list 0 (O_CumRainCatch + sum(map[?1 * ?2] I_DailyRainSub I_RelAreaSub))
  set O_CumInterceptCatch max list 0 (O_CumInterceptCatch + sum(map[?1 * ?2] (map[sum ?] D_InterceptPatch) I_RelAreaSub))    
  set O_CumSoilDischargeCatch max list 0 (O_CumSoilDischargeCatch + sum(map[?1 * ?2] (map[sum ?] D_SoilDischargePatch) I_RelAreaSub))
  set O_CumSurfaceFlowCatch 
    max list 0 (O_CumSurfaceFlowCatch + sum(map[?1 * ?2] D_SurfaceFlowSub I_RelAreaSub))    
  set O_CumETCatch max list 0 (O_CumETCatch + sum(map[?1 * ?2] (map[sum ?] D_ActETPatch) I_RelAreaSub))
  set O_CumGWCatch max list 0 (O_CumGWCatch + (sum(map[?1 * ?2] D_GWSub I_RelAreaSub) - O_CumGWCatch))
  set O_CumSoilWaterCatch max list 0 (O_CumSoilWaterCatch + (sum(map[?1 * ?2] (map[sum ?] D_SoilWaterPatch) I_RelAreaSub) - O_CumSoilWaterCatch))
  set O_CumSimulatedDebit (map[?1 + ?2] O_CumSimulatedDebit O_SimulatedDebit_mm_per_day)
  set O_CumHEPP_kWh O_CumHEPP_kWh + L_HEPP_kWh
end

to simulate-lake-dynamics
  ifelse (water-body-id <= (luc-number - 1))
  [
    set L_LakeTranspirationSub
      (map[ifelse-value(?1) [?2] [0]]
      L_LakeHereSub?
      (map[max list 0 (?2 - ?1)]
      (map[item water-body-id ?] D_ActETPatch)
      (map[item water-body-id ?] I_PETPatch)
      ))
  ]
  [
    set L_LakeTranspirationSub
      initialize-1D-parameters subcatchment-number 0
  ]
   
  set L_LakeLevel
    ifelse-value(sum L_LakeAreaSub > 0) [(L_LakeVol / (1000 * sum L_LakeAreaSub)) + L_LakeBottomElev] [0]
      
  set L_HEPPOutflow 
    ifelse-value(L_LakeLevel > L_LakeLevelFullHEPP)
    [
      L_HEPPDailyDemand
    ]
    [
      ifelse-value(L_LakeLevel > L_LakeLevelNoHEPP)
      [
        L_HEPPDailyDemand * 0.5 * (1 +
        (max list 0 (L_LakeLevel - L_LakeLevelHalfHEPP)
        /
        (L_LakeLevelFullHEPP - L_LakeLevelHalfHEPP)))
      ]
      [
        0
      ]
    ]
      
  set L_EvapLake 
    min list L_LakeVol ((min list (sum (map[?1 * ?2] L_LakeTranspirationSub I_RelAreaSub)) L_LakeVol) * I_LakeTranspirationMultiplier)
    ;min list L_LakeVol ((min list (sum L_LakeTranspirationSub) L_LakeVol) * I_LakeTranspirationMultiplier) 
      
  set L_RiverOutflow
    min list
    (max list 0 (L_LakeVol + L_LakeOverflow - L_EvapLake))      
    (max list (ifelse-value (activate-HEPP?) [L_SanitaryFlow] [0])
    ((L_LakeVol - (ifelse-value (activate-HEPP?) [L_OutflowTresholdVolPostHEPP] [0]) - 
    (ifelse-value(not activate-HEPP?) [L_OutflowTresholdVolPreHEPP] [0])) 
    * (L_LakeOverFlowFrac) * ( 1 + L_LakeLevelExcess ^ L_LakeOverFlow)))         
      
  set L_HEPPWaterUseFlow min list (max list 0 (L_LakeVol + L_InflowToLake 
    - L_EvapLake - L_RiverOutflow)) 
    (ifelse-value(activate-HEPP?) [L_HEPPOutflow] [0])
      
  set L_LakeLevelExcess 
    L_LakeLevel - (ifelse-value (not activate-HEPP?) [L_LakeElevPreHEPP] [0])
    - (ifelse-value(activate-HEPP?) [L_LakeElevPostHEPP] [0])
  
  ifelse (observed-point-id <= observation-point-number)
  [    
    set L_InflowToLake 
      item observed-point-id D_RiverFlowToLakeObs +
      item observed-point-id D_GWToLakeObs
  ]
  [
    set L_InflowToLake 0
  ]
      
  set L_FloodingCurrent? L_LakeLevel > L_FloodTresh
      
  set L_HEPP_kWh 1000 * sum(I_AreaSub) * L_HEPPWaterUseFlow / L_m3_per_kWh
       
  set L_HEPP_RelOperationalTime ifelse-value(I_Simulation_Time > 0) 
    [(L_CumHEPPUse / L_HEPPDailyDemand) / I_Simulation_Time]
    [0]
end

to simulate-patch-dynamics
  set I_RainIntensitySub[]
  set I_DailyRainPatch[]
  foreach n-values subcatchment-number[?]
  [
    random-seed I_Rain_GenSeed + 11250
    set I_RainIntensitySub sentence (max list I_Rain_IntensityMin min list I_Rain_IntensityMax random-normal I_Rain_IntensityMean 
    (I_Rain_IntensityMean * I_Rain_IntensityCV)) I_RainIntensitySub
        
    set I_DailyRainPatch lput (map[? * item ? I_DailyRainSub] item ? I_RelAreaPatch) I_DailyRainPatch
  ]
  set I_RainDurationSub (map[?1 / ?2] I_DailyRainSub I_RainIntensitySub)
  set I_InterceptCapacityPatch[]
  set I_MaxInfiltrationPatch[]
  set I_MaxInfiltrationSubSoilPatch[]
  set I_PETPatch[]
  set I_SoilSaturationPatch[]
  set D_InterceptPatch[]
  set D_RelAvailWaterPatch[]     
  
  foreach n-values subcatchment-number[?]
  [
    let i ?
    ;;Modified
    ;;xxx
    ;;set I_InterceptCapacityPatch lput(map[?1 * ?2 * (item i I_AreaSub)] I_InterceptLUC (item i I_RelAreaPatch)) I_InterceptCapacityPatch        
    set I_InterceptCapacityPatch lput(map[?1 * ?2] I_InterceptLUC (item i I_RelAreaPatch)) I_InterceptCapacityPatch
    
    set D_InterceptPatch lput(map[ ifelse-value(?1 > 0) 
      [?1 * (1 - exp (- ?2 / ?1))] [0]] 
      (item i I_InterceptCapacityPatch) (item i I_DailyRainPatch)) D_InterceptPatch          
    
    set I_PETPatch lput((map[I_ET * ?1 * ?2]  I_RelETLUC (item i I_RelAreaPatch))) I_PETPatch
    
    set I_MaxInfiltrationPatch lput(map[I_MaxInfiltration * ? * (item i I_BD_BDRefSub)] (item i I_RelAreaPatch) ) I_MaxInfiltrationPatch        
    
    set I_MaxInfiltrationSubSoilPatch lput(map[I_MaxInfiltrationSubSoil * ? ] (item i I_RelAreaPatch)) I_MaxInfiltrationSubSoilPatch        
    set D_RelAvailWaterPatch lput (map[ifelse-value ((?2 * ?3) > 0) 
      [min list 1 (?1 / (?2 * ?3))] [1]] (item i D_SoilWaterPatch) 
      (item i I_AvailWaterPatch) I_RelDroughtLUC) D_RelAvailWaterPatch            
    set I_SoilSaturationPatch lput(map[((item i I_SoilFieldCapacitySub) + (item i I_AvailWaterSub)) * ? ] (item i I_RelAreaPatch)) I_SoilSaturationPatch
  ]
      
  set D_InterceptDurationSub map[min list D_MaxInterceptDripDuration(? / D_InterceptDripRate)] (map[sum ?] D_InterceptPatch)
  set I_InfiltrationDurationSub (map[min list 24 (?1 + ?2)] I_RainDurationSub D_InterceptDurationSub)
        
  set D_InfiltrationPatch[]
  set D_ActETPatch[] 
  set D_PercolationPatch[]
  set D_SoilDischargePatch[]
  foreach n-values subcatchment-number[?]
  [
    let i ?
    
    ;;check here
    ;;zzz
    set D_InfiltrationPatch lput
      (ifelse-value (item i L_LakeHereSub?) [n-values luc-number [0]] 
      [
      (
      map[max list 0 ?]
      ((map[min list ?1 ?2] 
      (map[min list ?1 ?2] (map[?1 - ?2] 
      (item i I_SoilSaturationPatch) (item i D_SoilWaterPatch) )
      (map [? * (item i I_InfiltrationDurationSub) / 24] (item i I_MaxInfiltrationPatch)))
      (map[?1 - ?2] (item i I_DailyRainPatch) (item i D_InterceptPatch))
      )))
      ])
      D_InfiltrationPatch     
        
    set D_ActETPatch lput
      (map[ifelse-value (item i L_LakeHereSub?) [0] 
      [(min list (?4 + ?5) (max list 0 (?1 - I_InterceptionEffectOnTranspiration * ?2)) * ?3)]] 
      (item i I_PETPatch) (item i D_InterceptPatch) (item i D_RelAvailWaterPatch)
      (item i D_SoilWaterPatch)
      (item i D_InfiltrationPatch)
      ) 
      D_ActETPatch             
    
    ;;Modified
    ;;xxx
    set D_PercolationPatch lput 
      (map[ifelse-value (?1 > 0) [?2] [?3]] 
      ;;?1
      (item i I_AvailWaterPatch)
      ;;?2
      (map[?1 - ?2]
      ;;?2[?1]
      (map[min list ?1 ?2]
      (map[max list 0 (?1 + ?2 - ?3)] (item i D_SoilWaterPatch) (item i D_InfiltrationPatch) (item i D_ActETPatch))
      ((map[max list 0 ?]
      (map[min list ? ((item i I_MaxDynGWSub) - (item i D_GWSub))]
      (map[min list ?1 (?2 * I_PercolationFraction * (item i I_GWRelFracSub))] 
      (item i I_MaxInfiltrationSubSoilPatch) (item i D_SoilWaterPatch))))))
      ;;?2[?2]
      (map[min list ?1 ?2]
      (item i I_PETPatch)
      (map[ifelse-value(?1) [(item i D_GWSub) * (item i D_GWUtilizationFractionPatch) * (1 - ?2)] [0]]
      (item i D_GWUtilizedPatch?)      
      (item i D_RelAvailWaterPatch)
      )))
      ;;?3
      (map[-1 * ?]
      (map[min list ?1 ?2]
      (item i I_PETPatch)
      (map[ifelse-value(?1) [(item i D_GWSub) * (item i D_GWUtilizationFractionPatch) * (1 - ?2)] [0]]
      (item i D_GWUtilizedPatch?)      
      (item i D_RelAvailWaterPatch)
      )))
      )
      D_PercolationPatch
      
    ;;check here
    ;;zzz      
    set D_SoilDischargePatch lput
      (map[min list ?1 ?2]          
      (map[max list 0 (?1 + ?2 - ?3 - ?4)] 
      (item i D_SoilWaterPatch) 
      (item i D_InfiltrationPatch) 
      (item i D_ActETPatch) 
      (item i D_PercolationPatch))
      (map[max list 0 (?1 - ?2)] (item i D_SoilWaterPatch) 
      (item i I_AvailWaterPatch)))
      D_SoilDischargePatch      
   ]
    
    set D_DeepInfiltrationSub 
      (map[ifelse-value(?1) [0] [?2]]
      L_LakeHereSub?
      (
      map[max list 0 ?]
      ((map[min list ?1 ?2]
      (map[min list ?1 ?2] 
      (map[sum ?] I_MaxInfiltrationSubSoilPatch)
      (map[(?1 * (?2 / 24)) - (?3 + ?4)] 
      (map[sum ?] I_MaxInfiltrationPatch) 
      I_InfiltrationDurationSub 
      (map[sum ?] I_SoilSaturationPatch) 
      (map[sum ?] D_SoilWaterPatch))
      )
      (map[min list ?1 ?2]
      (map[?1 - ?2 - ?3]
      (map[sum ?] I_DailyRainPatch) 
      (map[sum ?] D_InterceptPatch)
      (map[sum ?] D_InfiltrationPatch))
      (map[?1 - ?2] I_MaxDynGWSub D_GWSub))))))
        
    set D_GWDischargeSub 
      (map[min list ?1 ?2] 
      (map[?1 + ?2 + sum ?3] D_GWSub D_DeepInfiltrationSub D_PercolationPatch) 
      (map[?1 * ?2] D_GWSub I_GWRelFracSub))
    
    ;;check here  
    ;;zzz
    set D_SurfaceFlowSub
      (map[ifelse-value (?1) [?2] [?3]]
      (L_LakeHereSub?)
      (map[sum ?] I_DailyRainPatch)
      (
      map[max list 0 ?]
      (map[?1 - ?2 - ?3 - ?4] 
      (map[sum ?] I_DailyRainPatch) 
      (map[sum ?] D_InterceptPatch) 
      (map[sum ?] D_InfiltrationPatch) 
      (D_DeepInfiltrationSub))))
    
    set D_ReservoirInflowSub
      (map[ifelse-value (?1) [?2] [0]] I_DamHereSub?
      (map[?1 + ?2 + ?3] 
      (D_GWDischargeSub)
      (map[sum ?] D_SoilDischargePatch)
      (D_SurfaceFlowSub))
      )
      
    set D_ReservoirEvapSub 
      (map[ifelse-value(?2) [?1] [0]] 
      (map[max list 0 (min list I_ET (?1 + ?2))] D_ReservoirVolSub D_ReservoirInflowSub)
      L_LakeHereSub?)
        
    set D_ReservoirOutflowSub
      (map[min list ?1 ?2]
      (map[max list 0 (?1 + ?2 - ?3)] D_ReservoirVolSub D_ReservoirInflowSub D_ReservoirEvapSub)
      (map[ifelse-value (?4) [(ifelse-value((?1 / ?2) > 1) [max list 0 (?1 - ?2)] [?1 * ?3])] [0]] 
      D_ReservoirVolSub D_MaxReservoirVolSub D_ReservoirUseFracSub L_LakeHereSub?))
      
    set D_TotalStreamInflowSub        
      (map[?1 + (?2 * ?3) + ?4 + (ifelse-value(?6) [?5] [0])]
      D_SurfaceFlowSub
      D_GWDischargeSub
      (map[1 - ?] D_GWFracToLakeSub)
      (map[sum ?] D_SoilDischargePatch)
      D_ReservoirOutflowSub
      (map[not ?] I_DamHereSub?))      
end

to simulate-river-dynamics[warm-up?]
    let list2[]
    foreach n-values subcatchment-number[?]
    [
      let x ?
      let list1[]
      foreach n-values observation-point-number[?]
      [
        let y ?
        let val item I_Simulation_Time item y item x D_DelaySurfaceFlowToRiverObs_DailySet
        set list1 lput val list1
      ]
      set list2 lput list1 list2
    ]
    set D_DelaySurfaceFlowToRiverObs list2
      
    set D_RoutingTimeObs[]
    set I_RelFracObs[]
    set D_RiverToLakeSameDayObs[]
    set D_DelayRiverFlowObs[]
    set D_DirectRiverFlowObs[]
    set D_DelaySurfaceFlowObs[]
    set D_RiverInflowToLakeObs[]
    set D_DirectSurfaceFlowObs[]
    set D_GWLakeObs[]
    foreach n-values subcatchment-number[?]
    [
      let i ?
         
      set D_RoutingTimeObs lput
        (map[ifelse-value((item i I_RiverFlowTimeSub) > 0) [?] [0]]
        (map[? / ((item i I_RiverFlowTimeSub) * 
        I_RoutingVelocity_m_per_s * 3.6 * 24 * I_Tortuosity)] item i I_RoutingDistanceObs))
        D_RoutingTimeObs
        
      set I_RelFracObs lput
        (map[ifelse-value(? != 0) [ifelse-value(? > 0) [min list 1 (I_RiverFlowDispersalFactor / ?)] [0]] [1]] item i D_RoutingTimeObs)
        I_RelFracObs
           
      set D_DirectRiverFlowObs lput
        (map[ifelse-value(?1 >= 0 and ?1 < 1) [?2] [0]]
        (item i D_RoutingTimeObs)
        (map[ifelse-value(not (item i D_FeedingIntoLakeSub?)) [(item i D_TotalStreamInflowSub) * ?] [0]]
        (item i I_RelFracObs)))
        D_DirectRiverFlowObs
        
      set D_DirectSurfaceFlowObs lput
        (map[ifelse-value(?1 >= 0 and ?1 < 1) [?2] [0]] (item i D_RoutingTimeObs)
        (map[(item i D_TotalStreamInflowSub) * (1 - ?)] (item i I_RelFracObs))
        )
        D_DirectSurfaceFlowObs
         
      set D_RiverToLakeSameDayObs lput
        (map[ifelse-value(?1 >= 0 and ?1 < 1) [?2] [0]] 
        (item i D_RoutingTimeObs)
        (map[ifelse-value(item i D_FeedingIntoLakeSub?) [(item i D_TotalStreamInflowSub) * ?] [0]] (item i I_RelFracObs))
        )
        D_RiverToLakeSameDayObs
           
      set D_DelaySurfaceFlowObs lput
        (map[ifelse-value(? >= 1) [item i D_TotalStreamInflowSub] [0]] (item i D_RoutingTimeObs))
        D_DelaySurfaceFlowObs

      set D_DelayRiverFlowObs lput
        (map[min list ?1 ?2]
        (map[?1 + ?2 + ?3]
        (item i D_TotalDelayRiverFlowObs) (item i D_DelaySurfaceFlowToRiverObs) (item i D_DirectSurfaceFlowObs))
        (map[ifelse-value(not (item i D_FeedingIntoLakeSub?)) [?] [0]]
        (map[?1 * ?2] (item i I_RelFracObs) (item i D_TotalDelayRiverFlowObs))))  
        D_DelayRiverFlowObs
           
      set D_RiverInflowToLakeObs lput
        (map[min list ?1 ?2]
        (map[max list 0 (?1 + ?2 + ?3 - ?4)] 
        (item i D_TotalDelayRiverFlowObs)
        (item i D_DelaySurfaceFlowToRiverObs)
        (item i D_DirectSurfaceFlowObs)
        (item i D_DelayRiverFlowObs))
        (map[ifelse-value(item i D_FeedingIntoLakeSub?) [?] [0]]
        (map[?1 * ?2] (item i I_RelFracObs) (item i D_TotalDelayRiverFlowObs))))
        D_RiverInflowToLakeObs    
          
      set D_GWLakeObs lput
        map[(item i (map[?1 * ?2] D_GWFracToLakeSub D_GWDischargeSub)) * ?]
        item i I_RelFracObs
        D_GWLakeObs
    ]
    
    ;;Modified        
    ;;xxx
    set D_RiverFlowToLakeObs[]
    set D_GWToLakeObs[]
    foreach n-values observation-point-number[?]
    [
      let i ?
      set D_RiverFlowToLakeObs lput  
        (sum(map[?1 * ?2] (map[item i ?] D_RiverToLakeSameDayObs) (map[item i ?] I_RelAreaSubObs)) +
        sum(map[?1 * ?2] (map[item i ?] D_RiverInflowToLakeObs) (map[item i ?] I_RelAreaSubObs)))
        D_RiverFlowToLakeObs
          
      set D_GWToLakeObs lput
        sum(map[?1 * ?2] (map[item i ?] D_GWLakeObs) (map[item i ?] I_RelAreaSubObs))
        D_GWToLakeObs
    ]
    
    set O_DeltaSoilWaterStockCatch O_CumSoilWaterCatch - sum(map[?1 * ?2] (map[sum ?] D_SoilWaterPatch) I_RelAreaSub)
    set O_DeltaGWCatch O_CumGWCatch - sum(map[?1 * ?2] D_GWSub I_RelAreaSub)
      
    set O_TotalStreamFlowCatch 
      O_CumGWDischargeCatch + O_CumSoilDischargeCatch + O_CumSurfaceFlowCatch
      
    if (not warm-up?)
    [
      ;;Modified
      ;;xxx
      set sim-day day + 1
      set sim-year year + simulation-start-year
      set O_BalanceCatch
        ;;        
        ;;O_CumRainCatch -
        ;;O_CumETCatch -
        ;;O_CumDebitCatch
        ;;      
        O_CumInterceptCatch +
        O_CumETCatch +
        O_TotalStreamFlowCatch -
        O_DeltaGWCatch -
        O_DeltaSoilWaterStockCatch -
        O_CumRainCatch         
    ]
           
    set O_FracBaseFlow ifelse-value (O_TotalStreamFlowCatch > 0) [O_CumGWDischargeCatch / O_TotalStreamFlowCatch] [0]
    set O_FracSoilQuickFlow ifelse-value (O_TotalStreamFlowCatch > 0) [O_CumSoilDischargeCatch / O_TotalStreamFlowCatch] [0]
    set O_FracSurfaceQuickFlow ifelse-value (O_TotalStreamFlowCatch > 0) [O_CumSurfaceFlowCatch / O_TotalStreamFlowCatch] [0]
    set O_RelAvailWaterCatch sum (map[?1 * ?2] (map[sum ?] D_RelAvailWaterPatch) I_RelAreaSub)    
    
    ;;Modified
    ;;xxx
    set O_SimulatedDebit_mm_per_day[]
    foreach n-values observation-point-number[?]
    [
      let i ?
      set O_SimulatedDebit_mm_per_day lput
      sum(map[(?1 + ?2 + ?3 + ?4) * ?5]
      (map[item i ?] D_DirectRiverFlowObs) 
      (map[item i ?] D_DelayRiverFlowObs)
      (map[item i ?] D_RiverToLakeSameDayObs)
      (map[item i ?] D_RiverInflowToLakeObs)
      (map[item i ?] I_RelAreaSubObs))
      O_SimulatedDebit_mm_per_day
    ]
end

to simulate-daily-dynamics[warm-up?]
  simulate-patch-dynamics    
  simulate-river-dynamics warm-up?    
  simulate-lake-dynamics    
  simulate-grass-dynamics
  simulate-cattle-dynamics
  simulate-soil-structure-dynamics
end

to simulate-soil-structure-dynamics       
  set S_RainAtSoilSurfacePatch[]
  set S_StructureFormationPatch[]
  set S_SplashErosionPatch[]
  set S_CompactionPatch[]
  set S_RippingSurfacePatch[] 
    
  foreach n-values subcatchment-number[?]
  [
    let i ?
    
    set S_RainAtSoilSurfacePatch lput
      (map[?1 - ?2]
      (item i I_DailyRainPatch)
      (item i D_InterceptPatch)
      )
      S_RainAtSoilSurfacePatch

    set S_StructureFormationPatch lput
      (map[under-development * ?1 * ?2]
      (item i S_RelBDPatch)
      (item i G_SurfaceCoverPatch))
      S_StructureFormationPatch
           
    set S_SplashErosionPatch lput
      (map[ifelse-value((item i I_RainDurationSub) > 0) [(under-development * ?1 * ?2) / 
      (item i I_RainDurationSub)] [0]]
      (item i G_SurfaceCoverPatch)
      (item i S_RainAtSoilSurfacePatch)     
      )
      S_SplashErosionPatch
          
    set S_RippingSurfacePatch lput
      (n-values luc-number[under-development])
      S_RippingSurfacePatch
          
    set S_CompactionPatch lput
      (map[min list ?1 ?2]
      (map[?1 + ?2 + ?3 + ?4] item i S_RelBDPatch 
      item i S_RippingSurfacePatch 
      item i S_StructureFormationPatch 
      item i S_SplashErosionPatch)
      (map[ifelse-value(S_MaxTrampling > 0) 
      [1.3 - ((?1 * ?2) / S_MaxTrampling)] [1.3]]
      (item i S_RelBDPatch)
      (item i C_TramplingCompactionPatch)
      ))
      S_CompactionPatch
  ]
end

to simulate-grass-dynamics
  set G_GrassCatch sum(map[sum ?] G_GrassBiomassPatch)   
  set G_GrazingPatch[]
  set G_SurfaceCoverPatch[]
  set G_GrowthRatePatch[]
  set G_LeafMortalityPatch[]
  set G_LitterDepositionPatch[]
  set G_DecaySurfaceLitterIncorporationPatch[]
  set G_FaecesProductionPatch[]
  set G_DecayManureIncorportionPatch[]
  foreach n-values subcatchment-number[?]
  [
    let i ?
    set G_GrowthRatePatch lput
      (map[G_WUE * ?1 * ?2]
      I_GrassFracBiomassLUC
      (item i D_ActETPatch))
      G_GrowthRatePatch  
        
    set G_GrazingPatch lput
      (map[min list ?1 ?2]
      (map[?1 + ?2] item i G_GrassBiomassPatch item i G_GrowthRatePatch)
      (map[ifelse-value(G_GrassCatch > 0) [?2] [?1]]
      (n-values luc-number[0])
      (map[C_Stocking * C_DailyIntake * ? / G_GrassCatch] 
      (item i G_GrassBiomassPatch))
      ))
      G_GrazingPatch
        
    set G_LeafMortalityPatch lput
      (map[min list ?1 ?2]
      (map[max list 0 (?1 + ?2 - ?3)] item i G_GrassBiomassPatch item i G_GrowthRatePatch item i G_GrazingPatch)
      (map[(?1 * G_GrassMortalityFrac) + (?2 * G_TramplingMultiplier)] 
      (item i G_GrassBiomassPatch)
      (item i G_GrazingPatch)
      ))
      G_LeafMortalityPatch
        
    set G_FaecesProductionPatch lput
      (map[? * G_GrazingManureConverter]
      (item i G_GrazingPatch))
      G_FaecesProductionPatch
           
    set G_DecayManureIncorportionPatch lput
      (map[min list ?1 ?2]
      (map[?1 + ?2] item i G_SurfaceManurePatch item i G_FaecesProductionPatch)
      (map[? * G_SurfaceManurePatchDecayFrac]
      (item i G_SurfaceManurePatch)))
      G_DecayManureIncorportionPatch
           
    set G_LitterDepositionPatch lput
      (map[? * G_GrassLitterConverter]
      (item i G_LeafMortalityPatch))
      G_LitterDepositionPatch
           
    set G_DecaySurfaceLitterIncorporationPatch lput
      (map[min list ?1 ?2]
      (map[?1 + ?2] item i G_SurfaceLitterPatch item i G_LitterDepositionPatch)
      (map[? * G_SurfaceLitterDecayFrac]
      (item i G_SurfaceLitterPatch)))
      G_DecaySurfaceLitterIncorporationPatch
        
    set G_SurfaceCoverPatch lput
      (map[?1 + ?2 + ?3]
      (item i G_GrassBiomassPatch)
      (item i G_SurfaceLitterPatch)
      (item i G_SurfaceManurePatch)
      )
      G_SurfaceCoverPatch
  ]
end

to simulate-cattle-dynamics
  set C_TramplingCompactionPatch[]
  foreach n-values subcatchment-number[?]
  [
    let i ?
    set C_TramplingCompactionPatch lput
      (map[ifelse-value(C_DailyIntake > 0) [C_DailyTramplingFrac * ? / C_DailyIntake] [0]]
      (item i G_GrazingPatch)
      )
      C_TramplingCompactionPatch
  ]
        
  set C_StockingRate under-development * C_Stocking
       
  set C_RelNutrition ifelse-value(C_Stocking * C_DailyIntake > 0)
    [min list 1 ((sum (map[sum ?] G_GrazingPatch)) / 
    (C_Stocking * C_DailyIntake))]
    [1]
      
  set C_DeathRate C_Stocking * min list 1 (ifelse-value(C_NutritionMortalityThreshold > 0) 
    [C_RelNutrition / C_NutritionMortalityThreshold] [0])
  set C_Destocking min list (C_Stocking + C_StockingRate) (C_CattleSale + C_DeathRate)
end

to simulate
  [
    warm-up?
    year-period 
    rain-set 
    luc-fraction-set 
    gw-release-fraction-set 
    available-water-set 
    soil-field-capacity-set
    bd-set
    max-gw-set
    river-flow-time-set
    subcatchment-reservoir-use-fraction-set
    pwp-set
    measured-debit-year-set
    measured-debit-data-set
  ]
  
  initialize-before-simulation warm-up?
  
  foreach n-values year-period[?]
  [
    
    set year ?
    
    if (not warm-up? and report-results?) 
    [
      file-open output-file-name
      file-print repeating-header
      file-close
    ]
    
    parameterize-yearly-parameters
      available-water-set
      bd-set
      gw-release-fraction-set
      max-gw-set
      pwp-set
      luc-fraction-set
      river-flow-time-set
      soil-field-capacity-set
    
    simulate-yearly-dynamics    
          
    foreach n-values 365[?]
    [
      set day ?
      
      parameterize-daily-parameters
        day
        year
        rain-set
        subcatchment-reservoir-use-fraction-set
        measured-debit-year-set
        measured-debit-data-set        
        
      simulate-daily-dynamics warm-up?
      report-and-plot warm-up?   
      update-data-set
      update-stocks      
      set I_Simulation_Time I_Simulation_Time + 1            
    ] 
    if (not warm-up? and report-results?) 
    [
      file-print ""
      file-print ""
    ]
  ]

  if (not warm-up? and report-results?) 
  [
    file-print ""
    file-print ""
    file-close
  ]
end

to report-and-plot[warm-up?]
  if (not warm-up?)
  [
    plot-simulated-river-flow-at-lake-inlet
    plot-simulated-river-flow-at-observed-point
    plot-water-balance
        
    if(activate-HEPP?)
    [
      plot-HEPP
    ]
        
    if (measured-at-lake-inlet? and (sum L_LakeAreaSub > 0))
    [
      if(member? year adjusted-observed-river-flow-year-set)
      [
        plot-measured-river-flow-at-lake-inlet
      ]
    ]
    if (measured-at-observed-point?)
    [
      if(member? year adjusted-observed-river-flow-year-set)
      [
        plot-measured-river-flow-at-observed-point
      ]
    ]
        
    if (report-results?) 
    [
      report-results
    ]
        
    if visualise-river?
    [
      ifelse (observed-point-id <= observation-point-number)
      [
        visualise-river ((item observed-point-id O_SimulatedDebit_mm_per_day) * scale)
      ]
      [
        visualise-river 0
      ]
    ]
  ]
end

to warm-up
  simulate 
    true
    warm-up-duration
    I_DailyRainSub_WarmUp
    I_RelAreaPatch_WarmUp
    I_GWRelFracSub_WarmUp
    I_AvailWaterSub_WarmUp
    I_SoilFieldCapacitySub_WarmUp
    I_BD_BDRefSub_WarmUp
    I_MaxDynGWSub_WarmUp
    I_RiverFlowTimeSub_WarmUp
    D_ReservoirUseFracSub_WarmUp
    I_PWPSub_WarmUp
    adjusted-observed-river-flow-year-set
    observed-river-flow-data-set
end

to reset
  set D_AtmWaterPatch initialize-2D-parameters subcatchment-number luc-number 0
  set D_CumRiverFlowObs initialize-2D-parameters subcatchment-number observation-point-number 0
  set L_CumEvapLake 0
  set L_CumRiverOutflow 0
  set L_CumHEPPUse 0
  set O_CumRainCatch 0
  set O_CumInterceptCatch 0
  set O_CumETCatch 0
  set O_CumSoilWaterCatch sum (map[?1 * ?2] (map[item 0 ?] I_AvailWaterSub_Simulation) I_RelAreaSub) * I_InitRelSoil
  set O_CumGWCatch sum (map[?1 * ?2] (map[item 0 ?] I_MaxDynGWSub_Simulation) I_RelAreaSub) * I_InitRelGW
  set O_CumSurfaceFlowCatch 0
  set O_CumSoilDischargeCatch 0
  set O_CumGWDischargeCatch 0
  set O_CumInfiltrationCatch 0
  set O_CumPercolationCatch 0
  set O_CumDeepInfiltrationCatch 0
  set S_RelBDPatch[]
  foreach map[item 0 ?] I_BD_BDRefSub_Simulation
  [
    let val ?
    set S_RelBDPatch lput n-values luc-number [val] S_RelBDPatch
  ]
  set G_GrassBiomassPatch initialize-2D-parameters subcatchment-number luc-number 1
  set G_SurfaceManurePatch initialize-2D-parameters subcatchment-number luc-number 0
  set G_SurfaceLitterPatch initialize-2D-parameters subcatchment-number luc-number 0
  set C_Stocking 1
  set O_CumSimulatedDebit initialize-1D-parameters observation-point-number 0
  set O_CumHEPP_kWh 0
  ;;Modified
  ;;xxx
  set O_CumDebitCatch 0
end

to setup
  ca
  open-scenario
  
  if (report-results?)
  [
    ask-output-file-name
  ]
  
  initialize-before-warming-up
  
  if (report-results?)
  [
    make-output-file-header
  ]
  
  if (use-warm-up?)
  [
    warm-up
    reset
  ]
  
  set setup-done-code 1
  
  user-message "[GenRiver] The model is now ready for simulation. " +
  "Press go button to proceed the simulation."
end

to go
  ifelse (setup-done-code = 1)
  [
    simulate 
      false
      simulation-duration
      I_DailyRainSub_Simulation
      I_RelAreaPatch_Simulation
      I_GWRelFracSub_Simulation
      I_AvailWaterSub_Simulation
      I_SoilFieldCapacitySub_Simulation
      I_BD_BDRefSub_Simulation
      I_MaxDynGWSub_Simulation
      I_RiverFlowTimeSub_Simulation
      D_ReservoirUseFracSub_Simulation
      I_PWPSub_Simulation   
      adjusted-observed-river-flow-year-set
      observed-river-flow-data-set
    user-message "[GenRiver] Simulation is done." 
    set setup-done-code 0
  ]
  [
    user-message "[GenRiver] You have not setup the model.  You must setup the model first." 
  ]
end

to plot-simulated-river-flow-at-lake-inlet
  set-current-plot "Lake inlet"
  set-current-plot-pen "Simulated"
  if (observed-point-id <= observation-point-number) and (sum D_RiverFlowToLakeObs > 0)
  [
    plotxy I_Simulation_Time (item observed-point-id D_RiverFlowToLakeObs)
  ]
end

to plot-measured-river-flow-at-lake-inlet
  set-current-plot "Lake inlet"
  set-current-plot-pen "Measured"
  if (observed-point-id <= observation-point-number) and (sum D_RiverFlowToLakeObs > 0)
  [
    plotxy I_Simulation_Time (item observed-point-id I_MeasuredDebit_mm_per_day)
  ]
end

to plot-simulated-river-flow-at-observed-point
  set-current-plot "Observed point"
  set-current-plot-pen "Simulated"
  if (observed-point-id <= observation-point-number)
  [
    plotxy I_Simulation_Time (item observed-point-id O_SimulatedDebit_mm_per_day)
  ]
end

to plot-measured-river-flow-at-observed-point
  set-current-plot "Observed point"
  set-current-plot-pen "Measured"
  if (observed-point-id <= observation-point-number)
  [
    plotxy I_Simulation_Time (item observed-point-id I_MeasuredDebit_mm_per_day)
  ]
end

to plot-water-balance
  set-current-plot "Catchment balance"
  set-current-plot-pen "Rain"
  plotxy I_Simulation_Time O_CumRainCatch
  set-current-plot-pen "ET"
  plotxy I_Simulation_Time O_CumETCatch
  ;;Modified
  ;;xxx
  set-current-plot-pen "Debit"
  plotxy I_Simulation_Time O_CumDebitCatch
  ;;if (observed-point-id <= observation-point-number)
  ;;[
  ;;  plotxy I_Simulation_Time (item observed-point-id O_CumSimulatedDebit)
  ;;]
  set-current-plot-pen "Base"
  plotxy I_Simulation_Time O_CumGWDischargeCatch
  set-current-plot-pen "Surface"
  plotxy I_Simulation_Time O_CumSurfaceFlowCatch
  set-current-plot-pen "Soil"
  plotxy I_Simulation_Time O_CumSoilDischargeCatch
end

to plot-HEPP
  set-current-plot "HEPP"
  plotxy I_Simulation_Time L_HEPP_kWh
end

to open-scenario
  user-message "[GenRiver] Please, select the name of scenario file after this dialog!"
  set scenario-file-name user-file
end

to ask-output-file-name
  set output-file-name user-input "[GenRiver] Please, define the name of output file to save the simulation results!" + ".out"
end

to make-output-file-header  
  ;;Modified
  ;;xxx
  let header ""
  foreach n-values subcatchment-number[?]
  [
    set header header + "rain[sub" + ? + "]" + "\t"
  ]
  foreach n-values subcatchment-number[?]
  [
    set header header + "et[sub" + ? + "]" + "\t"
  ]
  foreach n-values subcatchment-number[?]
  [
    set header header + "base[sub" + ? + "]" + "\t"
  ]
  foreach n-values subcatchment-number[?]
  [
    set header header + "surf[sub" + ? + "]" + "\t"
  ]
  foreach n-values subcatchment-number[?]
  [
    set header header + "soil[sub" + ? + "]" + "\t"
  ]  
  foreach n-values observation-point-number[?]
  [
    set header header + "lake[obs" + ? + "]" + "\t"
  ]
  foreach n-values (observation-point-number)[?]
  [
    set header header + "sim-deb[obs" + ? + "]" + "\t"
  ]  
  foreach n-values (observation-point-number - 1)[?]
  [
    set header header + "meas-deb[obs" + ? + "]" + "\t"
  ]
  set header header + "meas-deb[obs" + observation-point-number + "]" + "\t" + "balance"
  
  if (activate-HEPP?)
  [
    set header header + "\t" + "power"
  ]
  
  set header "year" + "\t" + "day" + "\t" + header
  
  set repeating-header header
  
  file-open output-file-name
  file-print "[GenRiver]"
  file-print ""
  file-print "Simulation results on " + date-and-time 
  file-print ""
  file-print "Main setting:"
  file-print "[.] Input scenario file name: " + scenario-file-name
  file-print "[.] Warm up the model? " + use-warm-up?
  file-print "[.] Activate HEPP? " + activate-HEPP?
  file-print ""
  file-print "Output parameters:"
  file-print "[.] Rainfall (mm/day by subcatchment)"
  file-print "[.] Actual evapotranspiration (mm/day by subcatchment)"
  file-print "[.] Baseflow (mm/day by subcatchment)"
  file-print "[.] Surface quickflow (mm/day by subcatchment)"
  file-print "[.] Soil quickflow (mm/day by subcatchment)"
  file-print "[.] Inflow to lake (mm/day by observation point)"
  file-print "[.] Simulated river debit (mm/day by observation point)"
  file-print "[.] Measured river debit (mm/day by observation point)"
  file-print "[.] Catchment balance (mm/day)"
  if (activate-HEPP?)
  [
    file-print "[.] HEPP production (kWh/day)"
  ]
  file-print ""
  file-close 
end

to report-results
  ;;Modified
  ;;xxx
  let result ""  
  foreach n-values subcatchment-number[?]
  [
    set result result + (item ? I_DailyRainSub) + "\t"
  ]
  foreach n-values subcatchment-number[?]
  [
    set result result + (item ? (map[sum ?]  D_ActETPatch)) + "\t"
  ]
  foreach n-values subcatchment-number[?]
  [
    set result result + (item ? D_GWDischargeSub) + "\t"
  ]
  foreach n-values subcatchment-number[?]
  [
    set result result + (item ? D_SurfaceFlowSub) + "\t"
  ]
  foreach n-values subcatchment-number[?]
  [
    set result result + (item ? (map[sum ?]  D_SoilDischargePatch)) + "\t"
  ]  
  foreach n-values observation-point-number[?]
  [
    set result result + (item ? D_RiverFlowToLakeObs) + "\t"
  ]
  foreach n-values (observation-point-number)[?]
  [
    set result result + (item ? O_SimulatedDebit_mm_per_day) + "\t"
  ]
  foreach n-values (observation-point-number - 1)[?]
  [
    set result result + (item ? I_MeasuredDebit_mm_per_day) + "\t"
  ]
  set result result + (last I_MeasuredDebit_mm_per_day) + "\t" + O_BalanceCatch 
  
  if (activate-HEPP?)
  [
    set result result + "\t" + L_HEPP_kWh
  ]
  
  set result (year + simulation-start-year) + "\t" + (day + 1) + "\t" + result
  
  file-open output-file-name
  file-print result
end

to visualise-river[o]
  ask patches with[pycor < o]
  [
    set pcolor blue + random-float 1
  ]
  ask patches with[pycor >= o]
  [
    set pcolor black
  ]
end
@#$#@#$#@
GRAPHICS-WINDOW
754
97
954
504
-1
-1
2.0
1
1
1
1
1
0
0
0
1
0
50
0
100

CC-WINDOW
5
518
963
613
Command Center
0

BUTTON
68
340
131
373
NIL
setup
NIL
1
T
OBSERVER
T
NIL

SLIDER
10
100
205
133
simulation-start-year
simulation-start-year
0
3000
1991
1
1
NIL

SLIDER
10
143
205
176
simulation-duration
simulation-duration
1
100
4
1
1
years

SLIDER
10
188
204
221
warm-up-duration
warm-up-duration
1
100
2
1
1
years

SLIDER
10
278
204
311
water-body-id
water-body-id
0
100
5
1
1
NIL

SLIDER
10
234
203
267
observed-point-id
observed-point-id
0
100
2
1
1
NIL

BUTTON
68
382
131
415
NIL
go
NIL
1
T
OBSERVER
T
NIL

PLOT
474
69
701
230
Lake inlet
day
river flow (mm)
0.0
10.0
0.0
10.0
true
true
PENS
"Simulated" 1.0 0 -2674135 true
"Measured" 1.0 2 -13345367 true

SWITCH
9
10
204
43
use-warm-up?
use-warm-up?
0
1
-1000

MONITOR
231
10
457
59
Catchment balance (mm)
O_BalanceCatch
0
1

SWITCH
474
25
700
58
measured-at-lake-inlet?
measured-at-lake-inlet?
1
1
-1000

PLOT
230
311
459
472
Observed point
day
river flow (mm)
0.0
10.0
0.0
10.0
true
true
PENS
"Simulated" 1.0 0 -2674135 true
"Measured" 1.0 2 -13345367 true

SWITCH
230
267
460
300
measured-at-observed-point?
measured-at-observed-point?
0
1
-1000

PLOT
231
69
458
230
Catchment balance
day
cum flow (mm)
0.0
10.0
0.0
10.0
true
true
PENS
"Rain" 1.0 0 -2674135 true
"ET" 1.0 0 -955883 true
"Debit" 1.0 0 -1184463 true
"Base" 1.0 0 -10899396 true
"Surface" 1.0 0 -13345367 true
"Soil" 1.0 0 -8630108 true

PLOT
476
310
706
473
HEPP
day
power (kWh)
0.0
10.0
0.0
10.0
true
false

SWITCH
475
269
705
302
activate-HEPP?
activate-HEPP?
1
1
-1000

SWITCH
9
54
203
87
report-results?
report-results?
0
1
-1000

SWITCH
753
10
954
43
visualise-river?
visualise-river?
0
1
-1000

SLIDER
754
50
954
83
scale
scale
0
100
10.0
0.01
1
NIL

MONITOR
161
341
218
390
day
sim-day
0
1

MONITOR
162
395
218
444
year
sim-year
0
1

@#$#@#$#@
WHAT IS IT?
-----------
This section could give a general understanding of what the model is trying to show or explain.


HOW IT WORKS
------------
This section could explain what rules the agents use to create the overall behavior of the model.


HOW TO USE IT
-------------
This section could explain how to use the model, including a description of each of the items in the interface tab.


THINGS TO NOTICE
----------------
This section could give some ideas of things for the user to notice while running the model.


THINGS TO TRY
-------------
This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.


EXTENDING THE MODEL
-------------------
This section could give some ideas of things to add or change in the procedures tab to make the model more complicated, detailed, accurate, etc.


NETLOGO FEATURES
----------------
This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.


RELATED MODELS
--------------
This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.


CREDITS AND REFERENCES
----------------------
This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

link
true
0
Line -7500403 true 150 0 150 300

link direction
true
0
Line -7500403 true 150 150 30 225
Line -7500403 true 150 150 270 225

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 3.1.3
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
