breed[links link]
breed[house-holds house-hold]
breed[fields field]

;;house-holds' attributes
house-holds-own
[
  ;;house-holds' neigborhood
  original-x
  original-y
  ethnic-type
  
  ;;land capital  
  fields-number
  own-land-use-1?
  own-land-use-2?
  own-land-use-3?
  number-land-use-1
  number-land-use-2
  number-land-use-3
  
  ;;labor capital  
  labor-capital
  labor-fraction-land-use-1
  labor-fraction-land-use-2
  labor-fraction-land-use-3
  
  ;;knowledge capital
  knowledge-land-use-1
  knowledge-land-use-2
  knowledge-land-use-3
  
  exchanged-knowledge-land-use-1
  exchanged-knowledge-land-use-2
  exchanged-knowledge-land-use-3
  
  total-knowledge-from-plot-land-use-1
  total-knowledge-from-plot-land-use-2
  total-knowledge-from-plot-land-use-3
    
  ;;information network 
  weight-popularity-person
  house-hold-popularity
  weight-ethnical-distance
  average-ethnic-distance-partners
  weight-physical-distance
  average-physic-distance-partners
  total-partner-attractiveness
  selected-partner
  weight-info-from-sharing
  weight-info-from-seeking
  
  ;;diffusion of information
  
  ;;sharing
  share?
  p-sharing
  list-info-from-sharing-land-use-1
  info-from-sharing-land-use-1
  list-info-from-sharing-land-use-2
  info-from-sharing-land-use-2
  list-info-from-sharing-land-use-3
  info-from-sharing-land-use-3
  list-weight-info-from-sharing-land-use-1
  list-weight-info-from-sharing-land-use-2
  list-weight-info-from-sharing-land-use-3
  
  ;;seeking
  seek?
  p-seeking
  list-info-from-seeking-land-use-1
  info-from-seeking-land-use-1
  list-info-from-seeking-land-use-2
  info-from-seeking-land-use-2
  list-info-from-seeking-land-use-3
  info-from-seeking-land-use-3
  list-weight-info-from-seeking-land-use-1
  list-weight-info-from-seeking-land-use-2
  list-weight-info-from-seeking-land-use-3
    
  ;;observing from others
  observe?
  p-observing
  observation-relative-distance
  observation-fields-list
  observation-land-use-list
  list-info-from-observing-land-use-1
  info-from-observing-land-use-1
  list-info-from-observing-land-use-2
  info-from-observing-land-use-2
  list-info-from-observing-land-use-3
  info-from-observing-land-use-3
  list-weight-info-from-observing-land-use-1
  list-weight-info-from-observing-land-use-2
  list-weight-info-from-observing-land-use-3

  ;;exposing in extension
  expose-in-extension-land-use-1?
  p-exposing-in-extension-land-use-1
  expose-in-extension-land-use-2?
  p-exposing-in-extension-land-use-2
  expose-in-extension-land-use-3?
  p-exposing-in-extension-land-use-3
  credibility-extension-land-use-1
  credibility-extension-land-use-2
  credibility-extension-land-use-3
  
  ;;observing from self  
  info-from-self-land-use-1
  info-from-self-land-use-2
  info-from-self-land-use-3
  
  ;;managing database
  collected-data-land-use-1
  collected-data-land-use-2
  collected-data-land-use-3
  mean-collected-data-land-use-1
  mean-collected-data-land-use-2
  mean-collected-data-land-use-3
  data-storage-land-use-1
  data-storage-land-use-2
  data-storage-land-use-3
  
  ;;learning
  learning-progressiveness
  memory-recall-ability
  recalled-data-land-use-1
  recalled-data-land-use-2
  recalled-data-land-use-3
  
  ;;decision-making
  prioritisation
  enough-capital-to-establish-land-use-1?
  p-generate-capital-to-establish-land-use-1
  enough-capital-to-establish-land-use-2?
  p-generate-capital-to-establish-land-use-2
  enough-capital-to-establish-land-use-3?
  p-generate-capital-to-establish-land-use-3
  convertible-fields-list
  number-convertible-fields
  p-to-adopt-land-use-1
  p-to-adopt-land-use-2
  p-to-adopt-land-use-3
  random-land-use-pot
  selected-land-use-system
  selected-land-use-system-list
]

;;fields' attributes
fields-own
[
  ;;tenurial status
  occupied?  
  
  ;;land lord
  land-holder-id
  
  ;;land use system
  land-use-type
  
  ;;observability by others
  land-use-system-visibility
  
  ;;production
  land-age
  land-stage
  land-size
  land-labor-fraction
  land-labor
  land-yield
  
  ;;economy
  land-costs
  land-profit
  
  ;;knowledge from plot
  land-knowledge
  recalled-field-data
  field-data-storage
  
  ;;dynamics
  land-convertible?
]

;;global variables
globals
[
  ;;constant  
  missing-value
  
  ;;inputs
  
  ;;house-holds' attributes
  
  ;;population
  house-holds-number
  fraction-ethnic-1
  fraction-ethnic-2
  fraction-ethnic-3
  initial-fraction-popular-person
  ethnic-agglomeration
  
  ;;land capital
  mean-fields-number
  cv-fields-number
  land-holder-agglomeration
  maximum-fields-distance 
  fields-distance
  
  ;;labor capital
  mean-labor-capital
  cv-labor-capital
  min-labor-capital
  
  ;;initial knowledge
  mean-initial-knowledge-land-use-1
  cv-initial-knowledge-land-use-1
  mean-initial-knowledge-land-use-2
  cv-initial-knowledge-land-use-2
  mean-initial-knowledge-land-use-3
  cv-initial-knowledge-land-use-3
  
  ;;information network 
  communication-partner-attractiveness
  mean-weight-ethnical-distance
  cv-weight-ethnical-distance
  physical-distance
  mean-weight-physical-distance
  cv-weight-physical-distance
  maximum-physical-distance 
  mean-weight-popularity-person
  cv-weight-popularity-person  
  maximum-partners
  
  ;;diffusion of information
  
  ;;sharing
  mean-p-sharing
  cv-p-sharing
  min-p-sharing
  
  ;;seeking
  mean-p-seeking
  cv-p-seeking
  min-p-seeking
  
  ;;observing from others
  mean-p-observing
  cv-p-observing
  min-p-observing
  mean-observation-relative-distance
  cv-observation-relative-distance
  min-observation-relative-distance
  
  ;;exposing in extension
  extension-land-use-1?
  extension-frequency-land-use-1
  extension-land-use-2?
  extension-frequency-land-use-2
  extension-land-use-3?
  extension-frequency-land-use-3
  mean-p-exposing-in-extension-land-use-1
  cv-p-exposing-in-extension-land-use-1
  min-p-exposing-in-extension-land-use-1
  mean-p-exposing-in-extension-land-use-2
  cv-p-exposing-in-extension-land-use-2
  min-p-exposing-in-extension-land-use-2
  mean-p-exposing-in-extension-land-use-3
  cv-p-exposing-in-extension-land-use-3
  min-p-exposing-in-extension-land-use-3
  suggestion-extension-land-use-1
  mean-suggestion-extension-land-use-1
  cv-suggestion-extension-land-use-1
  min-suggestion-extension-land-use-1
  suggestion-extension-land-use-2
  mean-suggestion-extension-land-use-2
  cv-suggestion-extension-land-use-2
  min-suggestion-extension-land-use-2
  suggestion-extension-land-use-3
  mean-suggestion-extension-land-use-3
  cv-suggestion-extension-land-use-3
  min-suggestion-extension-land-use-3
  mean-credibility-extension-land-use-1
  cv-credibility-extension-land-use-1
  mean-credibility-extension-land-use-2
  cv-credibility-extension-land-use-2
  mean-credibility-extension-land-use-3
  cv-credibility-extension-land-use-3
  
  ;;learning
  mean-learning-progressiveness
  cv-learning-progressiveness
  min-learning-progressiveness
  max-learning-progressiveness
  mean-memory-recall-ability
  cv-memory-recall-ability
  min-memory-recall-ability
  max-memory-recall-ability  
  
  ;;decision-making
  mean-prioritisation
  cv-prioritisation
  min-prioritisation
  max-prioritisation
  mean-p-generate-capital-to-establish-land-use-1
  cv-p-generate-capital-to-establish-land-use-1
  min-p-generate-capital-to-establish-land-use-1
  mean-p-generate-capital-to-establish-land-use-2
  cv-p-generate-capital-to-establish-land-use-2
  min-p-generate-capital-to-establish-land-use-2
  mean-p-generate-capital-to-establish-land-use-3
  cv-p-generate-capital-to-establish-land-use-3
  min-p-generate-capital-to-establish-land-use-3
  
  ;;fields' attributes
  
  ;;initial land use patterns
  initial-land-use-pot
  initial-fraction-land-use-1
  initial-fraction-land-use-2
  initial-fraction-land-use-3
  mean-initial-age-land-use-1
  cv-initial-age-land-use-1
  mean-initial-age-land-use-2
  cv-initial-age-land-use-2
  mean-initial-age-land-use-3
  cv-initial-age-land-use-3
  
  ;;land lord
  land-holder-id-list
  
  ;;field size 
  mean-land-holding-size
  cv-land-holding-size
  min-land-holding-size
  
  ;;field productivity 
  time-bound-stage-1-land-use-1
  time-bound-stage-2-land-use-1
  time-bound-stage-3-land-use-1
  time-bound-stage-4-land-use-1
  time-bound-stage-1-land-use-2
  time-bound-stage-2-land-use-2
  time-bound-stage-3-land-use-2
  time-bound-stage-4-land-use-2
  time-bound-stage-1-land-use-3
  time-bound-stage-2-land-use-3
  time-bound-stage-3-land-use-3
  time-bound-stage-4-land-use-3
  mean-yield-stage-1-land-use-1
  cv-yield-stage-1-land-use-1
  mean-yield-stage-2-land-use-1
  cv-yield-stage-2-land-use-1
  mean-yield-stage-3-land-use-1
  cv-yield-stage-3-land-use-1
  mean-yield-stage-4-land-use-1
  cv-yield-stage-4-land-use-1
  mean-yield-stage-1-land-use-2
  cv-yield-stage-1-land-use-2
  mean-yield-stage-2-land-use-2
  cv-yield-stage-2-land-use-2
  mean-yield-stage-3-land-use-2
  cv-yield-stage-3-land-use-2
  mean-yield-stage-4-land-use-2
  cv-yield-stage-4-land-use-2
  mean-yield-stage-1-land-use-3
  cv-yield-stage-1-land-use-3
  mean-yield-stage-2-land-use-3
  cv-yield-stage-2-land-use-3
  mean-yield-stage-3-land-use-3
  cv-yield-stage-3-land-use-3
  mean-yield-stage-4-land-use-3
  cv-yield-stage-4-land-use-3
  minimum-convertible-age-land-use-1
  minimum-convertible-age-land-use-2
  minimum-convertible-age-land-use-3
  
  ;;observability of fields' performance by others
  mean-land-use-system-visibility-1
  cv-land-use-system-visibility-1
  min-land-use-system-visibility-1
  mean-land-use-system-visibility-2
  cv-land-use-system-visibility-2
  min-land-use-system-visibility-2
  mean-land-use-system-visibility-3
  cv-land-use-system-visibility-3
  min-land-use-system-visibility-3
    
  ;;external factors
  
  ;;price 
  price-commodity-land-use-1
  mean-price-commodity-land-use-1  
  cv-price-commodity-land-use-1
  min-price-commodity-land-use-1
  price-commodity-land-use-2
  mean-price-commodity-land-use-2
  cv-price-commodity-land-use-2
  min-price-commodity-land-use-2
  mean-price-commodity-land-use-3
  cv-price-commodity-land-use-3
  min-price-commodity-land-use-3
  price-commodity-land-use-3
  
  ;;non harvesting labor costs 
  mean-costs-stage-1-land-use-1
  cv-costs-stage-1-land-use-1
  mean-costs-stage-2-land-use-1
  cv-costs-stage-2-land-use-1
  mean-costs-stage-3-land-use-1
  cv-costs-stage-3-land-use-1
  mean-costs-stage-4-land-use-1
  cv-costs-stage-4-land-use-1
  mean-costs-stage-1-land-use-2
  cv-costs-stage-1-land-use-2
  mean-costs-stage-2-land-use-2
  cv-costs-stage-2-land-use-2
  mean-costs-stage-3-land-use-2
  cv-costs-stage-3-land-use-2
  mean-costs-stage-4-land-use-2
  cv-costs-stage-4-land-use-2
  mean-costs-stage-1-land-use-3
  cv-costs-stage-1-land-use-3
  mean-costs-stage-2-land-use-3
  cv-costs-stage-2-land-use-3
  mean-costs-stage-3-land-use-3
  cv-costs-stage-3-land-use-3
  mean-costs-stage-4-land-use-3
  cv-costs-stage-4-land-use-3
  
  ;;working days 
  mean-working-days
  cv-working-days
  min-working-days
  
  ;;labor wage 
  mean-labor-wage
  cv-labor-wage
  min-labor-wage
  labor-wage
  
  ;;simulation
  simulation-time
  input-data
  input-data-file
  input-item-list
  output-data-file
  
  ;;outputs
  
  ;;information network 
  overall-average-popularity
  overall-average-ethnical-homophily
  overall-average-spatial-homophily
  
  ;;diffusion of information
  sharing-by-adopter-land-use-1
  sharing-by-adopter-land-use-2
  sharing-by-adopter-land-use-3
  seeking-by-adopter-land-use-1
  seeking-by-adopter-land-use-2
  seeking-by-adopter-land-use-3
  observing-by-adopter-land-use-1
  observing-by-adopter-land-use-2
  observing-by-adopter-land-use-3
  exposing-to-extension-land-use-1
  exposing-to-extension-land-use-2
  exposing-to-extension-land-use-3
  
  ;;learning
  overall-average-recalled-data-land-use-1
  overall-average-recalled-data-land-use-2
  overall-average-recalled-data-land-use-3
  overall-average-collected-data-land-use-1
  overall-average-collected-data-land-use-2
  overall-average-collected-data-land-use-3
  
  ;;knowledge
  overall-average-knowledge-land-use-1
  overall-average-knowledge-land-use-2
  overall-average-knowledge-land-use-3
  overall-average-plot-knowledge-land-use-1
  overall-average-plot-knowledge-land-use-2
  overall-average-plot-knowledge-land-use-3
  
  ;;labor allocation
  overall-average-labor-land-use-1
  overall-average-labor-land-use-2
  overall-average-labor-land-use-3
  
  ;;adoption
  
  ;;adopters
  adopters-land-use-1-only
  adopters-land-use-2-only
  adopters-land-use-3-only
  adopters-land-use-1-&-2
  adopters-land-use-1-&-3
  adopters-land-use-2-&-3
  adopters-land-use-1-2-&-3
  
  ;;farm size
  overall-average-field-size-land-use-1
  overall-average-field-size-land-use-2
  overall-average-field-size-land-use-3
    
  ;;land use area 
  total-area-land-use-1
  total-area-land-use-2
  total-area-land-use-3
  
  ;;economy
  
  ;;profit
  overall-average-profit-land-use-1
  overall-average-profit-land-use-2
  overall-average-profit-land-use-3
]

;;file name (tab delimited text file) of input data 
to open-input-data-file
  set input-data[]
  user-message "[Adopt&Learn] Please, select the name of input parameters data file after this dialog!"
  let file user-file
  set input-data-file file
  if ( file != false )
  [
    file-open file
    while [ not file-at-end? ]
    [ 
      let data file-read
      ifelse is-number? data
      [
        set input-data lput data input-data
      ]
      [
        set input-data input-data
      ]
    ]
    file-close
  ]  
end

;;read input data from tab delimited text file
to adjust-item-list
  set input-item-list bf input-item-list
end

to read-input-data
  set input-item-list n-values length input-data [?]
  
  ;;house-holds' attributes
  
  ;;population
  set house-holds-number item (first input-item-list) input-data ;;[house holds]
  adjust-item-list
  set fraction-ethnic-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set fraction-ethnic-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set fraction-ethnic-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set initial-fraction-popular-person item (first input-item-list) input-data ;;[]
  adjust-item-list
  set ethnic-agglomeration item (first input-item-list) input-data ;;[0-1, very dispersed to very agglomerated]
  adjust-item-list
    
  ;;land capital
  set mean-fields-number item (first input-item-list) input-data ;;[fields by household]
  adjust-item-list
  set cv-fields-number item (first input-item-list) input-data ;;[]
  adjust-item-list
  set land-holder-agglomeration item (first input-item-list) input-data ;;[0-1, very dispersed to very agglomerated]
  adjust-item-list
  
  ;;labor capital 
  set mean-labor-capital item (first input-item-list) input-data ;;[men]
  adjust-item-list
  set cv-labor-capital  item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-labor-capital item (first input-item-list) input-data ;;[men]
  adjust-item-list
  
  ;;initial knowledge 
  set mean-initial-knowledge-land-use-1 item (first input-item-list) input-data ;;[profit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-initial-knowledge-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-initial-knowledge-land-use-2 item (first input-item-list) input-data ;;[profit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-initial-knowledge-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-initial-knowledge-land-use-3 item (first input-item-list) input-data ;;[profit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-initial-knowledge-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  
  ;;information network 
  set mean-weight-ethnical-distance item (first input-item-list) input-data ;;[0-1, not concerned to highly concerned]
  adjust-item-list
  set cv-weight-ethnical-distance item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-weight-physical-distance item (first input-item-list) input-data ;;[0-1, not concerned to highly concerned]
  adjust-item-list
  set cv-weight-physical-distance item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-weight-popularity-person item (first input-item-list) input-data ;;[0-1, not concerned to highly concerned]
  adjust-item-list
  set cv-weight-popularity-person item (first input-item-list) input-data  ;;[]
  adjust-item-list
  
  ;;diffusion of information
  
  ;;sharing
  set mean-p-sharing item (first input-item-list) input-data ;;[]
  adjust-item-list
  set cv-p-sharing item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-p-sharing item (first input-item-list) input-data ;;[]
  adjust-item-list
  
  ;;seeking
  set mean-p-seeking item (first input-item-list) input-data ;;[]
  adjust-item-list
  set cv-p-seeking item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-p-seeking item (first input-item-list) input-data ;;[]
  adjust-item-list
  
  ;;observing from others
  set mean-p-observing item (first input-item-list) input-data ;;[]
  adjust-item-list
  set cv-p-observing item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-p-observing item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-observation-relative-distance item (first input-item-list) input-data ;;[0-1, very close to very far]
  adjust-item-list
  set cv-observation-relative-distance item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-observation-relative-distance item (first input-item-list) input-data ;;[0-1, very close to very far]
  adjust-item-list
  
  ;;exposing in extension  
  set extension-frequency-land-use-1 item (first input-item-list) input-data ;;[0-1, relative frequency]
  adjust-item-list
  set extension-frequency-land-use-2 item (first input-item-list) input-data ;;[0-1, relative frequency]
  adjust-item-list
  set extension-frequency-land-use-3 item (first input-item-list) input-data ;;[0-1, relative frequency]
  adjust-item-list
  set mean-p-exposing-in-extension-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set cv-p-exposing-in-extension-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-p-exposing-in-extension-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-p-exposing-in-extension-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set cv-p-exposing-in-extension-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-p-exposing-in-extension-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-p-exposing-in-extension-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set cv-p-exposing-in-extension-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-p-exposing-in-extension-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-suggestion-extension-land-use-1 item (first input-item-list) input-data ;;[profit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-suggestion-extension-land-use-1 item (first input-item-list) input-data  ;;[]
  adjust-item-list
  set min-suggestion-extension-land-use-1 item (first input-item-list) input-data ;;[profit.man-1.day-1.area unit-1]
  adjust-item-list
  set mean-suggestion-extension-land-use-2 item (first input-item-list) input-data ;;[profit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-suggestion-extension-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-suggestion-extension-land-use-2 item (first input-item-list) input-data ;;[profit.man-1.day-1.area unit-1]
  adjust-item-list
  set mean-suggestion-extension-land-use-3 item (first input-item-list) input-data ;;[profit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-suggestion-extension-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-suggestion-extension-land-use-3 item (first input-item-list) input-data ;;[profit.man-1.day-1.area unit-1]
  adjust-item-list
  set mean-credibility-extension-land-use-1 item (first input-item-list) input-data ;;[0-1, not credible to very credible]
  adjust-item-list
  set cv-credibility-extension-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-credibility-extension-land-use-2 item (first input-item-list) input-data ;;[0-1, not credible to very credible]
  adjust-item-list
  set cv-credibility-extension-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-credibility-extension-land-use-3 item (first input-item-list) input-data ;;[0-1, not credible to very credible]
  adjust-item-list
  set cv-credibility-extension-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  
  ;;learning
  set mean-learning-progressiveness item (first input-item-list) input-data ;;[]
  adjust-item-list
  set cv-learning-progressiveness item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-learning-progressiveness item (first input-item-list) input-data ;;[]
  adjust-item-list
  set max-learning-progressiveness item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-memory-recall-ability item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set cv-memory-recall-ability item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-memory-recall-ability item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set max-memory-recall-ability item (first input-item-list) input-data ;;[years]
  adjust-item-list
  
  ;;decision-making  
  set mean-prioritisation item (first input-item-list) input-data ;;[]
  adjust-item-list
  set cv-prioritisation item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-prioritisation item (first input-item-list) input-data ;;[]
  adjust-item-list
  set max-prioritisation item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-p-generate-capital-to-establish-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set cv-p-generate-capital-to-establish-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-p-generate-capital-to-establish-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-p-generate-capital-to-establish-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set cv-p-generate-capital-to-establish-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-p-generate-capital-to-establish-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-p-generate-capital-to-establish-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set cv-p-generate-capital-to-establish-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-p-generate-capital-to-establish-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  
  ;;fields' attributes
  
  ;;initial land use patterns
  set initial-fraction-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set initial-fraction-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set initial-fraction-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-initial-age-land-use-1 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set cv-initial-age-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-initial-age-land-use-2 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set cv-initial-age-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-initial-age-land-use-3 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set cv-initial-age-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  
  ;;fields size 
  set mean-land-holding-size item (first input-item-list) input-data ;;[area unit]
  adjust-item-list
  set cv-land-holding-size item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-land-holding-size item (first input-item-list) input-data ;;[area unit]
  adjust-item-list
  
  ;;field productivity 
  set time-bound-stage-1-land-use-1 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set time-bound-stage-2-land-use-1 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set time-bound-stage-3-land-use-1 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set time-bound-stage-4-land-use-1 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set time-bound-stage-1-land-use-2 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set time-bound-stage-2-land-use-2 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set time-bound-stage-3-land-use-2 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set time-bound-stage-4-land-use-2 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set time-bound-stage-1-land-use-3 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set time-bound-stage-2-land-use-3 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set time-bound-stage-3-land-use-3 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set time-bound-stage-4-land-use-3 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set mean-yield-stage-1-land-use-1 item (first input-item-list) input-data ;;[yield unit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-yield-stage-1-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-yield-stage-2-land-use-1 item (first input-item-list) input-data ;;[yield unit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-yield-stage-2-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-yield-stage-3-land-use-1 item (first input-item-list) input-data ;;[yield unit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-yield-stage-3-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-yield-stage-4-land-use-1 item (first input-item-list) input-data ;;[yield unit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-yield-stage-4-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-yield-stage-1-land-use-2 item (first input-item-list) input-data ;;[yield unit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-yield-stage-1-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-yield-stage-2-land-use-2 item (first input-item-list) input-data ;;[yield unit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-yield-stage-2-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-yield-stage-3-land-use-2 item (first input-item-list) input-data ;;[yield unit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-yield-stage-3-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-yield-stage-4-land-use-2 item (first input-item-list) input-data ;;[yield unit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-yield-stage-4-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-yield-stage-1-land-use-3 item (first input-item-list) input-data ;;[yield unit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-yield-stage-1-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-yield-stage-2-land-use-3 item (first input-item-list) input-data ;;[yield unit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-yield-stage-2-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-yield-stage-3-land-use-3 item (first input-item-list) input-data ;;[yield unit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-yield-stage-3-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-yield-stage-4-land-use-3 item (first input-item-list) input-data ;;[yield unit.man-1.day-1.area unit-1]
  adjust-item-list
  set cv-yield-stage-4-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set minimum-convertible-age-land-use-1 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set minimum-convertible-age-land-use-2 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  set minimum-convertible-age-land-use-3 item (first input-item-list) input-data ;;[years]
  adjust-item-list
  
  ;;observability of fields' performance by others  
  set mean-land-use-system-visibility-1 item (first input-item-list) input-data ;;[0-1, not visible to very visible]
  adjust-item-list
  set cv-land-use-system-visibility-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-land-use-system-visibility-1 item (first input-item-list) input-data ;;[0-1, not visible to very visible]
  adjust-item-list
  set mean-land-use-system-visibility-2 item (first input-item-list) input-data ;;[0-1, not visible to very visible]
  adjust-item-list
  set cv-land-use-system-visibility-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-land-use-system-visibility-2 item (first input-item-list) input-data ;;[0-1, not visible to very visible]
  adjust-item-list
  set mean-land-use-system-visibility-3 item (first input-item-list) input-data ;;[0-1, not visible to very visible]
  adjust-item-list
  set cv-land-use-system-visibility-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-land-use-system-visibility-3 item (first input-item-list) input-data ;;[0-1, not visible to very visible]
  adjust-item-list
  
  ;;external factors
  
  ;;price
  set mean-price-commodity-land-use-1 item (first input-item-list) input-data ;;[price.yield unit-1]
  adjust-item-list
  set cv-price-commodity-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-price-commodity-land-use-1 item (first input-item-list) input-data ;;[price.yield unit-1]
  adjust-item-list
  set mean-price-commodity-land-use-2 item (first input-item-list) input-data ;;[price.yield unit-1]
  adjust-item-list
  set cv-price-commodity-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-price-commodity-land-use-2 item (first input-item-list) input-data ;;[price.yield unit-1]
  adjust-item-list
  set mean-price-commodity-land-use-3 item (first input-item-list) input-data ;;[price.yield unit-1]
  adjust-item-list
  set cv-price-commodity-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-price-commodity-land-use-3 item (first input-item-list) input-data ;;[price.yield unit-1]
  adjust-item-list
  
  ;;non harvesting labor cost
  set mean-costs-stage-1-land-use-1 item (first input-item-list) input-data ;;[cost.area unit-1]
  adjust-item-list
  set cv-costs-stage-1-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-costs-stage-2-land-use-1 item (first input-item-list) input-data ;;[cost.area unit-1]
  adjust-item-list
  set cv-costs-stage-2-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-costs-stage-3-land-use-1 item (first input-item-list) input-data ;;[cost.area unit-1]
  adjust-item-list
  set cv-costs-stage-3-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-costs-stage-4-land-use-1 item (first input-item-list) input-data ;;[cost.area unit-1]
  adjust-item-list
  set cv-costs-stage-4-land-use-1 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-costs-stage-1-land-use-2 item (first input-item-list) input-data ;;[cost.area unit-1]
  adjust-item-list
  set cv-costs-stage-1-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-costs-stage-2-land-use-2 item (first input-item-list) input-data ;;[cost.area unit-1]
  adjust-item-list
  set cv-costs-stage-2-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-costs-stage-3-land-use-2 item (first input-item-list) input-data ;;[cost.area unit-1]
  adjust-item-list
  set cv-costs-stage-3-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-costs-stage-4-land-use-2 item (first input-item-list) input-data ;;[cost.area unit-1]
  adjust-item-list
  set cv-costs-stage-4-land-use-2 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-costs-stage-1-land-use-3 item (first input-item-list) input-data ;;[cost.area unit-1]
  adjust-item-list
  set cv-costs-stage-1-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-costs-stage-2-land-use-3 item (first input-item-list) input-data ;;[cost.area unit-1]
  adjust-item-list
  set cv-costs-stage-2-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-costs-stage-3-land-use-3 item (first input-item-list) input-data ;;[cost.area unit-1]
  adjust-item-list
  set cv-costs-stage-3-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  set mean-costs-stage-4-land-use-3 item (first input-item-list) input-data ;;[cost.area unit-1]
  adjust-item-list
  set cv-costs-stage-4-land-use-3 item (first input-item-list) input-data ;;[]
  adjust-item-list
  
  ;;working days
  set mean-working-days item (first input-item-list) input-data ;;[days]
  adjust-item-list
  set cv-working-days item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-working-days item (first input-item-list) input-data ;;[days]
  adjust-item-list
  
  ;;labor wage
  set mean-labor-wage item (first input-item-list) input-data ;;[wage.man-1.day-1]
  adjust-item-list
  set cv-labor-wage item (first input-item-list) input-data ;;[]
  adjust-item-list
  set min-labor-wage item (first input-item-list) input-data ;;[wage.man-1.day-1]
  adjust-item-list
end

;;initialisation

;;initialise information network
to initialise-network
  find-partner
end

;;initialise global variables
to initialise-global
  set extension-land-use-1? false
  set extension-land-use-2? false
  set extension-land-use-3? false
end

;;initialise households
to initialise-house-holds
  set-default-shape house-holds "person"
  create-custom-house-holds house-holds-number
  [
    ht
    setxy random-xcor random-ycor
    set weight-ethnical-distance min list 1 max list 0 random-normal mean-weight-ethnical-distance (cv-weight-ethnical-distance * mean-weight-ethnical-distance)
    set weight-physical-distance min list 1 max list 0 random-normal mean-weight-physical-distance (cv-weight-physical-distance * mean-weight-physical-distance)    
    set weight-popularity-person min list 1 max list 0 random-normal mean-weight-popularity-person (cv-weight-popularity-person * mean-weight-popularity-person)
    set fields-number round max list 1 random-normal mean-fields-number (cv-fields-number * mean-fields-number)
    set knowledge-land-use-1 max list 0 random-normal mean-initial-knowledge-land-use-1 (cv-initial-knowledge-land-use-1 * mean-initial-knowledge-land-use-1)
    set knowledge-land-use-2 max list 0 random-normal mean-initial-knowledge-land-use-2 (cv-initial-knowledge-land-use-2 * mean-initial-knowledge-land-use-2)
    set knowledge-land-use-3 max list 0 random-normal mean-initial-knowledge-land-use-3 (cv-initial-knowledge-land-use-3 * mean-initial-knowledge-land-use-3)
    set data-storage-land-use-1[]
    set data-storage-land-use-2[]
    set data-storage-land-use-3[]
    set share? false
    set seek? false
    set observe? false
    set expose-in-extension-land-use-1? false
    set expose-in-extension-land-use-2? false
    set expose-in-extension-land-use-3? false
    set observation-fields-list[]
      
    let random-ethnic random-float 1.00  
    ifelse random-ethnic < fraction-ethnic-1
    [
      set ethnic-type 1
      set color red
    ]
    [
      ifelse random-ethnic < fraction-ethnic-1 + fraction-ethnic-2
      [
        set ethnic-type 2
        set color green
      ]
      [
        set ethnic-type 3
        set color blue
      ]
    ]
    ifelse random-float 1.00 < initial-fraction-popular-person
    [
      set house-hold-popularity 1
    ]
    [
      set house-hold-popularity 0
    ]    
  ]
  
  agglomerate-ethnic
  
  ask house-holds
  [
    set original-x xcor
    set original-y ycor
  ]
  measure-maximum-physical-distance  
end

;;initialise fields
to initialise-fields  
  let land-holder-id-list-1[]
  ask house-holds
  [
    set land-holder-id-list-1 fput n-values fields-number-of house-hold who [who] land-holder-id-list-1
  ]
  
  let land-holder-id-list-2[]
  let land-holder-id-list-3[]
  let counter 0
  ifelse (count house-holds) mod 2 = 0
  [
    while [counter < (count house-holds) - 1]
    [
      set land-holder-id-list-2 sentence item counter land-holder-id-list-1 item (counter + 1) land-holder-id-list-1
      set land-holder-id-list-3 sentence land-holder-id-list-2 land-holder-id-list-3
      set counter counter + 2
    ]
  ]
  [
    while [counter < (count house-holds) - 1]
    [
      set land-holder-id-list-2 sentence item counter land-holder-id-list-1 item (counter + 1) land-holder-id-list-1
      set land-holder-id-list-3 sentence land-holder-id-list-2 land-holder-id-list-3
      set counter counter + 2
    ]
    set land-holder-id-list-3 sentence item ((count house-holds) - 1) land-holder-id-list-1 land-holder-id-list-3
  ]
 
  set land-holder-id-list-3 sort land-holder-id-list-3
  set land-holder-id-list sort remove-duplicates land-holder-id-list-3
  
  set initial-land-use-pot 
  sentence n-values round(sum values-from house-holds[fields-number] * initial-fraction-land-use-1) [1]
  sentence n-values round(sum values-from house-holds[fields-number] * initial-fraction-land-use-2) [2]
  n-values round(sum values-from house-holds[fields-number] * initial-fraction-land-use-3) [3]
  
  while [length initial-land-use-pot < sum values-from house-holds[fields-number]]
  [
    set initial-land-use-pot fput round(1 + random 3) initial-land-use-pot
  ]
  
  without-interruption
  [
    create-custom-fields (sum values-from house-holds[fields-number])
    [   
      ht
      setxy random-xcor random-ycor
      set occupied? true
      set land-holder-id item 0 land-holder-id-list-3
      set land-holder-id-list-3 remove-item 0 land-holder-id-list-3
      set land-size max list min-land-holding-size random-normal mean-land-holding-size (cv-land-holding-size * mean-land-holding-size)
      set field-data-storage[]
      let random-land-use random-float 1.00
      set land-use-type one-of shuffle initial-land-use-pot
      set initial-land-use-pot remove-item position land-use-type initial-land-use-pot initial-land-use-pot
    ]
  ]
  
  ask fields
  [
    set shape one-of shuffle["parcel1" "parcel2" "parcel3" "parcel4" "parcel5" "parcel6" "parcel7" "parcel8" "parcel9" "parcel10"]
    if land-use-type = 1
    [
      set land-age max list 0 round random-normal mean-initial-age-land-use-1 (cv-initial-age-land-use-1 * mean-initial-age-land-use-1)
      set land-knowledge knowledge-land-use-1-of house-hold land-holder-id
    ]
    if land-use-type = 2
    [
      set land-age max list 0 round random-normal mean-initial-age-land-use-2 (cv-initial-age-land-use-2 * mean-initial-age-land-use-2)
      set land-knowledge knowledge-land-use-2-of house-hold land-holder-id
    ]
    if land-use-type = 3
    [
      set land-age max list 0 round random-normal mean-initial-age-land-use-3 (cv-initial-age-land-use-3 * mean-initial-age-land-use-3)
      set land-knowledge knowledge-land-use-3-of house-hold land-holder-id
    ]
  ]
  
  agglomerate-fields 
end

;;agglomerate community by ethnic
to agglomerate-ethnic
  without-interruption
  [
    ask house-holds
    [
      let source who
      ask house-holds with [self != myself]
      [
        let target who
        if ethnic-type-of house-hold target = ethnic-type-of house-hold source
        [
          facexy xcor-of house-hold source ycor-of house-hold source
          jump max list 0 ((distance house-hold source) * ethnic-agglomeration - 1)
        ]
      ]
    ]
  ]
  
  repeat count house-holds
  [
    __layout-spring house-holds 0 0 1
  ]
end

;;agglomerate fields by land holder
to agglomerate-fields
  without-interruption
  [
    ask fields
    [
      let source who
      ask fields with [self != myself]
      [
        let target who
        if land-holder-id-of field target = land-holder-id-of field source
        [
          facexy xcor-of field source ycor-of field source
          jump max list 0 ((distance field source) * land-holder-agglomeration - 1)
        ]
      ]      
    ]
  ]
  
  repeat count fields
  [
    __layout-spring fields 0 0 1
  ]
end

;;agglomerate fields by land holder
to-report measure-physical-distance[source partner]
  ask house-hold source
  [
    set physical-distance distancexy original-x-of house-hold partner original-y-of house-hold partner
  ]
  report physical-distance
end

;;measure maximum physical distance of neighboring households
to measure-maximum-physical-distance
  let distance-list []
  ask house-holds
  [
    let agent1 who
    ask house-holds with [self != myself]
    [
      let agent2 who
      set distance-list fput measure-physical-distance agent1 agent2 distance-list
    ]
  ]
  set maximum-physical-distance max distance-list
end

;;evaluate attractiveness of others as communication partner
to evaluate-partners
  without-interruption
  [
    ask house-holds
    [
      let source who
      set total-partner-attractiveness-of house-hold source 0
      ask house-holds with [self != myself]
      [
        let partner who
        let popularity house-hold-popularity-of house-hold partner
        let physic-distance (measure-physical-distance source partner) / maximum-physical-distance
        let ethnic-distance min list 1 abs(ethnic-type-of house-hold source - ethnic-type-of house-hold partner)
        let communication-attractiveness (1 + 100 * weight-popularity-person-of house-hold source * popularity) / (1 + 100 * weight-ethnical-distance-of house-hold source * ethnic-distance + 100 * weight-physical-distance-of house-hold source * physic-distance)
        set total-partner-attractiveness-of house-hold source total-partner-attractiveness-of house-hold source + communication-attractiveness
      ]
    ]
  ]  
end

;;find the best partner to communicate
to find-partner
  evaluate-partners  
  without-interruption
  [
    ask house-holds
    [
      let source who
      let pick random-float total-partner-attractiveness-of house-hold source
      set selected-partner-of house-hold source nobody
      ask house-holds with [self != myself]
      [
        let partner who
        let popularity house-hold-popularity
        let physic-distance (measure-physical-distance source partner) / maximum-physical-distance
        let ethnic-distance min list 1 abs(ethnic-type-of house-hold source - ethnic-type-of house-hold partner)
        let communication-attractiveness (1 + 100 * weight-popularity-person-of house-hold source * popularity) / (1 + 100 * weight-ethnical-distance-of house-hold source * ethnic-distance + 100 * weight-physical-distance-of house-hold source * physic-distance)
        if selected-partner-of house-hold source = nobody
        [
          ifelse communication-attractiveness > pick
          [
            set selected-partner-of house-hold source self
          ]
          [
            set pick pick - communication-attractiveness
          ]        
        ]
      ]  
    ]
  ]
  ask links
  [
    die
  ]
  without-interruption
  [
    ask house-holds
    [
      let source who
      ask house-hold source
      [
        if not __link-neighbor? selected-partner-of house-hold source
        [
          __create-link-with selected-partner-of house-hold source [ht]
        ]
      ]
    ]
  ]
end

;;visualisation

;;select type of visualisation: fields dynamics or communication network 
to visualise  
  ifelse show-network?
  [
    display
    show-house-holds
    hide-fields
  ]
  [
    display
    show-fields
    hide-house-holds
  ]
end

;;visualise communication network of households
to show-house-holds
  ask links
  [
    st
    set color grey - 3
  ]
  let max-popularity max values-from house-holds [1 + house-hold-popularity]
  ask house-holds
  [
    st
    set size ((1 + house-hold-popularity) / max-popularity) * zoom
  ]
end

;;layout communication network of households for better visualisation
to layout-network
  __layout-spring house-holds 0.2 5 1
  visualise
end

;;hide communication network of households
to hide-house-holds
  ask house-holds
  [
    ht
  ]
  ask links
  [
    ht
  ]
end

;;show fields
to show-fields
  let max-size max values-from fields [land-size]
  ask fields
  [
    st
    set size (land-size / max-size) * zoom
    if land-use-type = 1 
    [
      set color red 
    ]
    if land-use-type = 2 
    [
      set color green
    ]
    if land-use-type = 3 
    [
      set color blue
    ]
  ]
end

;;hide fields
to hide-fields
  ask fields
  [
    ht
  ]
end

;;setup initialisation
to setup
  ca
  no-display
  set simulation-time 0
  set missing-value (-1 * 10 ^ 31)
  open-input-data-file
  ask-for-output-file
  make-header
  read-input-data
  initialise-global
  initialise-house-holds
  initialise-network
  initialise-fields
  visualise
end

;;dynamic modules

;;main simulation module
to go
  ifelse simulation-time < simulation-duration
  [
    visualise
    simulate-dynamic-modules
    record-results
    set simulation-time simulation-time + 1
  ]
  [
    file-open output-data-file
    file-print "\n"
    file-close
    user-message "[Adopt&Learn] Simulation is done!"
    stop
  ]
end

;;content of simulation
to simulate-dynamic-modules 
  ;;Check here
  ;;xxx
  parameterise-house-holds
  find-partner
  parameterise-fields
  define-land-stage
  check-house-holds-fields
  generate-labor-capital
  allocate-labor
  harvest-fields 
  generate-price
  calculate-costs
  calculate-profit
  observe-from-self
  observe-from-others
  exchange-information
  generate-extension
  expose-in-extension
  collect-data
  recall-memory
  recall-field-memory
  generate-capital-for-establishment
  consider-options
  define-convertible-fields
  
  summarise-outputs
  plot-outputs
  
  convert-fields  
  learn    
end

;;parameterise households' attributes
to parameterise-house-holds
  ask house-holds
  [    
    setxy original-x original-y
    
    ifelse max values-from  house-holds [count __link-neighbors] > 0
    [
      set house-hold-popularity count __link-neighbors / max values-from  house-holds [count __link-neighbors]
    ]
    [
      set house-hold-popularity 0
    ]
    set weight-ethnical-distance min list 1 max list 0 random-normal mean-weight-ethnical-distance (cv-weight-ethnical-distance * mean-weight-ethnical-distance)
    set weight-physical-distance min list 1 max list 0 random-normal mean-weight-physical-distance (cv-weight-physical-distance * mean-weight-physical-distance)    
    set weight-popularity-person min list 1 max list 0 random-normal mean-weight-popularity-person (cv-weight-popularity-person * mean-weight-popularity-person)
    set prioritisation min list max-prioritisation (max list min-prioritisation random-normal mean-prioritisation (cv-prioritisation * mean-prioritisation))
    set p-sharing min list 1 max list min-p-sharing random-normal mean-p-sharing (cv-p-sharing * mean-p-sharing)
    set p-seeking min list 1 max list min-p-seeking random-normal mean-p-seeking (cv-p-seeking * mean-p-seeking)
    set p-observing min list 1 max list min-p-observing random-normal mean-p-observing (cv-p-observing * mean-p-observing)
    set p-exposing-in-extension-land-use-1 min list 1 max list min-p-exposing-in-extension-land-use-1 random-normal mean-p-exposing-in-extension-land-use-1 (cv-p-exposing-in-extension-land-use-1 * mean-p-exposing-in-extension-land-use-1)
    set p-exposing-in-extension-land-use-2 min list 1 max list min-p-exposing-in-extension-land-use-2 random-normal mean-p-exposing-in-extension-land-use-2 (cv-p-exposing-in-extension-land-use-2 * mean-p-exposing-in-extension-land-use-2)
    set p-exposing-in-extension-land-use-3 min list 1 max list min-p-exposing-in-extension-land-use-3 random-normal mean-p-exposing-in-extension-land-use-3 (cv-p-exposing-in-extension-land-use-3 * mean-p-exposing-in-extension-land-use-3)
    set observation-relative-distance min list 1 max list min-observation-relative-distance random-normal mean-observation-relative-distance (cv-observation-relative-distance * mean-observation-relative-distance)
    set learning-progressiveness min list max-learning-progressiveness (max list min-learning-progressiveness random-normal mean-learning-progressiveness (cv-learning-progressiveness * mean-learning-progressiveness))    
    set memory-recall-ability min list max-memory-recall-ability (max list min-memory-recall-ability random-normal mean-memory-recall-ability (cv-memory-recall-ability * mean-memory-recall-ability))
    set p-generate-capital-to-establish-land-use-1 min list 1 max list min-p-generate-capital-to-establish-land-use-1 random-normal mean-p-generate-capital-to-establish-land-use-1 (cv-p-generate-capital-to-establish-land-use-1 * mean-p-generate-capital-to-establish-land-use-1)
    set p-generate-capital-to-establish-land-use-2 min list 1 max list min-p-generate-capital-to-establish-land-use-2 random-normal mean-p-generate-capital-to-establish-land-use-2 (cv-p-generate-capital-to-establish-land-use-2 * mean-p-generate-capital-to-establish-land-use-2)
    set p-generate-capital-to-establish-land-use-3 min list 1 max list min-p-generate-capital-to-establish-land-use-3 random-normal mean-p-generate-capital-to-establish-land-use-3 (cv-p-generate-capital-to-establish-land-use-3 * mean-p-generate-capital-to-establish-land-use-3)
    set credibility-extension-land-use-1 min list 1 max list 0 random-normal mean-credibility-extension-land-use-1 (cv-credibility-extension-land-use-1 * mean-credibility-extension-land-use-1)
    set credibility-extension-land-use-2 min list 1 max list 0 random-normal mean-credibility-extension-land-use-2 (cv-credibility-extension-land-use-2 * mean-credibility-extension-land-use-2)
    set credibility-extension-land-use-3 min list 1 max list 0 random-normal mean-credibility-extension-land-use-3 (cv-credibility-extension-land-use-3 * mean-credibility-extension-land-use-3)
  ]
end

;;parameterise fields' attributes
to parameterise-fields
  ask fields
  [
    if land-use-type = 1
    [
      set land-use-system-visibility
      min list 1 max list min-land-use-system-visibility-1 
      random-normal mean-land-use-system-visibility-1 
      (cv-land-use-system-visibility-1 * 
      mean-land-use-system-visibility-1)
    ]
    if land-use-type = 2
    [
      set land-use-system-visibility
      min list 1 max list min-land-use-system-visibility-2
      random-normal mean-land-use-system-visibility-2
      (cv-land-use-system-visibility-2 * 
      mean-land-use-system-visibility-2)
    ]
    if land-use-type = 3
    [
      set land-use-system-visibility
      min list 1 max list min-land-use-system-visibility-3
      random-normal mean-land-use-system-visibility-3
      (cv-land-use-system-visibility-3 * 
      mean-land-use-system-visibility-3)
    ]
  ]
end

;;check what kind of land use system practiced by each house-hold on their fields
to check-house-holds-fields
  ask house-holds
  [
    ifelse (count fields with [land-holder-id = who-of myself and land-use-type = 1]) > 0
    [
      set own-land-use-1? 1
    ]
    [
      set own-land-use-1? 0
    ]
    ifelse (count fields with [land-holder-id = who-of myself and land-use-type = 2]) > 0
    [
      set own-land-use-2? 1
    ]
    [
      set own-land-use-2? 0
    ]
    ifelse (count fields with [land-holder-id = who-of myself and land-use-type = 3]) > 0
    [
      set own-land-use-3? 1
    ]
    [
      set own-land-use-3? 0
    ]
    
    set number-land-use-1 count fields with [land-holder-id = who-of myself and land-use-type = 1]
    set number-land-use-2 count fields with [land-holder-id = who-of myself and land-use-type = 2]
    set number-land-use-3 count fields with [land-holder-id = who-of myself and land-use-type = 3]
  ]
end

;;generate labor capital of each house-hold
to generate-labor-capital
  ask house-holds
  [
    set labor-capital 
    (max list min-working-days random-normal mean-working-days (cv-working-days * mean-working-days)) *
    round (max list min-labor-capital random-normal mean-labor-capital (cv-labor-capital * mean-labor-capital))
  ]
end

;;allocate labor to each field
to allocate-labor
  ;;allocate labors based on general knowledge
  ask house-holds
  [
    let total (
    (own-land-use-1? * (knowledge-land-use-1 ^ prioritisation)) +
    (own-land-use-2? * (knowledge-land-use-2 ^ prioritisation)) +
    (own-land-use-3? * (knowledge-land-use-3 ^ prioritisation)))
    
    let totalsystem (own-land-use-1? + own-land-use-2? + own-land-use-3?)
    
    ifelse total > 0
    [      
      set labor-fraction-land-use-1 ((own-land-use-1? * (knowledge-land-use-1 ^ prioritisation)) / total)
      set labor-fraction-land-use-2 ((own-land-use-2? * (knowledge-land-use-2 ^ prioritisation)) / total)
      set labor-fraction-land-use-3 ((own-land-use-3? * (knowledge-land-use-3 ^ prioritisation)) / total)
    ]
    [
      ;;no knowledge, consider possible systems practiced in plot
      ifelse totalsystem > 0
      [
        set labor-fraction-land-use-1 (own-land-use-1? / totalsystem)
        set labor-fraction-land-use-2 (own-land-use-2? / totalsystem)
        set labor-fraction-land-use-3 (own-land-use-3? / totalsystem)
      ]
      [
        ;;no knowledge, no systems practiced, no labor allocation
        set labor-fraction-land-use-1 0
        set labor-fraction-land-use-2 0
        set labor-fraction-land-use-3 0
      ]
    ]
  ]
  
  ;;allocate labors based on plot knowledge
  without-interruption
  [
    foreach land-holder-id-list
    [
      set total-knowledge-from-plot-land-use-1-of house-hold ? 0
      set total-knowledge-from-plot-land-use-2-of house-hold ? 0
      set total-knowledge-from-plot-land-use-3-of house-hold ? 0
      
      ask fields
      [
        if land-holder-id = ? and land-use-type = 1
        [
          set total-knowledge-from-plot-land-use-1-of house-hold ?
          total-knowledge-from-plot-land-use-1-of house-hold ? +
          land-knowledge ^ prioritisation-of house-hold ?
        ]
        if land-holder-id = ? and land-use-type = 2
        [
          set total-knowledge-from-plot-land-use-2-of house-hold ?
          total-knowledge-from-plot-land-use-2-of house-hold ? +
          land-knowledge ^ prioritisation-of house-hold ?
        ]
        if land-holder-id = ? and land-use-type = 3
        [
          set total-knowledge-from-plot-land-use-3-of house-hold ?
          total-knowledge-from-plot-land-use-3-of house-hold ? +
          land-knowledge ^ prioritisation-of house-hold ?
        ]
      ]
    ]
  ]
  ask fields
  [
    if land-use-type = 1
    [
      ifelse total-knowledge-from-plot-land-use-1-of house-hold land-holder-id > 0
      [
        set land-labor-fraction
        (land-knowledge ^ prioritisation-of house-hold land-holder-id) /
        total-knowledge-from-plot-land-use-1-of house-hold land-holder-id
      ]
      [
        ifelse number-land-use-1-of house-hold land-holder-id > 0
        [
          ;;no ideas? allocate uniformly!
          set land-labor-fraction 1 / number-land-use-1-of house-hold land-holder-id
        ]
        [
          ;;currently has no land use of this type
          set land-labor-fraction 0
        ]
      ]
    ]
    if land-use-type = 2
    [
      ifelse total-knowledge-from-plot-land-use-2-of house-hold land-holder-id > 0
      [
        set land-labor-fraction
        (land-knowledge ^ prioritisation-of house-hold land-holder-id) /
        total-knowledge-from-plot-land-use-2-of house-hold land-holder-id
      ]
      [
        ifelse number-land-use-2-of house-hold land-holder-id > 0
        [
          ;;no ideas? allocate uniformly!
          set land-labor-fraction 1 / number-land-use-2-of house-hold land-holder-id
        ]
        [
          ;;currently has no land use of this type
          set land-labor-fraction 0
        ]
      ]
    ]
    if land-use-type = 3
    [
      ifelse total-knowledge-from-plot-land-use-3-of house-hold land-holder-id > 0
      [
        set land-labor-fraction
        (land-knowledge ^ prioritisation-of house-hold land-holder-id) /
        total-knowledge-from-plot-land-use-3-of house-hold land-holder-id
      ]
      [
        ifelse number-land-use-3-of house-hold land-holder-id > 0
        [
          ;;no ideas? allocate uniformly!
          set land-labor-fraction 1 / number-land-use-3-of house-hold land-holder-id
        ]
        [
          ;;currently has no land use of this type
          set land-labor-fraction 0
        ]
      ]
    ]
  ]
  
  ;;allocate labor to each field
  ask fields
  [
    if land-use-type = 1
    [
      set land-labor
      (land-labor-fraction * 
      labor-fraction-land-use-1-of house-hold land-holder-id *
      labor-capital-of house-hold land-holder-id)
    ]
    if land-use-type = 2
    [
      set land-labor
      (land-labor-fraction * 
      labor-fraction-land-use-2-of house-hold land-holder-id *
      labor-capital-of house-hold land-holder-id)
    ]
    if land-use-type = 3
    [
      set land-labor
      (land-labor-fraction * 
      labor-fraction-land-use-3-of house-hold land-holder-id *
      labor-capital-of house-hold land-holder-id)
    ]
  ]
end

;;define productional stage of each field based on age
to define-land-stage
  ask fields
  [
    if land-use-type = 1
    [
      if (land-age >= time-bound-stage-1-land-use-1) and (land-age < time-bound-stage-2-land-use-1)
      [
        set land-stage 1
      ]
      if (land-age >= time-bound-stage-2-land-use-1) and (land-age < time-bound-stage-3-land-use-1)
      [
        set land-stage 2
      ]
      if (land-age >= time-bound-stage-3-land-use-1) and (land-age < time-bound-stage-4-land-use-1)
      [
        set land-stage 3
      ]
      if (land-age >= time-bound-stage-4-land-use-1)
      [
        set land-stage 4
      ]
    ]
    if land-use-type = 2
    [
      if (land-age >= time-bound-stage-1-land-use-2) and (land-age < time-bound-stage-2-land-use-2)
      [
        set land-stage 1
      ]
      if (land-age >= time-bound-stage-2-land-use-2) and (land-age < time-bound-stage-3-land-use-2)
      [
        set land-stage 2
      ]
      if (land-age >= time-bound-stage-3-land-use-2) and (land-age < time-bound-stage-4-land-use-2)
      [
        set land-stage 3
      ]
      if (land-age >= time-bound-stage-4-land-use-2)
      [
        set land-stage 4
      ]
    ]
    if land-use-type = 3
    [
      if (land-age >= time-bound-stage-1-land-use-3) and (land-age < time-bound-stage-2-land-use-3)
      [
        set land-stage 1
      ]
      if (land-age >= time-bound-stage-2-land-use-3) and (land-age < time-bound-stage-3-land-use-3)
      [
        set land-stage 2
      ]
      if (land-age >= time-bound-stage-3-land-use-3) and (land-age < time-bound-stage-4-land-use-3)
      [
        set land-stage 3
      ]
      if (land-age >= time-bound-stage-4-land-use-3)
      [
        set land-stage 4
      ]
    ]
  ]
end

;;estimate harvested yield of each field based on its performance, its size and harvesting labor allocated
to harvest-fields
  ask fields
  [
    if land-use-type = 1
    [
      if land-stage = 1
      [    
        set land-yield land-labor * land-size * max list 0 random-normal mean-yield-stage-1-land-use-1 (cv-yield-stage-1-land-use-1 * mean-yield-stage-1-land-use-1)
      ]
      if land-stage = 2
      [    
        set land-yield land-labor * land-size * max list 0 random-normal mean-yield-stage-2-land-use-1 (cv-yield-stage-2-land-use-1 * mean-yield-stage-2-land-use-1)
      ]
      if land-stage = 3
      [    
        set land-yield land-labor * land-size * max list 0 random-normal mean-yield-stage-3-land-use-1 (cv-yield-stage-3-land-use-1 * mean-yield-stage-3-land-use-1)
      ]
      if land-stage = 4
      [    
        set land-yield land-labor * land-size * max list 0 random-normal mean-yield-stage-4-land-use-1 (cv-yield-stage-4-land-use-1 * mean-yield-stage-4-land-use-1)
      ]
    ]
    if land-use-type = 2
    [
      if land-stage = 1
      [    
        set land-yield land-labor * land-size * max list 0 random-normal mean-yield-stage-1-land-use-2 (cv-yield-stage-1-land-use-2 * mean-yield-stage-1-land-use-2)
      ]
      if land-stage = 2
      [    
        set land-yield land-labor * land-size * max list 0 random-normal mean-yield-stage-2-land-use-2 (cv-yield-stage-2-land-use-2 * mean-yield-stage-2-land-use-2)
      ]
      if land-stage = 3
      [    
        set land-yield land-labor * land-size * max list 0 random-normal mean-yield-stage-3-land-use-2 (cv-yield-stage-3-land-use-2 * mean-yield-stage-3-land-use-2)
      ]
      if land-stage = 4
      [    
        set land-yield land-labor * land-size * max list 0 random-normal mean-yield-stage-4-land-use-2 (cv-yield-stage-4-land-use-2 * mean-yield-stage-4-land-use-2)
      ]
    ]
    if land-use-type = 3
    [
      if land-stage = 1
      [    
        set land-yield land-labor * land-size * max list 0 random-normal mean-yield-stage-1-land-use-3 (cv-yield-stage-1-land-use-3 * mean-yield-stage-1-land-use-3)
      ]
      if land-stage = 2
      [    
        set land-yield land-labor * land-size * max list 0 random-normal mean-yield-stage-2-land-use-3 (cv-yield-stage-2-land-use-3 * mean-yield-stage-2-land-use-3)
      ]
      if land-stage = 3
      [    
        set land-yield land-labor * land-size * max list 0 random-normal mean-yield-stage-3-land-use-3 (cv-yield-stage-3-land-use-3 * mean-yield-stage-3-land-use-3)
      ]
      if land-stage = 4
      [    
        set land-yield land-labor * land-size * max list 0 random-normal mean-yield-stage-4-land-use-3 (cv-yield-stage-4-land-use-3 * mean-yield-stage-4-land-use-3)
      ]
    ]
  ]  
end

;;generate prices
to generate-price
  set price-commodity-land-use-1 max list min-price-commodity-land-use-1 random-normal mean-price-commodity-land-use-1 (cv-price-commodity-land-use-1 * mean-price-commodity-land-use-1)
  set price-commodity-land-use-2 max list min-price-commodity-land-use-2 random-normal mean-price-commodity-land-use-2 (cv-price-commodity-land-use-2 * mean-price-commodity-land-use-2)
  set price-commodity-land-use-3 max list min-price-commodity-land-use-3 random-normal mean-price-commodity-land-use-3 (cv-price-commodity-land-use-3 * mean-price-commodity-land-use-3)
  set labor-wage max list min-labor-wage random-normal mean-labor-wage (cv-labor-wage * mean-labor-wage)
end

;;generate non harvesting labor costs of each field
to calculate-costs
  ask fields
  [
    if land-use-type = 1
    [
      if land-stage = 1
      [    
        set land-costs land-labor * labor-wage + land-size * max list 0 random-normal mean-costs-stage-1-land-use-1 (cv-costs-stage-1-land-use-1 * mean-costs-stage-1-land-use-1)
      ]
      if land-stage = 2
      [    
        set land-costs land-labor * labor-wage + land-size * max list 0 random-normal mean-costs-stage-2-land-use-1 (cv-costs-stage-2-land-use-1 * mean-costs-stage-2-land-use-1)
      ]
      if land-stage = 3
      [    
        set land-costs land-labor * labor-wage + land-size * max list 0 random-normal mean-costs-stage-3-land-use-1 (cv-costs-stage-3-land-use-1 * mean-costs-stage-3-land-use-1)
      ]
      if land-stage = 4
      [    
        set land-costs land-labor * labor-wage + land-size * max list 0 random-normal mean-costs-stage-4-land-use-1 (cv-costs-stage-4-land-use-1 * mean-costs-stage-4-land-use-1)
      ]
    ]
    if land-use-type = 2
    [
      if land-stage = 1
      [    
        set land-costs land-labor * labor-wage + land-size * max list 0 random-normal mean-costs-stage-1-land-use-2 (cv-costs-stage-1-land-use-2 * mean-costs-stage-1-land-use-2)
      ]
      if land-stage = 2
      [    
        set land-costs land-labor * labor-wage + land-size * max list 0 random-normal mean-costs-stage-2-land-use-2 (cv-costs-stage-2-land-use-2 * mean-costs-stage-2-land-use-2)
      ]
      if land-stage = 3
      [    
        set land-costs land-labor * labor-wage + land-size * max list 0 random-normal mean-costs-stage-3-land-use-2 (cv-costs-stage-3-land-use-2 * mean-costs-stage-3-land-use-2)
      ]
      if land-stage = 4
      [    
        set land-costs land-labor * labor-wage + land-size * max list 0 random-normal mean-costs-stage-4-land-use-2 (cv-costs-stage-4-land-use-2 * mean-costs-stage-4-land-use-2)
      ]
    ]
    if land-use-type = 3
    [
      if land-stage = 1
      [    
        set land-costs land-labor * labor-wage + land-size * max list 0 random-normal mean-costs-stage-1-land-use-3 (cv-costs-stage-1-land-use-3 * mean-costs-stage-1-land-use-3)
      ]
      if land-stage = 2
      [    
        set land-costs land-labor * labor-wage + land-size * max list 0 random-normal mean-costs-stage-2-land-use-3 (cv-costs-stage-2-land-use-3 * mean-costs-stage-2-land-use-3)
      ]
      if land-stage = 3
      [    
        set land-costs land-labor * labor-wage + land-size * max list 0 random-normal mean-costs-stage-3-land-use-3 (cv-costs-stage-3-land-use-3 * mean-costs-stage-3-land-use-3)
      ]
      if land-stage = 4
      [    
        set land-costs land-labor * labor-wage + land-size * max list 0 random-normal mean-costs-stage-4-land-use-3 (cv-costs-stage-4-land-use-3 * mean-costs-stage-4-land-use-3)
      ]
    ]
  ]  
end

;;calculate profit from each field = [revenue - costs]/labor
to calculate-profit
  ask fields
  [
    ifelse (land-labor * land-size) > 0
    [
      if land-use-type = 1
      [
        set land-profit ((land-yield * price-commodity-land-use-1) - land-costs) / (land-labor * land-size)
      ]
      if land-use-type = 2
      [
        set land-profit ((land-yield * price-commodity-land-use-2) - land-costs) / (land-labor * land-size)
      ]
      if land-use-type = 3
      [
        set land-profit ((land-yield * price-commodity-land-use-3) - land-costs) / (land-labor * land-size)
      ]
    ]
    [
      set land-profit 0
    ]
  ]
end

;;simulate information exchange from sharing and seeking
to exchange-information
  ask house-holds
  [
    set share? random-float 1.00 < p-sharing
    set seek? random-float 1.00 < p-seeking
    ifelse own-land-use-1? = 1
    [
      set exchanged-knowledge-land-use-1 knowledge-land-use-1
    ]
    [
      set exchanged-knowledge-land-use-1 missing-value
    ]
    ifelse own-land-use-2? = 1
    [
      set exchanged-knowledge-land-use-2 knowledge-land-use-2
    ]
    [
      set exchanged-knowledge-land-use-2 missing-value
    ]
    ifelse own-land-use-3? = 1
    [
      set exchanged-knowledge-land-use-3 knowledge-land-use-1
    ]
    [
      set exchanged-knowledge-land-use-3 missing-value
    ]
    
    ifelse show-network?
    [
      ;;visualisation
      if share? and not seek?
      [
        ask __my-links 
        [
          st
          set color white
        ]
      ]
      if not share? and seek?
      [
        ask __my-links 
        [
          st
          set color yellow
        ]
      ]
      if share? and seek?
      [
        ask __my-links 
        [
          st
          set color pink
        ]
      ]
      if not share? and not seek?
      [
        ask __my-links 
        [
          st
          set color grey - 3
        ]
      ]  
    ]
    [
      ask __my-links [ht]
    ]
    setxy original-x original-y    
    set list-info-from-seeking-land-use-1[]
    set list-info-from-seeking-land-use-2[]
    set list-info-from-seeking-land-use-3[]
    set list-info-from-sharing-land-use-1[]
    set list-info-from-sharing-land-use-2[]
    set list-info-from-sharing-land-use-3[]
    set list-weight-info-from-seeking-land-use-1[]
    set list-weight-info-from-seeking-land-use-2[]
    set list-weight-info-from-seeking-land-use-3[]
    set list-weight-info-from-sharing-land-use-1[]
    set list-weight-info-from-sharing-land-use-2[]
    set list-weight-info-from-sharing-land-use-3[]
  ]
  measure-maximum-physical-distance
  set maximum-partners max values-from  house-holds [count __link-neighbors]
  without-interruption
  [
    ask house-holds
    [
      ifelse seek?
      [
        let source who
        ask __link-neighbors
        [
          let partner who
          let popularity value-from  house-hold partner [count __link-neighbors] / maximum-partners 
          let physic-distance (measure-physical-distance source partner) / maximum-physical-distance
          let ethnic-distance min list 1 abs(ethnic-type-of house-hold source - ethnic-type-of house-hold partner)
          set weight-info-from-seeking min list 1 ((1 + weight-popularity-person-of house-hold source * popularity) / (1 + weight-ethnical-distance-of house-hold source * ethnic-distance + weight-physical-distance-of house-hold source * physic-distance))
          
          ifelse exchanged-knowledge-land-use-1-of house-hold partner != missing-value
          [
            set list-info-from-seeking-land-use-1-of house-hold source fput (exchanged-knowledge-land-use-1-of house-hold partner * weight-info-from-seeking) list-info-from-seeking-land-use-1-of house-hold source 
            set list-weight-info-from-seeking-land-use-1-of house-hold source fput weight-info-from-seeking list-weight-info-from-seeking-land-use-1-of house-hold source
          ]
          [
            set list-info-from-seeking-land-use-1-of house-hold source fput exchanged-knowledge-land-use-1-of house-hold partner list-info-from-seeking-land-use-1-of house-hold source
            set list-weight-info-from-seeking-land-use-1-of house-hold source fput missing-value list-weight-info-from-seeking-land-use-1-of house-hold source
          ]
          
          ifelse exchanged-knowledge-land-use-2-of house-hold partner != missing-value
          [
            set list-info-from-seeking-land-use-2-of house-hold source fput (exchanged-knowledge-land-use-2-of house-hold partner * weight-info-from-seeking) list-info-from-seeking-land-use-2-of house-hold source 
            set list-weight-info-from-seeking-land-use-2-of house-hold source fput weight-info-from-seeking list-weight-info-from-seeking-land-use-2-of house-hold source
          ]
          [
            set list-info-from-seeking-land-use-2-of house-hold source fput exchanged-knowledge-land-use-2-of house-hold partner list-info-from-seeking-land-use-2-of house-hold source
            set list-weight-info-from-seeking-land-use-2-of house-hold source fput missing-value list-weight-info-from-seeking-land-use-2-of house-hold source
          ]
          
          ifelse exchanged-knowledge-land-use-3-of house-hold partner != missing-value
          [
            set list-info-from-seeking-land-use-3-of house-hold source fput (exchanged-knowledge-land-use-3-of house-hold partner * weight-info-from-seeking) list-info-from-seeking-land-use-3-of house-hold source 
            set list-weight-info-from-seeking-land-use-3-of house-hold source fput weight-info-from-seeking list-weight-info-from-seeking-land-use-3-of house-hold source
          ]
          [
            set list-info-from-seeking-land-use-3-of house-hold source fput exchanged-knowledge-land-use-3-of house-hold partner list-info-from-seeking-land-use-3-of house-hold source
            set list-weight-info-from-seeking-land-use-3-of house-hold source fput missing-value list-weight-info-from-seeking-land-use-3-of house-hold source
          ]
                 
        ]
      ]
      [
        ask __link-neighbors
        [
          let partner who
          set list-info-from-seeking-land-use-1 fput missing-value list-info-from-seeking-land-use-1
          set list-weight-info-from-seeking-land-use-1 fput missing-value list-weight-info-from-seeking-land-use-1
          set list-info-from-seeking-land-use-2 fput missing-value list-info-from-seeking-land-use-2
          set list-weight-info-from-seeking-land-use-2 fput missing-value list-weight-info-from-seeking-land-use-2
          set list-info-from-seeking-land-use-3 fput missing-value list-info-from-seeking-land-use-3
          set list-weight-info-from-seeking-land-use-3 fput missing-value list-weight-info-from-seeking-land-use-3
        ]
      ]
      
      ifelse share?
      [
        let source who
        ask __link-neighbors
        [
          let partner who
          let popularity value-from  house-hold source [count __link-neighbors] / maximum-partners 
          let physic-distance (measure-physical-distance source partner) / maximum-physical-distance
          let ethnic-distance min list 1 abs(ethnic-type-of house-hold source - ethnic-type-of house-hold partner)
          
          set weight-info-from-sharing min list 1 ((1 + weight-popularity-person-of house-hold partner * popularity) / (1 + weight-ethnical-distance-of house-hold partner * ethnic-distance + weight-physical-distance-of house-hold partner * physic-distance))
          
          ifelse exchanged-knowledge-land-use-1-of house-hold source != missing-value
          [
            set list-info-from-sharing-land-use-1-of house-hold partner fput (exchanged-knowledge-land-use-1-of house-hold source * weight-info-from-sharing) list-info-from-sharing-land-use-1-of house-hold partner
            set list-weight-info-from-sharing-land-use-1-of house-hold partner fput weight-info-from-sharing list-weight-info-from-sharing-land-use-1-of house-hold partner
          ]
          [
            set list-info-from-sharing-land-use-1-of house-hold partner fput exchanged-knowledge-land-use-1-of house-hold source list-info-from-sharing-land-use-1-of house-hold partner
            set list-weight-info-from-sharing-land-use-1-of house-hold partner fput missing-value list-weight-info-from-sharing-land-use-1-of house-hold partner
          ]
          
          ifelse exchanged-knowledge-land-use-2-of house-hold source != missing-value
          [
            set list-info-from-sharing-land-use-2-of house-hold partner fput (exchanged-knowledge-land-use-2-of house-hold source * weight-info-from-sharing) list-info-from-sharing-land-use-2-of house-hold partner
            set list-weight-info-from-sharing-land-use-2-of house-hold partner fput weight-info-from-sharing list-weight-info-from-sharing-land-use-2-of house-hold partner
          ]
          [
            set list-info-from-sharing-land-use-2-of house-hold partner fput exchanged-knowledge-land-use-2-of house-hold source list-info-from-sharing-land-use-2-of house-hold partner
            set list-weight-info-from-sharing-land-use-2-of house-hold partner fput missing-value list-weight-info-from-sharing-land-use-2-of house-hold partner
          ]
          
          ifelse exchanged-knowledge-land-use-3-of house-hold source != missing-value
          [
            set list-info-from-sharing-land-use-3-of house-hold partner fput (exchanged-knowledge-land-use-3-of house-hold source * weight-info-from-sharing) list-info-from-sharing-land-use-3-of house-hold partner
            set list-weight-info-from-sharing-land-use-3-of house-hold partner fput weight-info-from-sharing list-weight-info-from-sharing-land-use-3-of house-hold partner
          ]
          [
            set list-info-from-sharing-land-use-3-of house-hold partner fput exchanged-knowledge-land-use-3-of house-hold source list-info-from-sharing-land-use-3-of house-hold partner
            set list-weight-info-from-sharing-land-use-3-of house-hold partner fput missing-value list-weight-info-from-sharing-land-use-3-of house-hold partner
          ]
        ]
      ]
      [
        ask __link-neighbors
        [
          let partner who
          set list-info-from-sharing-land-use-1-of house-hold partner fput missing-value list-info-from-sharing-land-use-1-of house-hold partner
          set list-weight-info-from-sharing-land-use-1-of house-hold partner fput missing-value list-weight-info-from-sharing-land-use-1-of house-hold partner
          set list-info-from-sharing-land-use-2-of house-hold partner fput missing-value list-info-from-sharing-land-use-2-of house-hold partner
          set list-weight-info-from-sharing-land-use-2-of house-hold partner fput missing-value list-weight-info-from-sharing-land-use-2-of house-hold partner
          set list-info-from-sharing-land-use-3-of house-hold partner fput missing-value list-info-from-sharing-land-use-3-of house-hold partner
          set list-weight-info-from-sharing-land-use-3-of house-hold partner fput missing-value list-weight-info-from-sharing-land-use-3-of house-hold partner
        ]
      ]      
    ]
  ]
  ask house-holds
  [
    ifelse length remove missing-value list-info-from-seeking-land-use-1 > 0
    [
      set info-from-seeking-land-use-1 sum remove missing-value list-info-from-seeking-land-use-1 / sum remove missing-value list-weight-info-from-seeking-land-use-1
    ]
    [
      set info-from-seeking-land-use-1 missing-value
    ]
    ifelse length remove missing-value list-info-from-seeking-land-use-2 > 0
    [
      set info-from-seeking-land-use-2 sum remove missing-value list-info-from-seeking-land-use-2 / sum remove missing-value list-weight-info-from-seeking-land-use-2
    ]
    [
      set info-from-seeking-land-use-2 missing-value
    ]
    ifelse length remove missing-value list-info-from-seeking-land-use-3 > 0
    [
      set info-from-seeking-land-use-3 sum remove missing-value list-info-from-seeking-land-use-3 / sum remove missing-value list-weight-info-from-seeking-land-use-3
    ]
    [
      set info-from-seeking-land-use-3 missing-value
    ] 
    ifelse length remove missing-value list-info-from-sharing-land-use-1 > 0
    [
      set info-from-sharing-land-use-1 sum remove missing-value list-info-from-sharing-land-use-1 / sum remove missing-value list-weight-info-from-sharing-land-use-1
    ]
    [
      set info-from-sharing-land-use-1 missing-value
    ]
    ifelse length remove missing-value list-info-from-sharing-land-use-2 > 0
    [
      set info-from-sharing-land-use-2 sum remove missing-value list-info-from-sharing-land-use-2 / sum remove missing-value list-weight-info-from-sharing-land-use-2
    ]
    [
      set info-from-sharing-land-use-2 missing-value
    ]
    ifelse length remove missing-value list-info-from-sharing-land-use-3 > 0
    [
      set info-from-sharing-land-use-3 sum remove missing-value list-info-from-sharing-land-use-3 / sum remove missing-value list-weight-info-from-sharing-land-use-3
    ]
    [
      set info-from-sharing-land-use-3 missing-value
    ]   
  ]  
end

;;simulate direct observation from others
to observe-from-others
  ask house-holds
  [
    set list-info-from-observing-land-use-1[]
    set list-info-from-observing-land-use-2[]
    set list-info-from-observing-land-use-3[]
    set list-weight-info-from-observing-land-use-1[]
    set list-weight-info-from-observing-land-use-2[]
    set list-weight-info-from-observing-land-use-3[]
  ]  
  measure-maximum-fields-distance
  ask house-holds
  [
    set observe? random-float 1.00 < p-observing    
    set observation-fields-list[]  
  ]
  without-interruption
  [
    ask fields
    [  
      let core who
      ask fields with [self != myself]
      [   
        let buffer who
        if (((distance field core) / maximum-fields-distance) < observation-relative-distance-of house-hold land-holder-id-of field core)
        and (land-holder-id-of field core != land-holder-id-of field buffer)
        [
          set observation-fields-list-of house-hold land-holder-id-of field core fput buffer observation-fields-list-of house-hold land-holder-id-of field core
        ]
      ]
    ]
  ]
  ask house-holds
  [
    set observation-fields-list sort remove-duplicates observation-fields-list
  ]
  without-interruption
  [
    ask house-holds
    [
      ifelse observe?
      [
        foreach observation-fields-list
        [
          if land-use-type-of field ? = 1
          [
            set list-info-from-observing-land-use-1 fput (land-use-system-visibility-of field ? * land-profit-of field ?) list-info-from-observing-land-use-1
            set list-weight-info-from-observing-land-use-1 fput land-use-system-visibility-of field ? list-weight-info-from-observing-land-use-1
          ]
          if land-use-type-of field ? = 2
          [
            set list-info-from-observing-land-use-2 fput (land-use-system-visibility-of field ? * land-profit-of field ?) list-info-from-observing-land-use-2
            set list-weight-info-from-observing-land-use-2 fput land-use-system-visibility-of field ? list-weight-info-from-observing-land-use-2
          ]
          if land-use-type-of field ? = 3
          [
            set list-info-from-observing-land-use-3 fput (land-use-system-visibility-of field ? * land-profit-of field ?) list-info-from-observing-land-use-3
            set list-weight-info-from-observing-land-use-3 fput land-use-system-visibility-of field ? list-weight-info-from-observing-land-use-3
          ]
        ]
      ]
      [
        set list-info-from-observing-land-use-1 fput missing-value list-info-from-observing-land-use-1
        set list-weight-info-from-observing-land-use-1 fput missing-value list-weight-info-from-observing-land-use-1
        set list-info-from-observing-land-use-2 fput missing-value list-info-from-observing-land-use-2
        set list-weight-info-from-observing-land-use-2 fput missing-value list-weight-info-from-observing-land-use-2
        set list-info-from-observing-land-use-3 fput missing-value list-info-from-observing-land-use-3
        set list-weight-info-from-observing-land-use-3 fput missing-value list-weight-info-from-observing-land-use-3
      ]
    ]
  ]
  ask house-holds
  [
    ifelse length remove missing-value list-info-from-observing-land-use-1 > 0 
    [
      ifelse sum remove missing-value list-weight-info-from-observing-land-use-1 > 0
      [
        set info-from-observing-land-use-1 sum list-info-from-observing-land-use-1 / sum list-weight-info-from-observing-land-use-1
      ]
      [
        set info-from-observing-land-use-1 0
      ]
    ]
    [
      set info-from-observing-land-use-1 missing-value
    ]
    ifelse length remove missing-value list-info-from-observing-land-use-2 > 0 
    [
      ifelse sum remove missing-value list-weight-info-from-observing-land-use-2 > 0
      [
        set info-from-observing-land-use-2 sum list-info-from-observing-land-use-2 / sum list-weight-info-from-observing-land-use-2
      ]
      [
        set info-from-observing-land-use-2 0
      ]
    ]
    [
      set info-from-observing-land-use-2 missing-value
    ]
    ifelse length remove missing-value list-info-from-observing-land-use-3 > 0 
    [
      ifelse sum remove missing-value list-weight-info-from-observing-land-use-3 > 0
      [
        set info-from-observing-land-use-3 sum list-info-from-observing-land-use-3 / sum list-weight-info-from-observing-land-use-3
      ]
      [
        set info-from-observing-land-use-3 0
      ]
    ]
    [
      set info-from-observing-land-use-3 missing-value
    ]
  ]
end

;;measure distance between two fields
to-report measure-fields-distance[core buffer]
  ask field core
  [
    set fields-distance distancexy xcor-of field buffer ycor-of field buffer
  ]
  report fields-distance
end

;;measure maximum distance of neigboring fields
to measure-maximum-fields-distance
  let distance-list []
  ask fields
  [
    let core who
    ask fields with [self != myself]
    [
      let buffer who
      set distance-list fput measure-fields-distance core buffer distance-list
    ]
  ]
  set maximum-fields-distance max distance-list
end

;;simulate observation from self fields
to observe-from-self
  without-interruption
  [
    foreach land-holder-id-list
    [
      ifelse length values-from fields with [land-holder-id = ? and land-use-type = 1] [land-profit] > 0
      [
        set info-from-self-land-use-1-of house-hold ? average values-from fields with [land-holder-id = ? and land-use-type = 1] [land-profit]
      ]
      [
        set info-from-self-land-use-1-of house-hold ? missing-value
      ]
      ifelse length values-from fields with [land-holder-id = ? and land-use-type = 2] [land-profit] > 0
      [
        set info-from-self-land-use-2-of house-hold ? average values-from fields with [land-holder-id = ? and land-use-type = 2] [land-profit]
      ]
      [
        set info-from-self-land-use-2-of house-hold ? missing-value
      ]
      ifelse length values-from fields with [land-holder-id = ? and land-use-type = 3] [land-profit] > 0
      [
        set info-from-self-land-use-3-of house-hold ? average values-from fields with [land-holder-id = ? and land-use-type = 3] [land-profit]
      ]
      [
        set info-from-self-land-use-3-of house-hold ? missing-value
      ]
    ]
  ]
end

;;simulate extension events
to generate-extension
  set extension-land-use-1? random-float 1.00 < extension-frequency-land-use-1
  set extension-land-use-2? random-float 1.00 < extension-frequency-land-use-2
  set extension-land-use-3? random-float 1.00 < extension-frequency-land-use-3
  set suggestion-extension-land-use-1 max list min-suggestion-extension-land-use-1 random-normal mean-suggestion-extension-land-use-1 (cv-suggestion-extension-land-use-1 * mean-suggestion-extension-land-use-1)
  set suggestion-extension-land-use-2 max list min-suggestion-extension-land-use-2 random-normal mean-suggestion-extension-land-use-2 (cv-suggestion-extension-land-use-2 * mean-suggestion-extension-land-use-2)
  set suggestion-extension-land-use-3 max list min-suggestion-extension-land-use-3 random-normal mean-suggestion-extension-land-use-3 (cv-suggestion-extension-land-use-2 * mean-suggestion-extension-land-use-3)
end

;;simulate exposure in extension
to expose-in-extension
  ask house-holds 
  [
    set expose-in-extension-land-use-1? random-float 1.00 < p-exposing-in-extension-land-use-1
    set expose-in-extension-land-use-2? random-float 1.00 < p-exposing-in-extension-land-use-2
    set expose-in-extension-land-use-3? random-float 1.00 < p-exposing-in-extension-land-use-3
  ] 
end

;;calculate collected data from information sharing, seeking, observing from others and observing from self
to collect-data
  ask house-holds
  [   
    set collected-data-land-use-1 remove missing-value sentence sentence info-from-seeking-land-use-1 info-from-sharing-land-use-1 sentence info-from-observing-land-use-1 info-from-self-land-use-1
    set collected-data-land-use-2 remove missing-value sentence sentence info-from-seeking-land-use-2 info-from-sharing-land-use-2 sentence info-from-observing-land-use-2 info-from-self-land-use-2
    set collected-data-land-use-3 remove missing-value sentence sentence info-from-seeking-land-use-3 info-from-sharing-land-use-3 sentence info-from-observing-land-use-3 info-from-self-land-use-3
    
    ;;missing-value is used to differ between no data with data <= 0
    ifelse length collected-data-land-use-1 > 0
    [
      set mean-collected-data-land-use-1 mean collected-data-land-use-1
    ]
    [
      set mean-collected-data-land-use-1 missing-value
    ]
    ifelse length collected-data-land-use-2 > 0
    [
      set mean-collected-data-land-use-2 mean collected-data-land-use-2
    ]
    [
      set mean-collected-data-land-use-2 missing-value
    ]
    ifelse length collected-data-land-use-3 > 0
    [
      set mean-collected-data-land-use-3 mean collected-data-land-use-3
    ]
    [
      set mean-collected-data-land-use-3 missing-value
    ]
    
  ]
end

;;store collected data
to-report store-data[storage capacity]
  ifelse length storage > (capacity + 1)
  [
    report butfirst storage
  ]
  [
    report storage
  ]
end

;;recall data from memory
to recall-memory 
  ask house-holds
  [
    ;;missing value is used to differ between n/a data with data <= 0, thus n/a data is removed
    set data-storage-land-use-1 remove missing-value store-data lput mean-collected-data-land-use-1 data-storage-land-use-1 memory-recall-ability
    set data-storage-land-use-2 remove missing-value store-data lput mean-collected-data-land-use-2 data-storage-land-use-2 memory-recall-ability
    set data-storage-land-use-3 remove missing-value store-data lput mean-collected-data-land-use-3 data-storage-land-use-3 memory-recall-ability    
    ifelse length data-storage-land-use-1 > 0
    [
      set recalled-data-land-use-1 sum data-storage-land-use-1 / length data-storage-land-use-1
    ]
    [
      set recalled-data-land-use-1 0
    ]
    ifelse length data-storage-land-use-2 > 0
    [
      set recalled-data-land-use-2 sum data-storage-land-use-2 / length data-storage-land-use-2
    ]
    [
      set recalled-data-land-use-2 0
    ]
    ifelse length data-storage-land-use-3 > 0
    [
      set recalled-data-land-use-3 sum data-storage-land-use-3 / length data-storage-land-use-3
    ]
    [
      set recalled-data-land-use-3 0
    ]
  ]
end

;;recall data from field memory
to recall-field-memory 
  ask fields
  [
    ;;farmers consider whatever results from their plots,
    ;;including when the profit = 0
    set field-data-storage store-data lput land-profit field-data-storage memory-recall-ability-of house-hold land-holder-id
    ifelse length field-data-storage > 0
    [
      set recalled-field-data sum field-data-storage / length field-data-storage
    ]
    [
      set recalled-field-data 0
    ]
  ]
end

;;consider option to be practiced
to consider-options
  ask house-holds
  [
    let total (
    (enough-capital-to-establish-land-use-1? * (knowledge-land-use-1 ^ prioritisation)) +
    (enough-capital-to-establish-land-use-2? * (knowledge-land-use-2 ^ prioritisation)) +
    (enough-capital-to-establish-land-use-3? * (knowledge-land-use-3 ^ prioritisation))
    )
    
    let totalcapital 
    (enough-capital-to-establish-land-use-1? +
    enough-capital-to-establish-land-use-2? +
    enough-capital-to-establish-land-use-3?)
    
    ifelse total > 0
    [      
      set p-to-adopt-land-use-1 ((enough-capital-to-establish-land-use-1? * (knowledge-land-use-1 ^ prioritisation)) / total)
      set p-to-adopt-land-use-2 ((enough-capital-to-establish-land-use-2? * (knowledge-land-use-2 ^ prioritisation)) / total)
      set p-to-adopt-land-use-3 ((enough-capital-to-establish-land-use-3? * (knowledge-land-use-3 ^ prioritisation)) / total)
    ]
    [
      ;;no knowledge, consider possible options with capital
      ifelse totalcapital > 0
      [
        set p-to-adopt-land-use-1 (enough-capital-to-establish-land-use-1? / totalcapital)
        set p-to-adopt-land-use-2 (enough-capital-to-establish-land-use-2? / totalcapital)
        set p-to-adopt-land-use-3 (enough-capital-to-establish-land-use-3? / totalcapital)
      ]
      [
        ;;no knowledge, no capital, no adoption, just let the old plots 
        set p-to-adopt-land-use-1 0
        set p-to-adopt-land-use-2 0
        set p-to-adopt-land-use-3 0
      ]
    ]
  ]
end

;;define convertible fields
to define-convertible-fields
  ask fields
  [
    if land-use-type = 1
    [
      set land-convertible? (land-age >= minimum-convertible-age-land-use-1)
    ]
    if land-use-type = 2
    [
      set land-convertible? (land-age >= minimum-convertible-age-land-use-2) 
    ]
    if land-use-type = 3
    [
      set land-convertible? (land-age >= minimum-convertible-age-land-use-3) 
    ]
  ]
  without-interruption
  [
    foreach land-holder-id-list
    [
      set convertible-fields-list-of house-hold ? values-from fields with [land-convertible? and land-holder-id = ?] [land-holder-id]
      set number-convertible-fields-of house-hold ? length convertible-fields-list-of house-hold ?
    ]
  ]  
end

;;generate capital for establishment
to generate-capital-for-establishment
  ask house-holds
  [
    if random-float 1.00 < p-generate-capital-to-establish-land-use-1
    [
      set enough-capital-to-establish-land-use-1? 1
    ]
    if random-float 1.00 < p-generate-capital-to-establish-land-use-2
    [
      set enough-capital-to-establish-land-use-2? 1
    ]
    if random-float 1.00 < p-generate-capital-to-establish-land-use-3
    [
      set enough-capital-to-establish-land-use-3? 1
    ]
  ]
end

;;convert fields
to convert-fields
  ask house-holds
  [
    set random-land-use-pot 
    sentence n-values round (100 * number-convertible-fields * p-to-adopt-land-use-1) [1] 
    sentence n-values round (100 * number-convertible-fields * p-to-adopt-land-use-2) [2] 
    n-values round (100 * number-convertible-fields * p-to-adopt-land-use-3) [3]
    set selected-land-use-system-list[]
  ]
  without-interruption
  [
    ask house-holds
    [
      let updated-random-land-use-pot random-land-use-pot
      repeat number-convertible-fields
      [
        if not empty? updated-random-land-use-pot
        [
          set selected-land-use-system one-of shuffle updated-random-land-use-pot
          set selected-land-use-system-list fput selected-land-use-system selected-land-use-system-list
          set updated-random-land-use-pot remove-item position selected-land-use-system updated-random-land-use-pot updated-random-land-use-pot
        ]
      ]
    ]
  ]    
  without-interruption
  [
    ask fields
    [
      let old-system land-use-type
      ifelse land-convertible?
      [
        ifelse length selected-land-use-system-list-of house-hold land-holder-id > 0
        [
          set land-use-type one-of shuffle selected-land-use-system-list-of house-hold land-holder-id
          set land-age 0
          set land-knowledge 0
          set selected-land-use-system-list-of house-hold land-holder-id 
          remove-item position land-use-type selected-land-use-system-list-of house-hold land-holder-id
          selected-land-use-system-list-of house-hold land-holder-id      
        ]
        [
          set land-use-type old-system
          set land-age land-age + 1
          set land-knowledge max list 0 (land-knowledge + (learning-progressiveness-of house-hold land-holder-id * (recalled-field-data - land-knowledge)))
        ]
      ]
      [
        set land-use-type old-system
        set land-age land-age + 1
        set land-knowledge max list 0 (land-knowledge + (learning-progressiveness-of house-hold land-holder-id * (recalled-field-data - land-knowledge)))
      ]
    ]
  ]
end

;;learn
to learn
  ask house-holds
  [
    ifelse expose-in-extension-land-use-1? and extension-land-use-1?
    [
      set knowledge-land-use-1 max list 0 (knowledge-land-use-1 + (learning-progressiveness * (recalled-data-land-use-1 - knowledge-land-use-1)) + (credibility-extension-land-use-1 * (suggestion-extension-land-use-1 - knowledge-land-use-1)))
    ]
    [
      set knowledge-land-use-1 max list 0 (knowledge-land-use-1 + (learning-progressiveness * (recalled-data-land-use-1 - knowledge-land-use-1)))
    ]
    ifelse expose-in-extension-land-use-2? and extension-land-use-2?
    [
      set knowledge-land-use-2 max list 0 (knowledge-land-use-2 + (learning-progressiveness * (recalled-data-land-use-2 - knowledge-land-use-2)) + (credibility-extension-land-use-2 * (suggestion-extension-land-use-2 - knowledge-land-use-2)))
    ]
    [
      set knowledge-land-use-2 max list 0 (knowledge-land-use-2 + (learning-progressiveness * (recalled-data-land-use-2 - knowledge-land-use-2)))
    ]
    ifelse expose-in-extension-land-use-3? and extension-land-use-3?
    [
      set knowledge-land-use-3 max list 0 (knowledge-land-use-3 + (learning-progressiveness * (recalled-data-land-use-3 - knowledge-land-use-3)) + (credibility-extension-land-use-3 * (suggestion-extension-land-use-3 - knowledge-land-use-3)))
    ]
    [
      set knowledge-land-use-3 max list 0 (knowledge-land-use-3 + (learning-progressiveness * (recalled-data-land-use-3 - knowledge-land-use-3)))
    ]
  ]  
end

;;report outputs

;;average individual values
to-report average [data-list]
  ifelse length data-list > 0
  [
    report mean data-list
  ]
  [
    report 0
  ]
end

;;file name of output data (tab delimited text file)
to ask-for-output-file
  set output-data-file user-input "Output file name: " + ".out"
end

;;make header for output file
to make-header
  file-open output-data-file
  file-print 
  "input data file:" + "\t" + input-data-file
  +
  "\n"
  +
  "date and time:" + "\t" + date-and-time
  +
  "\n\n"
  +
  "time" 
  + 
  "\t" 
  + 
  "overall-average-popularity"
  + 
  "\t" 
  + 
  "overall-average-ethnical-homophily"
  + 
  "\t" 
  + 
  "overall-average-spatial-homophily"
  + 
  "\t" 
  + 
  "sharing-by-adopter-land-use-1"
  + 
  "\t" 
  + 
  "sharing-by-adopter-land-use-2"
  + 
  "\t" 
  + 
  "sharing-by-adopter-land-use-3"
  + 
  "\t" 
  + 
  "seeking-by-adopter-land-use-1"
  + 
  "\t" 
  + 
  "seeking-by-adopter-land-use-2"
  + 
  "\t" 
  + 
  "seeking-by-adopter-land-use-3"
  + 
  "\t" 
  + 
  "observing-by-adopter-land-use-1"
  + 
  "\t" 
  + 
  "observing-by-adopter-land-use-2"
  + 
  "\t" 
  + 
  "observing-by-adopter-land-use-3"
  + 
  "\t" 
  + 
  "exposing-to-extension-land-use-1"
  + 
  "\t" 
  + 
  "exposing-to-extension-land-use-2"
  + 
  "\t" 
  + 
  "exposing-to-extension-land-use-3"
  + 
  "\t" 
  + 
  "overall-average-recalled-data-land-use-1"
  + 
  "\t" 
  + 
  "overall-average-recalled-data-land-use-2"
  + 
  "\t" 
  + 
  "overall-average-recalled-data-land-use-3"
  + 
  "\t" 
  + 
  "overall-average-collected-data-land-use-1"
  + 
  "\t" 
  + 
  "overall-average-collected-data-land-use-2"
  + 
  "\t" 
  + 
  "overall-average-collected-data-land-use-3"
  + 
  "\t" 
  + 
  "overall-average-knowledge-land-use-1"
  + 
  "\t" 
  + 
  "overall-average-knowledge-land-use-2"
  + 
  "\t" 
  + 
  "overall-average-knowledge-land-use-3"
  + 
  "\t" 
  + 
  "overall-average-plot-knowledge-land-use-1"
  + 
  "\t" 
  + 
  "overall-average-plot-knowledge-land-use-2"
  + 
  "\t" 
  + 
  "overall-average-plot-knowledge-land-use-3"
  + 
  "\t" 
  + 
  "overall-average-labor-land-use-1"
  + 
  "\t" 
  + 
  "overall-average-labor-land-use-2"
  + 
  "\t" 
  + 
  "overall-average-labor-land-use-3"
  + 
  "\t" 
  + 
  "adopters-land-use-1-only"
  + 
  "\t" 
  + 
  "adopters-land-use-2-only" 
  + 
  "\t" 
  + 
  "adopters-land-use-3-only"
  + 
  "\t" 
  + 
  "adopters-land-use-1-&-2"
  + 
  "\t" 
  + 
  "adopters-land-use-1-&-3"
  + 
  "\t" 
  + 
  "adopters-land-use-2-&-3"
  + 
  "\t" 
  + 
  "adopters-land-use-1-2-&-3"
  + 
  "\t" 
  + 
  "overall-average-field-size-land-use-1"
  + 
  "\t" 
  + 
  "overall-average-field-size-land-use-2"
  + 
  "\t" 
  + 
  "overall-average-field-size-land-use-3"
  + 
  "\t" 
  + 
  "total-area-land-use-1"
  + 
  "\t" 
  + 
  "total-area-land-use-2"
  + 
  "\t" 
  + 
  "total-area-land-use-3"
  + 
  "\t" 
  + 
  "overall-average-profit-land-use-1"
  + 
  "\t" 
  + 
  "overall-average-profit-land-use-2"
  + 
  "\t" 
  + 
  "overall-average-profit-land-use-3"
  file-close
end

;;record results to external file
to record-results
  file-open output-data-file
  file-print 
  simulation-time
  + 
  "\t" 
  + 
  precision overall-average-popularity 2
  + 
  "\t" 
  + 
  precision overall-average-ethnical-homophily 2
  + 
  "\t" 
  + 
  precision overall-average-spatial-homophily 2
  + 
  "\t" 
  + 
  precision sharing-by-adopter-land-use-1 0
  + 
  "\t" 
  + 
  precision sharing-by-adopter-land-use-2 0
  + 
  "\t" 
  + 
  precision sharing-by-adopter-land-use-3 0
  + 
  "\t" 
  + 
  precision seeking-by-adopter-land-use-1 0
  + 
  "\t" 
  + 
  precision seeking-by-adopter-land-use-2 0
  + 
  "\t" 
  + 
  precision seeking-by-adopter-land-use-3 0
  + 
  "\t" 
  + 
  precision observing-by-adopter-land-use-1 0
  + 
  "\t" 
  + 
  precision observing-by-adopter-land-use-2 0
  + 
  "\t" 
  + 
  precision observing-by-adopter-land-use-3 0
  + 
  "\t" 
  + 
  precision exposing-to-extension-land-use-1 0
  + 
  "\t" 
  + 
  precision exposing-to-extension-land-use-2 0
  + 
  "\t" 
  + 
  precision exposing-to-extension-land-use-3 0
  + 
  "\t" 
  + 
  precision overall-average-recalled-data-land-use-1 2
  + 
  "\t" 
  + 
  precision overall-average-recalled-data-land-use-2 2
  + 
  "\t" 
  + 
  precision overall-average-recalled-data-land-use-3 2
  + 
  "\t" 
  + 
  precision overall-average-collected-data-land-use-1 2
  + 
  "\t" 
  + 
  precision overall-average-collected-data-land-use-2 2
  + 
  "\t" 
  + 
  precision overall-average-collected-data-land-use-3 2
  + 
  "\t" 
  + 
  precision overall-average-knowledge-land-use-1 2
  + 
  "\t" 
  + 
  precision overall-average-knowledge-land-use-2 2
  + 
  "\t" 
  + 
  precision overall-average-knowledge-land-use-3 2
  + 
  "\t" 
  + 
  precision overall-average-plot-knowledge-land-use-1 2
  + 
  "\t" 
  + 
  precision overall-average-plot-knowledge-land-use-2 2
  + 
  "\t" 
  + 
  precision overall-average-plot-knowledge-land-use-3 2
  + 
  "\t" 
  + 
  precision overall-average-labor-land-use-1 2
  + 
  "\t" 
  + 
  precision overall-average-labor-land-use-2 2
  + 
  "\t" 
  + 
  precision overall-average-labor-land-use-3 2
  + 
  "\t" 
  + 
  precision adopters-land-use-1-only 0
  + 
  "\t" 
  + 
  precision adopters-land-use-2-only 0
  + 
  "\t" 
  + 
  precision adopters-land-use-3-only 0
  + 
  "\t" 
  + 
  precision adopters-land-use-1-&-2 0
  + 
  "\t" 
  + 
  precision adopters-land-use-1-&-3 0
  + 
  "\t" 
  + 
  precision adopters-land-use-2-&-3 0
  + 
  "\t" 
  + 
  precision adopters-land-use-1-2-&-3 0
  + 
  "\t" 
  + 
  precision overall-average-field-size-land-use-1 2
  + 
  "\t" 
  + 
  precision overall-average-field-size-land-use-2 2
  + 
  "\t" 
  + 
  precision overall-average-field-size-land-use-3 2
  + 
  "\t" 
  + 
  precision total-area-land-use-1 2
  + 
  "\t" 
  + 
  precision total-area-land-use-2 2
  + 
  "\t" 
  + 
  precision total-area-land-use-3 2
  + 
  "\t" 
  + 
  precision overall-average-profit-land-use-1 2
  + 
  "\t" 
  + 
  precision overall-average-profit-land-use-2 2
  + 
  "\t" 
  + 
  precision overall-average-profit-land-use-3 2
  file-close
end

;;summarise outputs
to summarise-outputs
  ;;information network
  set overall-average-popularity average values-from house-holds [count __link-neighbors / max values-from house-holds [count __link-neighbors]]
  set overall-average-ethnical-homophily average values-from house-holds [count __link-neighbors with [ethnic-type = ethnic-type-of myself] / count __link-neighbors]
  set overall-average-spatial-homophily average values-from house-holds [count __link-neighbors with [(measure-physical-distance who-of myself who) / maximum-physical-distance < 0.5] / count __link-neighbors]
  
  ;;diffusion of information
  
  ;;sharing
  set sharing-by-adopter-land-use-1 count house-holds with [share? = true and own-land-use-1? = 1]
  set sharing-by-adopter-land-use-2 count house-holds with [share? = true and own-land-use-2? = 1]
  set sharing-by-adopter-land-use-3 count house-holds with [share? = true and own-land-use-3? = 1]
  
  ;;seeking
  set seeking-by-adopter-land-use-1 count house-holds with [seek? = true and own-land-use-1? = 1]
  set seeking-by-adopter-land-use-2 count house-holds with [seek? = true and own-land-use-2? = 1]
  set seeking-by-adopter-land-use-3 count house-holds with [seek? = true and own-land-use-3? = 1]
  
  ;;observing from others
  set observing-by-adopter-land-use-1 count house-holds with [observe? = true and own-land-use-1? = 1]
  set observing-by-adopter-land-use-2 count house-holds with [observe? = true and own-land-use-2? = 1]
  set observing-by-adopter-land-use-3 count house-holds with [observe? = true and own-land-use-3? = 1]
  
  ;;exposing in extension  
  set exposing-to-extension-land-use-1 count house-holds with [extension-land-use-1?]
  set exposing-to-extension-land-use-2 count house-holds with [extension-land-use-2?]
  set exposing-to-extension-land-use-3 count house-holds with [extension-land-use-3?]
  
  ;;knowledge  
  
  ;;general knowledge
  set overall-average-knowledge-land-use-1 average values-from house-holds [knowledge-land-use-1]
  set overall-average-knowledge-land-use-2 average values-from house-holds [knowledge-land-use-2]
  set overall-average-knowledge-land-use-3 average values-from house-holds [knowledge-land-use-3]
  
  ;;plot knowledge
  set overall-average-plot-knowledge-land-use-1 average values-from fields with [land-use-type = 1] [land-knowledge] 
  set overall-average-plot-knowledge-land-use-2 average values-from fields with [land-use-type = 2] [land-knowledge]
  set overall-average-plot-knowledge-land-use-3 average values-from fields with [land-use-type = 3] [land-knowledge]

  ;;learning
  
  ;;collected data
  set overall-average-collected-data-land-use-1 average remove missing-value values-from house-holds [mean-collected-data-land-use-1]
  set overall-average-collected-data-land-use-2 average remove missing-value values-from house-holds [mean-collected-data-land-use-2]
  set overall-average-collected-data-land-use-3 average remove missing-value values-from house-holds [mean-collected-data-land-use-3]
  
  ;;recall memory
  set overall-average-recalled-data-land-use-1 average values-from house-holds [recalled-data-land-use-1]
  set overall-average-recalled-data-land-use-2 average values-from house-holds [recalled-data-land-use-2]
  set overall-average-recalled-data-land-use-3 average values-from house-holds [recalled-data-land-use-3]
  
  ;;labor allocation
  set overall-average-labor-land-use-1 average values-from fields with [land-use-type = 1] [land-labor / land-size]
  set overall-average-labor-land-use-2 average values-from fields with [land-use-type = 2] [land-labor / land-size]
  set overall-average-labor-land-use-3 average values-from fields with [land-use-type = 3] [land-labor / land-size]
  
  ;;adoption
  
  ;;adopters
  set adopters-land-use-1-only count house-holds with [own-land-use-1? = 1 and own-land-use-2? = 0 and own-land-use-3? = 0] 
  set adopters-land-use-2-only count house-holds with [own-land-use-1? = 0 and own-land-use-2? = 1 and own-land-use-3? = 0] 
  set adopters-land-use-3-only count house-holds with [own-land-use-1? = 0 and own-land-use-2? = 0 and own-land-use-3? = 1] 
  set adopters-land-use-1-&-2 count house-holds with [own-land-use-1? = 1 and own-land-use-2? = 1 and own-land-use-3? = 0] 
  set adopters-land-use-1-&-3 count house-holds with [own-land-use-1? = 1 and own-land-use-2? = 0 and own-land-use-3? = 1] 
  set adopters-land-use-2-&-3 count house-holds with [own-land-use-1? = 0 and own-land-use-2? = 1 and own-land-use-3? = 1] 
  set adopters-land-use-1-2-&-3 count house-holds with [own-land-use-1? = 1 and own-land-use-2? = 1 and own-land-use-3? = 1] 
  
  ;;total area
  set total-area-land-use-1 sum values-from fields with [land-use-type = 1] [land-size]
  set total-area-land-use-2 sum values-from fields with [land-use-type = 2] [land-size]
  set total-area-land-use-3 sum values-from fields with [land-use-type = 3] [land-size]
  
  ;;farm size
  set overall-average-field-size-land-use-1 average values-from fields with [land-use-type = 1] [land-size]
  set overall-average-field-size-land-use-2 average values-from fields with [land-use-type = 2] [land-size]
  set overall-average-field-size-land-use-3 average values-from fields with [land-use-type = 3] [land-size]
  
  ;;economy
    
  ;;profit
  set overall-average-profit-land-use-1 average values-from fields with [land-use-type = 1] [land-profit]
  set overall-average-profit-land-use-2 average values-from fields with [land-use-type = 2] [land-profit]
  set overall-average-profit-land-use-3 average values-from fields with [land-use-type = 3] [land-profit]
end

;;make plots
to plot-outputs
  set-current-plot "General Knowledge"
  set-current-plot-pen "System 1"
  plotxy simulation-time overall-average-knowledge-land-use-1
  set-current-plot-pen "System 2"
  plotxy simulation-time overall-average-knowledge-land-use-2
  set-current-plot-pen "System 3"
  plotxy simulation-time overall-average-knowledge-land-use-3
  
  set-current-plot "Land Area"
  set-current-plot-pen "System 1"
  plotxy simulation-time total-area-land-use-1
  set-current-plot-pen "System 2"
  plotxy simulation-time total-area-land-use-2
  set-current-plot-pen "System 3"
  plotxy simulation-time total-area-land-use-3
  
  set-current-plot "Plot Knowledge"
  set-current-plot-pen "System 1"
  plotxy simulation-time overall-average-plot-knowledge-land-use-1
  set-current-plot-pen "System 2"
  plotxy simulation-time overall-average-plot-knowledge-land-use-2
  set-current-plot-pen "System 3"
  plotxy simulation-time overall-average-plot-knowledge-land-use-3
  
  set-current-plot "Labor"
  set-current-plot-pen "System 1"
  plotxy simulation-time overall-average-labor-land-use-1
  set-current-plot-pen "System 2"
  plotxy simulation-time overall-average-labor-land-use-2
  set-current-plot-pen "System 3"
  plotxy simulation-time overall-average-labor-land-use-3  
end

;; Adopt&Learn Model
;; Model Authors: Meine van Noordwijk & Desi Ariyadhi Suyamto
;; Model Developer: Desi Ariyadhi Suyamto
;;
;; Latest update: August 18, 2006
;;
;; Developmental stage status: concept review, programming review
;; 
;; This model is a NetLogo version of adoption and learning (Adopt&Learn Model), 
;; authored by Meine van Noordwijk and Desi Ariyadhi Suyamto, 
;; ICRAF Southeast Asia. Initially, it was developed as a system dynamics model using STELLA at a community scale.  
;; Recently, it is migrated to NetLogo due to some needs to capture individual interactions among farmers. 
;;
;; The conceptual framework of the model is inspired by:
;;
;; [1] Ball, P. 2004.  Critical Mass: How One Thing Leads to Another.  
;;
;; [2] Rogers, E.M. 2003. Diffusion of Innovations, Fifth Edition.
;;
;; [3] van Noordwijk, M. (2002).  Scaling trade-offs between crop productivity, 
;; carbon stocks and biodiversity in shifting cultivation landscape mosaics: the FALLOW model. 
;; Ecological Modelling 149 (2002)1 13-126.
;;
;; [4] Wilensky, U. (2005). NetLogo Preferential Attachment model. 
;; http://ccl.northwestern.edu/netlogo/models/PreferentialAttachment. 
;; Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.
;;
;; [5] Wilensky, U. (2006). NetLogo Ethnocentrism model.  
;; http://ccl.northwestern.edu/netlogo/ models/Ethnocentrism.  
;; Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.
;;
;; The model borrows some codes and ideas from NetLogo Library: 
;; Preferential Attachment - Loterry Example
;;
;; The development of Adopt&Learn Model is part of research activity funded by Common Fund for Commodities 
;; (CFC)-Improving the Productivity of Rubber Smallholdings through Rubber Agroforestry Systems (CFC/IRSG/11) Project.
;;
;; Thank you to Uri Wilensky and the team by providing us with this powerful tool.  
;; Also thanks to Luis E. Garcia Barrios (lgarcia@sclc.ecosur.mx) from Alternativos-ECOSUR Mexico 
;; who introduced NetLogo to us on May 26, 2006.
;;
;; Corresponding author for the Adopt&Learn Model: Desi Ariyadhi Suyamto. 
;; World Agroforestry Centre, ICRAF Southeast Asia Regional Office, Email: DSuyamto@cgiar.org. 
;; Tel: +62 251 625415 ext 791. Fax: +62 251 625416. http://www.worldagroforestrycentre.org/sea or 
;; http://www.icraf.cgiar.org/sea. A  Future Harvest centre supported by the CGIAR.
@#$#@#$#@
GRAPHICS-WINDOW
4
10
301
328
20
20
7.0
1
10
1
1
1
0
1
1
1
-20
20
-20
20

CC-WINDOW
5
514
957
609
Command Center
0

BUTTON
79
339
142
372
NIL
setup
NIL
1
T
OBSERVER
T
NIL

BUTTON
146
339
209
372
NIL
go
T
1
T
OBSERVER
T
NIL

SWITCH
13
425
135
458
show-network?
show-network?
1
1
-1000

BUTTON
175
424
280
457
NIL
layout-network
T
1
T
OBSERVER
T
NIL

PLOT
648
10
947
237
General Knowledge
time
profit.man-1.day-1.area unit-1
0.0
10.0
0.0
10.0
true
true
PENS
"System 1" 1.0 0 -2674135 true
"System 2" 1.0 0 -10899396 true
"System 3" 1.0 0 -13345367 true

PLOT
649
253
948
480
Land Area
time
area unit
0.0
10.0
0.0
10.0
true
true
PENS
"System 1" 1.0 0 -2674135 true
"System 2" 1.0 0 -10899396 true
"System 3" 1.0 0 -13345367 true

PLOT
329
10
627
238
Plot Knowledge
time
profit.man-1.day-1.area unit-1
0.0
10.0
0.0
10.0
true
true
PENS
"System 1" 1.0 0 -2674135 true
"System 2" 1.0 0 -10899396 true
"System 3" 1.0 0 -13345367 true

PLOT
328
253
625
481
Labor
time
man.day.area unit-1
0.0
10.0
0.0
1.0
true
true
PENS
"System 1" 1.0 0 -2674135 true
"System 2" 1.0 0 -10899396 true
"System 3" 1.0 0 -13345367 true

SLIDER
55
381
244
414
simulation-duration
simulation-duration
1
500
100
1
1
years

SLIDER
63
467
235
500
zoom
zoom
1
10
4
1
1
NIL

@#$#@#$#@
WHAT IS IT?
-----------
This is a simple model about landscape transformation by farmers. The model simulates on how farmers decide to practice particular land use system on their plots, given that they have 3 choices available. The basic premise of the model is that farmers adopt certain land use system based on their knowledge about profitability of the system and their ability to generate capitals for establishment.

Farmers knowledge about profitability of each land use system is shaped either by their individual experiences or information received from others. Information from others is received either by means of knowledge exchange among farmers or observing the performance of others plots directly.

Farmers exchange their knowledge via diffusion networks.  Depending on farmers preferences in selecting partners, the network can be heterophilous, homophilous, centralized or decentralized. The network is homophilous if majority of farmers exchange their knowledge with partners of the same ethnic group or with relatively close neighbors. The network is centralized if majority of farmers attach to one opinion leader.  Through these networks, farmers share or seek information. Based on ethnic similarity, relative distance and relative popularity of sources, partners credibility is judged by farmers. Farmers observe others plots within certain radius from their plots. Inaccuracy in observing performance of others plots is determined by visibility of information about performance of the system.  

All collected information from individual experience, sharing, seeking and direct observation from others plots are stored in farmers memory.  Farmers recall the data from their memory as the reference to update their knowledge. It depends on their memory-recall ability. At memory-recall ability equals 0, farmers use the most current collected information for the reference.  The rate of adjustment depends on farmers progressiveness in trusting the reference. At progressiveness close to 0, farmers trust the reference at relatively very slow rate. Farmers knowledge is also enhanced by their exposures in extensions. Effectiveness of extensions in influencing farmers knowledge depends on farmers perception about credibility of the extension agents. Overall knowledge updating process in this model is called learning.

In connection with decision-making process, the model splits farmers knowledge into plot knowledge and general knowledge.  Basically, plot knowledge is product of farmers book keeping about performance of existing land use systems currently practiced on their plots. It is pure knowledge of farmers from their plots without any influences from others.  When the plots are renewed, the plot knowledge is reset into 0. General knowledge is farmers knowledge about all options of land use systems, which are available in the landscape. This type of knowledge is fusion of knowledge from their individual experiences and knowledge from others, including knowledge from extension and knowledge from interaction.  General knowledge is more permanent than plot knowledge, in sense that physically, it is maintained in farmers memory.  Although farmers do not practice a land use system anymore, it does not imply that they have no general knowledge on that system.

Solely, general knowledge is used as the basis to make strategic decision. It is a decision to select the best land use system when farmers need to renew their plots. Together with plot knowledge, general knowledge is used as the basis to make tactical decision.  It is a decision to allocate labors to existing plots for harvesting.  Both strategic and tactical decisions are determined by prioritization degree of farmers. At prioritization degree equals 1, farmers consider or allocate labors proportionally according to relative profitability of each land use system.  At prioritization degree more than 1, farmers consider or allocate labors to the most profitable land use system and ignoring the less rewarding options. At prioritization degree close to 0, farmers consider or allocate labors to each land use system uniformly.  It illustrates a situation where farmers are facing dilemma, have no ideas about what to do with available options.

In the model, farmers are decision makers.  They are the heads of household.  They are landlords of their farms.  They have power to generate and to mobilise labor capital.  They have power to generate financial capital and use it for renewing old plots. A farmer can occupy more than one parcel of farms.  A farmer can adopt more than one land use system on their plots.  A farmer can have more than one worker.  Other than knowledge, labor and financial capitals, adoption of certain land use system is limited by convertibility of a land.  In this model, convertibility of farmers plots is defined by age threshold.  Farmers can renew their plots after the existing plots are not productive at all.  

This model is developed as learning and/or research tool to explore barriers on adoption of a land use system that we want to promote.  The barrier can be caused by unfavourable conditions found in information diffusion network, in farmers personal aptitudes (their mental properties), in extension strategy, in biophysical/economical performance of the land use system or due to lack of capitals.  Thus, using this model, we can explore possible drivers that can help us in boosting the adoption process of better land use system option.  It can be used to explore favourable condition where critical mass in adoption process can be achieved.

HOW IT WORKS
------------
1.	Scales of the model. In term of interaction captured by this model: decision-making is made at household level; spatial dynamics is at plot level; and temporal dynamics is yearly. In term of emergent behavior as results of individual interactions in this model: decision-making should be observed at community level, spatial dynamics should be observed at micro rural landscape; and temporal dynamics should be observed at longer time frame.

2.	Number of farmers is generated based on user-defined input.  They are composed from 3 ethnic groups, which fractions are user-defined input.  In their neighborhood, farmers can be agglomerated based on ethnic group.

3.	Diffusion network is formed according to attractiveness of partners, which is defined by equation:

(1+100*w1*p)/(1+100*w2*e+100*w3*d)

	p is partners relative popularity (0<=p<=1)
	e is ethnic similarity of partners (0=different, 1=similar)
	d is relative distance of partners (0<=d<=1)
	w1, w2, and w3 are weighting factor given by farmers to popularity, ethnic similarity, and distance of partners respectively (0<=w<=1)

Links among farmers in this network are randomized based on attractiveness values using random lottery algorithm borrowed from NetLogo.  For initialisation, popular persons (or opinion leaders) are assigned by fraction.  In the dynamic part, popularity is later judged by number of current attachments linked to farmers relative to maximum attachments found in the whole community.  When w1=1, w2=0, w3=0, the network is centralized to opinion leader. When w1=0, w2=1, w3=0, the network is ethnical homophilous. When w1=0, w2=0, w3=1, the network is homophilous based on neighborhood.  When the neighborhood is agglomerated based on ethnic group [No. 2], the last setting forms ethnical homophilous network. 

4.	Each farmer may have more than 1 parcel of farms at various sizes.  Position of the farms can be agglomerated based on landowner. 

5.	Initial patterns of the landscape are generated based on user-defined input.  

6.	Number of farmers, number of plots, landholder of each plot and size of plots are static over the whole simulation. No population dynamics of farmers, no land exchange among farmers, no land expansion and no modification to plot size. 

7.	Three choices of land use systems are provided.  All land use systems are assumed as tree-based systems.  Productivity of each land use system is determined by age.  To simplify, each land use system is stratified into 4 production stages: pioneer (stage 1), early production (stage 2), late production (stage 3) and post-production (stage 4).  Age of each plot is always updated during simulation and reset into 0 when farmers renew their plots.  Production stage of each plot is defined by time bound to reach each stage, based on user-defined look up.  Productivity of each plot is randomized based on given statistic of each land use type at each production stage.  Productivity should be expressed in attainable yield unit [yield-unit.person-1.day-1.area unit-1].  External factors affecting plots productivity (e.g. bad weather, pest and disease) are not yet included.  But, seasonal variability of yields is covered by coefficient of variance in user-defined statistic of productivity.  Causal relation between land use system and site quality are not yet considered.

8.	Farmers exchange their knowledge with partners through diffusion network.  Willingness of farmers to share or to seek information from their partners is driven by probability.  At prisoner dilemma game situation, probability of sharing and probability of seeking equal 0.5. Credibility of information from others is defined by similar equation in No 3:

(1+w1*p)/(1+w2*e+w3*d)

	p is partners relative popularity (0<=p<=1)
	e is ethnic similarity of partners (0=different, 1=similar)
	d is relative distance of partners (0<=d<=1)
	w1, w2, and w3 are weighting factor given by farmers to popularity, ethnic similarity and distance of partners respectively. 

9.	Farmers observe others plots within specified radius.  It depends on relative distance of farmers observation range from their plots.  Visibility of performance of each land use system determines information accuracy from observation.  

10.	Average of information collected from individual experience, sharing, seeking and direct observation from others plots are stored in farmers memory.  Farmers recall the data from their memory as the reference to update their knowledge. It depends on their memory-recall ability.  Moving average code borrowed from NetLogo is used in this procedure.

11.	Plot knowledge is knowledge of farmers about performance of particular land use system currently practiced on their plots. When a plot is converted into other types, plot knowledge is reset into 0. When land use system is sustained on given plot, plot knowledge is updated using this equation:

Kp[i,j,t+dt] = Kp[i,,t] + a*[Ip[i,j,t]-Kp[i,j,t]]

	Kp[i,j,t+dt] is knowledge about land use system i currently practiced on plot j at time t + dt
	Kp[i,j,t] is knowledge about land use system i currently practiced on plot j at time t
	Ip[i,j,t] is the reference data recalled from farmers memory about profitability of land use system i currently practiced on plot j at time t
	a is progressiveness of farmers in trusting the reference data.  At rational adjustment, 0<=a<=1.
	Since this model only simulates 3 land use systems, thus i = 1,2,3.
	Knowledge and reference data are expressed in profitability unit [profit.person-1.day-1.area unit-1].

12.	General knowledge, expressing knowledge of each farmer about performance of all land use systems available in the landscape, is updated using this equation:

Kg[i,t+dt] = Kg[i,t] + a*[Ig[i,t]-Kg[i,t]] + c*[E[i,t]-Kg[i,t]]

	Kg[i,t+dt] is general knowledge about land use system i at time t + dt
	Kg[i,t] is general knowledge about land use system i at time t
	Ig[i,t] is the reference data recalled from farmers memory about profitability of land use system i at time t. In this case, Ig[i,t] is compiled from farmers individual experience and other information from sharing, seeking and from direct observation to others plots
	E[i,t] is knowledge about performance of land use system i at time t delivered by extension agents
	a is progressiveness of farmers in trusting the reference data
	c is credibility of extension agents as perceived by farmers
	Knowledge, reference data and information delivered by extension agents are expressed in profitability unit [profit.person-1.day-1.unit area-1].

13.	Based on general knowledge and plot knowledge, farmers make tactical decision to allocate labors for harvesting.  Labors [persons.days] are dynamically generated.  Thus, labors capital may vary from one farmer to other farmers, from one year to the next years.  Labor is allocated using following steps.

Firstly, based on general knowledge, farmers make macro labor allocation, allocating labor into each option of land use system, using this equation:

fLM[i,t] = ((o?[i]*(Kg[i,t]^p))) / ((o?[1]*(Kg[i,t]^p)) +  (o?[2]*(Kg[i,t]^p)) + (o?[3]*(Kg[i,t]^p)))

	fLM[i,t] is labor fraction allocated for land use system i at time t
	Kg[i,t] is general knowledge about land use system i at time t
	o?[i] is whether farmers currently adopt land use system i on their plots (0=no,1=yes)
	p is prioritization degree in allocation. 

In the case when farmers have no general idea about all systems or when Kg[1,t] = Kg[2,t] = Kg[3,t] = 0, farmers allocate their labors according to existing systems they are practicing currently. Thus:

fLM[i,t] = o?[i] / (o?[1] + o?[2] + o?[3])

Secondly, based on plot knowledge, farmers make micro labor allocation, allocating labor spatially into each plot, using similar equation: 

fLm[i,j,t] = Kp[i,j,t] ^p /( Kp[i,1,t] ^p + ... + Kp[i,n,t] ^p)

	fLm[i,j,t] is labor fraction allocated for land use system i on plot j at time t
	Kp[i,j,t] is plot knowledge about land use system i on plot j at time t

In the case when (Kp[i,1,t] ^p + ... + Kp[i,n,t] ^p) equals 0, farmers allocate their labors uniformly, depending on plot number (n) where land use system i is adopted. Finally, number of labors allocated to harvest land use system i on plot j at time t is fLM[i,t] * fLm[i,j,t]*LT[t].  LT is total labor capital available at time t.

14.	Harvested yield is calculated from each plot using equation:


L[j,t]*S[j]*P[j,t]

	L[j,t] is harvesting labor allocated for plot j
	S[j] is size of plot j (area unit)
	P[j,t] is productivity of plot j at time t.  P[j,t] is generated based on productivity statistic, depending on production stage of the plot and land use system type of the plot.  P[j,t] is expressed in yield unit [yield-unit.area unit-1.person-1.day-1].

15.	Profitability of each parcel of farms is calculated using equation:

(Y[i,j,t]*$1[i,t] - L[i,j,t]*$2[t] - $3[i,j,t]* S[i,j]) / (L[i,j,t]* S[i,j])

	Y[i,j,t] is harvested yield from plot j at time t, where land use system i is adopted
	$1[i,t] is price of commodity from land use system i at time t
	L[i,j,t] is harvesting labor allocated on plot j at time t, where land use system i is adopted
	$2[t]  is labor wage at time t
	$3[i,j,t] is non-harvesting-labor costs for maintaining plot at time t, where land use system i is adopted
	S[i,j] is size of plot j, where land use system i is adopted
	L[i,j,t] is number of harvesting labors work on plot j at time t, where land use system i is adopted
	Profitability is expressed in profitability unit [profit.person-1.day-1.unit area-1].

16.	Based on general knowledge, farmers make strategic decision to adopt certain land use system to renew their plots.  Equation to calculate attractiveness of each land use system to be adopted is similar to equation to calculate macro labor allocation [No. 13]:

fS[i,t] = ((c?[i]*(Kg[i,t]^p))) / ((c?[1]*(Kg[i,t]^p)) +  (c?[2]*(Kg[i,t]^p)) + (c?[3]*(Kg[i,t]^p)))

	fS[i,t] is fraction of consideration given for land use system i at time t
	Kg[i,t] is general knowledge about land use system i at time t
	c?[i] is whether farmers are currently able to generate capital to adopt land use system i on their plots (0=no,1=yes)
	p is prioritization degree in allocation

In the case when farmers have no general idea about all systems or Kg[1,t] = Kg[2,t] = Kg[3,t] = 0, farmers consider each system according to capital availability. Thus:

fS[i,t] = c?[i] / (c?[1] + c?[2] + c?[3])

This equation implies that at given time when farmers need to renew their old plots but they have no knowledge about any systems or when they have no ideas in selecting the best choice (when p = 0), farmers may adopt particular system when the capital to establish that system is available.  Using this equation, the model can explain some cases where adoption of particular system at early stage works through incentives disbursement to establish that system as such, without any efforts related to knowledge diffusion.  For example, project approaches that promote particular land use system usually start the promotion by disbursing subsidies to farmers.

17.	Suppose that a farmer, in order to renew their plots, consider each system uniformly, thus the fractions are 1/3 each.  A pot of numbers representing the system id according to consideration fraction given by the farmer is made.  The pot contains 100 times number of plots to be renewed.  Suppose that a farmer need and able to renew 2 plots. Thus, in this case, we will have a pot of numbers containing: 66 seeds with values equal 1, 66 seeds with values equal 2 and 66 seeds with values equal 3.  This pot is shuffled, and a number is picked up randomly from the pot to define which type of land use system that the farmer finally adopts on given plot.

18.	At last, dynamics of each plot is updated.  Ages of renewed plots are reset to 0, and their land use type is adjusted to the new one.  Ages of sustaining plots are increased by 1.

HOW TO USE IT
-------------
SETUP button: sets up the model by initialising farmers and their plots.  Input parameters of the model are read from external file (tab delimited text file).  You will be asked to find the file name of input parameters.  Excel file (_Adopt&Learn.XLS) is provided to ease you in parameterizing the model.   SaveAs the Excel file as tab delimited text file after modification. We also provide 3 examples of input files. After simulation, some outputs are maintained in different external file (tab delimited text file).  Thus, you will be asked to give the file name for outputs.  You can use one output file for several runs.

GO button -- runs the model.

SIMULATION-DURATION slider -- lets you determine the simulation duration.

ZOOM slider -- lets you scale the size of plots or farmers for visualization.

SHOW-NETWORK? switch -- ON switches the view into diffusion network of farmers. OFF switches the view into plot dynamics.

LAYOUT-NETWORK button -- attempts to move farmers around to make the structure of the network easier to see. Use the button before or after the simulation. This procedure is borrowed from preferential attachment model by NetLogo. 

PLOT KNOWLEDGE plot -- .shows overall average of plot knowledge of farmers about each land use system.

GENERAL KNOWLEDGE plot --. shows overall average of general knowledge of farmers about each land use system.

LABOR plot --. shows overall average of allocated labors on each land use system.

LAND AREA plot --. shows total area of each land use system

THINGS TO NOTICE
----------------
During the simulation run, you can switch the view from patch dynamics into communication network dynamics.  When you switch to communication network dynamics, youll see how farmers are interacting each other.  Grey links illustrates no interaction.  White links illustrates farmers are only sharing to their neighborhood. Yellow links illustrates farmers are only seeking from their neighborhood.  Pink links illustrates farmers are exchanging knowledge with their neighborhood, both through sharing and seeking in one go.  Size of farmers represents relative communication partners that they have.  Bigger the farmers, more partners they have. Color of farmers illustrates their ethnic groups. Red is ethnic group 1, green is ethnic group 2, and blue is ethnic group 3.  If you simulate many farmers, you may find difficult to see the network clearly.  Use layout-network button to ease the visualisation.  But, during the simulation, the layout is always reset into farmers original location for computation purpose.  Thus, its better to layout the network before or after the simulation run.

When you switch to patch dynamics, you will see visualization of farmers plots.  Random irregular shapes of each plot illustrate that this model consider spatial representation of plots as objects, not as raster.  In this regard, size of the plots represents the relative size and the color represents their land use types.  Red is land use system 1, green is land use system 2 and blue is land use system 3.

The purpose of this model is to observe emergent behavior at larger scale than individual interaction captured in the model.  Thus, attributes of each individual in the simulation should not be parameterized at precise individual level. Instead, we use average of larger scale by still respecting individual variability. This model lets some parameters of each individual changing over time, with respects to uncertainty. For instance, prioritization degree or learning progressiveness of each individual may not be the same from time to time.  In fact, there is no evidence that human being are having constant mental properties over time.   Just look at us.  We may find ourselves that one day we were fast learners, having high prioritization degree, but on another day we totally behaved contrastingly.  Shortly, those properties are in fact uncertain.  Therefore, let them being uncertain.


THINGS TO TRY
----------------
1.	To test the model performance, we provide some input data files (input*.txt).  Parameters values of those files are developed based on made up scenarios. You can see the content of the files using any text file editors, preferably using MS Excel.  All input parameters of the model are listed in the next section (INPUT PARAMETERS).  If you want to make your own input data file, simply use Adopt&Learn.xls provided.  After modifying the values, simply SaveAs the file into tab delimited text file (*.txt).

2.	To get to know the models behaviour at the first time, simply use input data file input00.txt.  Imagine that there are 10 farmers living on a neighborhood, composed by 3 ethnic groups uniformly. Suppose that initially, the landscape is only dominated by land use system 1 and all farmers are only able to generate capital to establish land use system 1 (with constant probability = 0.5).  Let all farmers only learn from their own plots. Let them never exchange their knowledge each other, neither through sharing, seeking, direct observation nor extension.  Now, just let other parameters random.  Run the model using this setting several times, and notice the main results from 4 provided plots.  You should see static pattern of the landscape.  This example explains that without any interaction with each other and without any capabilities to generate capital to establish other options than land use system 1, farmers only learn about existing land use system from their own plots.

3.	Now, use input data file input01.txt. In this scenario, we allow farmers to have capability to generate capital to establish land use system 2 and 3 (with constant probability = 0.5). Imagine that a project is coming in to the village, promoting those two new systems by giving subsidies. Other parameters are maintained the same as the previous scenario.  Run the model using this setting several times, and again, notice the main results from 4 provided plots.  You should find some farmers experimenting land use system 2 or 3.  But, land use system 1 still predominates the landscape.  It seems hard for land use system 2 or 3 to totally replace land use system 1. This example explains that without manipulating farmers knowledge, adoption of new systems by early adopters can work through incentive, especially when farmers have prioritization degree less close to 0, a situation when farmers face a dilemma in decision-making.

4.	Next, use input data file input02.txt.  In this scenario, we open the communication network, so that farmers can share, seek and observe each other.  But, we do not bring extension agents into the world.  We use prisoner dilemma game in this communication network by setting the probabilities to seek, share and observe into 0.5.  You should find that its easier for land use system 2 and 3 to achieve their critical mass, although they are still competing with land use system 1 at their tipping points.

5.	Finally, your mission is to promote land use system 2 into the landscape.  Simply use the MS Excel file Adopt&Learn.xls to make your strategy.  After modification, just SaveAs the file under different file name using tab delimited text file format.

INPUT PARAMETERS
-------------

You should construct input parameters in a tab delimited text file to run the model using defined format.  Simply use Adopt&Learn.xls file to parameterize the model. The file should have following input parameters:  

HUMAN capital	
house-holds-number	[households]
fraction-ethnic-1	[]
fraction-ethnic-2	[]
fraction-ethnic-3	[]
initial-fraction-popular-person	[]
ethnic-agglomeration	[0-1,very dispersed to very agglomerated]
	
LAND capital	
mean-fields-number	[fields.household-1]
cv-fields-number	[]
land-holder-agglomeration	[0-1,very dispersed to very agglomerated]
	
LABOR capital	
mean-labor-capital	[men]
cv-labor-capital	[]
min-labor-capital	[men]
	
INITIAL knowledge	
mean-initial-knowledge-land-use-1	[profit.person-1.day-1.area unit-1]
cv-initial-knowledge-land-use-1	[]
mean-initial-knowledge-land-use-2	[profit.person-1.day-1.area unit-1]
cv-initial-knowledge-land-use-2	[]
mean-initial-knowledge-land-use-3	[profit.person-1.day-1.area unit-1]
cv-initial-knowledge-land-use-3	[]
	
DIFFUSION network	
mean-weight-ethnical-distance	[0-1,not concerned to highly concerned]
cv-weight-ethnical-distance	[]
mean-weight-physical-distance	[0-1,not concerned to highly concerned]
cv-weight-physical-distance	[]
mean-weight-popularity-person	[0-1,not concerned to highly concerned]
cv-weight-popularity-person	[]
	
SHARING with	
mean-p-sharing	[]
cv-p-sharing	[]
min-p-sharing	[]
	
SEEKING from	
mean-p-seeking	[]
cv-p-seeking	[]
min-p-seeking	[]
	
OBSERVE from	
mean-p-observing	[]
cv-p-observing	[]
min-p-observing	[]
mean-observation-relative-distance	[0-1,very close to very far]
cv-observation-relative-distance	[]
min-observation-relative-distance	[0-1,very close to very far]
	
EXPOSE in extension	
extension-frequency-land-use-1	[0-1,relative frequency]
extension-frequency-land-use-2	[0-1,relative frequency]
extension-frequency-land-use-3	[0-1,relative frequency]
mean-p-exposing-in-extension-land-use-1	[]
cv-p-exposing-in-extension-land-use-1	[]
min-p-exposing-in-extension-land-use-1	[]
mean-p-exposing-in-extension-land-use-2	[]
cv-p-exposing-in-extension-land-use-2	[]
min-p-exposing-in-extension-land-use-2	[]
mean-p-exposing-in-extension-land-use-3	[]
cv-p-exposing-in-extension-land-use-3	[]
min-p-exposing-in-extension-land-use-3	[]
mean-suggestion-extension-land-use-1	[profit.person-1.day-1.area unit-1]
cv-suggestion-extension-land-use-1	[]
min-suggestion-extension-land-use-1	[profit.person-1.day-1.area unit-1]
mean-suggestion-extension-land-use-2	[profit.person-1.day-1.area unit-1]
cv-suggestion-extension-land-use-2	[]
min-suggestion-extension-land-use-2	[profit.person-1.day-1.area unit-1]
mean-suggestion-extension-land-use-3	[profit.person-1.day-1.area unit-1]
cv-suggestion-extension-land-use-3	[]
min-suggestion-extension-land-use-3	[profit.person-1.day-1.area unit-1]
mean-credibility-extension-land-use-1	[0-1,not credible to very credible]
cv-credibility-extension-land-use-1	[]
mean-credibility-extension-land-use-2	[0-1,not credible to very credible]
cv-credibility-extension-land-use-2	[]
mean-credibility-extension-land-use-3	[0-1,not credible to very credible]
cv-credibility-extension-land-use-3	[]
	
LEARNING properties	
mean-learning-progressiveness	[]
cv-learning-progressiveness	[]
min-learning-progressiveness	[]
max-learning-progressiveness	[]
mean-memory-recall-ability	[years]
cv-memory-recall-ability	[]
min-memory-recall-ability	[years]
max-memory-recall-ability	[years]
	
DECISION making	
mean-prioritisation	[]
cv-prioritisation	[]
min-prioritisation	[]
max-prioritisation	[]
mean-p-generate-capital-to-establish-land-use-1	[]
cv-p-generate-capital-to-establish-land-use-1	[]
min-p-generate-capital-to-establish-land-use-1	[]
mean-p-generate-capital-to-establish-land-use-2	[]
cv-p-generate-capital-to-establish-land-use-2	[]
min-p-generate-capital-to-establish-land-use-2	[]
mean-p-generate-capital-to-establish-land-use-3	[]
cv-p-generate-capital-to-establish-land-use-3	[]
min-p-generate-capital-to-establish-land-use-3	[]
	
INITIAL land use patterns	
initial-fraction-land-use-1	[]
initial-fraction-land-use-2	[]
initial-fraction-land-use-3	[]
mean-initial-age-land-use-1	[years]
cv-initial-age-land-use-1	[]
mean-initial-age-land-use-2	[years]
cv-initial-age-land-use-2	[]
mean-initial-age-land-use-3	[years]
cv-initial-age-land-use-3	[]
	
FIELD size	
mean-land-holding-size	[area unit]
cv-land-holding-size	[]
min-land-holding-size	[area unit]
	
FIELD productivity	
time-bound-stage-1-land-use-1	[years]
time-bound-stage-2-land-use-1	[years]
time-bound-stage-3-land-use-1	[years]
time-bound-stage-4-land-use-1	[years]
time-bound-stage-1-land-use-2	[years]
time-bound-stage-2-land-use-2	[years]
time-bound-stage-3-land-use-2	[years]
time-bound-stage-4-land-use-2	[years]
time-bound-stage-1-land-use-3	[years]
time-bound-stage-2-land-use-3	[years]
time-bound-stage-3-land-use-3	[years]
time-bound-stage-4-land-use-3	[years]
mean-yield-stage-1-land-use-1	[yield unit.man-1.day-1.area unit-1]
cv-yield-stage-1-land-use-1	[]
mean-yield-stage-2-land-use-1	[yield unit.man-1.day-1.area unit-1]
cv-yield-stage-2-land-use-1	[]
mean-yield-stage-3-land-use-1	[yield unit.man-1.day-1.area unit-1]
cv-yield-stage-3-land-use-1	[]
mean-yield-stage-4-land-use-1	[yield unit.man-1.day-1.area unit-1]
cv-yield-stage-4-land-use-1	[]
mean-yield-stage-1-land-use-2	[yield unit.man-1.day-1.area unit-1]
cv-yield-stage-1-land-use-2	[]
mean-yield-stage-2-land-use-2	[yield unit.man-1.day-1.area unit-1]
cv-yield-stage-2-land-use-2	[]
mean-yield-stage-3-land-use-2	[yield unit.man-1.day-1.area unit-1]
cv-yield-stage-3-land-use-2	[]
mean-yield-stage-4-land-use-2	[yield unit.man-1.day-1.area unit-1]
cv-yield-stage-4-land-use-2	[]
mean-yield-stage-1-land-use-3	[yield unit.man-1.day-1.area unit-1]
cv-yield-stage-1-land-use-3	[]
mean-yield-stage-2-land-use-3	[yield unit.man-1.day-1.area unit-1]
cv-yield-stage-2-land-use-3	[]
mean-yield-stage-3-land-use-3	[yield unit.man-1.day-1.area unit-1]
cv-yield-stage-3-land-use-3	[]
mean-yield-stage-4-land-use-3	[yield unit.man-1.day-1.area unit-1]
cv-yield-stage-4-land-use-3	[]
minimum-convertible-age-land-use-1	[years]
minimum-convertible-age-land-use-2	[years]
minimum-convertible-age-land-use-3	[years]
	
VISIBILITY by others	
mean-land-use-system-visibility-1	[0-1,not visible to very visible]
cv-land-use-system-visibility-1	[]
min-land-use-system-visibility-1	[0-1,not visible to very visible]
mean-land-use-system-visibility-2	[0-1,not visible to very visible]
cv-land-use-system-visibility-2	[]
min-land-use-system-visibility-2	[0-1,not visible to very visible]
mean-land-use-system-visibility-3	[0-1,not visible to very visible]
cv-land-use-system-visibility-3	[]
min-land-use-system-visibility-3	[0-1,not visible to very visible]
	
COMMODITY price	
mean-price-commodity-land-use-1	[price.yield unit-1]
cv-price-commodity-land-use-1	[]
min-price-commodity-land-use-1	[price.yield unit-1]
mean-price-commodity-land-use-2	[price.yield unit-1]
cv-price-commodity-land-use-2	[]
min-price-commodity-land-use-2	[price.yield unit-1]
mean-price-commodity-land-use-3	[price.yield unit-1]
cv-price-commodity-land-use-3	[]
min-price-commodity-land-use-3	[price.yield unit-1]
	
NON harvesting labor costs	
mean-costs-stage-1-land-use-1	[cost.area unit-1]
cv-costs-stage-1-land-use-1	[]
mean-costs-stage-2-land-use-1	[cost.area unit-1]
cv-costs-stage-2-land-use-1	[]
mean-costs-stage-3-land-use-1	[cost.area unit-1]
cv-costs-stage-3-land-use-1	[]
mean-costs-stage-4-land-use-1	[cost.area unit-1]
cv-costs-stage-4-land-use-1	[]
mean-costs-stage-1-land-use-2	[cost.area unit-1]
cv-costs-stage-1-land-use-2	[]
mean-costs-stage-2-land-use-2	[cost.area unit-1]
cv-costs-stage-2-land-use-2	[]
mean-costs-stage-3-land-use-2	[cost.area unit-1]
cv-costs-stage-3-land-use-2	[]
mean-costs-stage-4-land-use-2	[cost.area unit-1]
cv-costs-stage-4-land-use-2	[]
mean-costs-stage-1-land-use-1	[cost.area unit-1]
cv-costs-stage-1-land-use-1	[]
mean-costs-stage-2-land-use-1	[cost.area unit-1]
cv-costs-stage-2-land-use-1	[]
mean-costs-stage-3-land-use-1	[cost.area unit-1]
cv-costs-stage-3-land-use-1	[]
mean-costs-stage-4-land-use-1	[cost.area unit-1]
cv-costs-stage-4-land-use-1	[]
mean-costs-stage-1-land-use-3	[cost.area unit-1]
cv-costs-stage-1-land-use-3	[]
mean-costs-stage-2-land-use-3	[cost.area unit-1]
cv-costs-stage-2-land-use-3	[]
mean-costs-stage-3-land-use-3	[cost.area unit-1]
cv-costs-stage-3-land-use-3	[]
mean-costs-stage-4-land-use-3	[cost.area unit-1]
cv-costs-stage-4-land-use-3	[]
	
WORKING days	
mean-working-days	[days]
cv-working-days	[]
min-working-days	[days]
	
LABOR wage	
mean-labor-wage	[wage.man-1.day-1]
cv-labor-wage	[]
min-labor-wage	[wage.man-1.day-1]

OUTPUT PARAMETERS
-------------

A tab delimited text file is constructed to store the main outputs from simulation.  The file should have following output parameters:


INFORMATION network
overall-average-popularity	[]
overall-average-ethnical-homophily	[]
overall-average-spatial-homophily	[]
  
DIFFUSION of information
sharing-by-adopter-land-use-1	[households]
sharing-by-adopter-land-use-2	[households]
sharing-by-adopter-land-use-3	[households]
seeking-by-adopter-land-use-1	[households]
seeking-by-adopter-land-use-2	[households]
seeking-by-adopter-land-use-3	[households]
observing-by-adopter-land-use-1	[households]
observing-by-adopter-land-use-2	[households]
observing-by-adopter-land-use-3	[households]
exposing-to-extension-land-use-1	[households]
exposing-to-extension-land-use-2	[households]
exposing-to-extension-land-use-3	[households]
  
LEARNING products
overall-average-recalled-data-land-use-1	[profit.person-1.day-1.area unit-1]
overall-average-recalled-data-land-use-2	[profit.person-1.day-1.area unit-1]
overall-average-recalled-data-land-use-3	[profit.person-1.day-1.area unit-1]
overall-average-collected-data-land-use-1	[profit.person-1.day-1.area unit-1]
overall-average-collected-data-land-use-2	[profit.person-1.day-1.area unit-1]
overall-average-collected-data-land-use-3	[profit.person-1.day-1.area unit-1]
  
KNOWLEDGE products
overall-average-knowledge-land-use-1	[profit.person-1.day-1.area unit-1]
overall-average-knowledge-land-use-2	[profit.person-1.day-1.area unit-1]
overall-average-knowledge-land-use-3	[profit.person-1.day-1.area unit-1]
overall-average-plot-knowledge-land-use-1	[profit.person-1.day-1.area unit-1]
overall-average-plot-knowledge-land-use-2	[profit.person-1.day-1.area unit-1]
overall-average-plot-knowledge-land-use-3	[profit.person-1.day-1.area unit-1]
  
LABOR allocation
overall-average-labor-land-use-1	[persons.days]
overall-average-labor-land-use-2	[persons.days]
overall-average-labor-land-use-3	[persons.days]
 
ADOPTION indicators
adopters-land-use-1-only	[households]
adopters-land-use-2-only	[households]
adopters-land-use-3-only	[households]
adopters-land-use-1-&-2	[households]
adopters-land-use-1-&-3	[households]
adopters-land-use-2-&-3	[households]
adopters-land-use-1-2-&-3  	[households]
overall-average-field-size-land-use-1	[area unit]
overall-average-field-size-land-use-2	[area unit]
overall-average-field-size-land-use-3	[area unit]
total-area-land-use-1	[area unit]
total-area-land-use-2	[area unit]
total-area-land-use-3	[area unit]
  
ECONOMICAL indicators  
overall-average-profit-land-use-1	[profit.person-1.day-1.area unit-1]
overall-average-profit-land-use-2	[profit.person-1.day-1.area unit-1]
overall-average-profit-land-use-3	[profit.person-1.day-1.area unit-1]


EXTENDING THE MODEL
-------------------
The model can be extended with regards to the scale of complexity that we want to explore.  We can add modules to consider site quality dynamics and link it to productivity, elaborate the economical modules by tracing the flow of revenue into financial capital and link it back to capital generating ability to adopt new systems, add some toolboxes to assess environmental consequences of emergent landscape patterns, and so on.  Although this model is developed using decision-making scale at household level, but the main purpose is to explore emergent behavior at larger scale, how the majority adopt certain land use system.

NETLOGO FEATURES
----------------
	This model uses breeds to represent farmers, their communication links and their plots.  The model runs slow at number of fields close to 100. 
	Although plots location and farmers neighborhood are fix attributes, but this model does not explicitly consider spatial attributes.  We do not want to know where exactly farmers are living and where exactly their plots are located.  We just want to know how farmers will interact each other, resulting emergent behavior at larger scale, given that they have general spatial characteristics. Thus, we treat the world in this model as wrapped world since we are not dealing with environment at precise boundaries. 

RELATED MODELS
--------------
The FALLOW Model (van Noordwijk, 2002), Preferential Attachment Model (Wilensky, 2005), Ethnocentrism (Wilensky, 2006).


CREDITS AND REFERENCES
----------------------
This model is a NetLogo version of adoption and learning (Adopt&Learn Model), authored by Meine van Noordwijk and Desi Ariyadhi Suyamto, ICRAF Southeast Asia. Initially, it was developed as a system dynamics model using STELLA at a community scale.  Recently, it is migrated to NetLogo due to some needs to capture individual interactions among farmers. The current conceptual framework of the model is inspired by:

	Ball, P. 2004.  Critical Mass: How One Thing Leads to Another.  
	Rogers, E.M. 2003. Diffusion of Innovations, Fifth Edition.
	van Noordwijk, M. (2002).  Scaling trade-offs between crop productivity, carbon stocks and biodiversity in shifting cultivation landscape mosaics: the FALLOW model. Ecological Modelling 149 (2002)1 13-126.
	Wilensky, U. (2005). NetLogo Preferential Attachment model. http://ccl.northwestern.edu/netlogo/models/PreferentialAttachment. Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.
	Wilensky, U. (2006). NetLogo Ethnocentrism model.  http://ccl.northwestern.edu/netlogo/ models/Ethnocentrism.  Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.

The development of Adopt&Learn Model is part of research activity funded by Common Fund for Commodities (CFC)-Improving the Productivity of Rubber Smallholdings through Rubber Agroforestry Systems (CFC/IRSG/11) Project.  The task of this modelling exercise is to explore the barriers of adoption process of rubber-based system promoted by World Agroforestry Center in some areas.

Thank you to Uri Wilensky and the team by facilitating us with this powerful tool.  Also thanks to Luis E. Garcia Barrios (lgarcia@sclc.ecosur.mx) from Alternativos-ECOSUR Mexico, who is the first person who share knowledge about NetLogo to us. It was on May 26, 2006 at the airport in West Sumatera, Indonesia.

Corresponding author for the Adopt&Learn Model: Desi Ariyadhi Suyamto. World Agroforestry Centre, ICRAF Southeast Asia Regional Office, Email: DSuyamto@cgiar.org. Tel: +62 251 625415 ext 791. Fax: +62 251 625416. http://www.worldagroforestrycentre.org/sea or http://www.icraf.cgiar.org/sea. A  Future Harvest centre supported by the CGIAR.
 
STATUS
----------------------
Concept review.  Latest update: August 18, 2006.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

link
true
0
Line -7500403 true 150 0 150 300

link direction
true
0
Line -7500403 true 150 150 30 225
Line -7500403 true 150 150 270 225

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

observe
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105
Circle -16777216 true false 116 11 67
Polygon -16777216 true false 120 105 135 90 165 90 180 105 180 135 165 150 150 165 150 180 135 195 135 165 165 135 165 105 135 105 120 120
Rectangle -16777216 true false 135 195 150 210

parcel1
true
0
Polygon -7500403 true true 0 135 15 120 15 90 45 75 60 45 90 15 120 15 135 0 240 30 240 45 195 60 195 75 195 90 210 105 225 105 240 120 270 135 285 165 300 180 270 210 240 210 225 195 195 195 180 210 165 240 165 270 135 300 90 285 75 240 90 225 90 180 60 180 30 195 15 210

parcel10
true
0
Polygon -7500403 true true 60 30 120 30 180 45 240 30 270 90 255 120 255 135 255 150 285 210 240 255 210 240 165 300 90 285 60 240 15 210 15 180 30 135 15 105 30 60

parcel2
true
0
Polygon -7500403 true true 90 15 120 15 120 30 150 30 165 45 195 45 210 60 240 75 255 75 285 90 300 135 285 165 285 210 255 225 240 240 240 270 180 285 165 270 150 270 90 285 45 255 60 240 75 210 105 210 120 180 135 180 105 135 75 150 45 135 15 150 0 120 30 90 60 90 60 60 75 45

parcel3
true
0
Polygon -7500403 true true 30 75 30 60 60 60 75 45 105 45 150 30 165 30 210 15 270 60 255 105 210 120 195 150 225 165 240 225 255 255 210 285 165 270 150 240 105 240 90 270 60 270 60 225 75 195 75 165 90 135 75 105

parcel4
true
0
Polygon -7500403 true true 45 45 75 30 120 30 135 30 150 30 150 60 180 60 195 75 210 105 210 120 240 120 240 165 255 180 270 195 285 210 255 240 225 225 210 240 180 240 150 240 120 240 120 255 60 270 75 195 105 180 105 150

parcel5
true
0
Polygon -7500403 true true 195 15 165 30 135 30 90 15 15 105 30 240 135 300 240 270 240 210 180 210 180 165 225 135 255 45

parcel6
true
0
Polygon -7500403 true true 120 0 300 150 270 180 270 240 165 300 165 270 135 255 120 180 45 255 0 165 30 120 90 105 120 0

parcel7
true
0
Polygon -7500403 true true 150 0 165 30 180 30 195 60 225 75 225 105 270 105 285 120 285 135 300 150 270 195 225 180 210 210 210 225 225 240 225 270 195 285 150 270 90 285 45 255 60 225 105 225 120 195 75 180 45 180 15 150 15 90 30 75 60 75 75 90 90 105 105 105 105 75 90 60 90 15

parcel8
true
0
Polygon -7500403 true true 105 0 90 30 90 60 75 90 75 120 15 210 45 255 75 255 90 270 135 255 150 270 165 285 195 285 240 270 240 225 225 180 255 165 255 120 240 105 225 90 225 60 240 30 210 15 165 15 150 30

parcel9
true
0
Polygon -7500403 true true 75 270 105 270 120 255 135 255 165 240 180 225 195 210 270 225 285 195 270 180 270 165 270 150 270 135 255 120 240 120 255 90 255 60 240 60 240 45 210 15 195 30 180 30 135 0 105 15 90 15 90 30 105 60 105 90 75 90 60 105 30 105 0 135 15 150 45 150 45 165 60 180 90 180 105 195 90 225 75 225 60 240 45 210 15 225

pentagon
true
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
true
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 3.1.3
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
